import 'dart:io';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:test/test.dart';
import 'package:yaml/yaml.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();

  group(retry: 3, 'Meta Writer', () {
    test('Write Meta', () async {
      final fileContent = await rootBundle.loadString(
        "pubspec.yaml",
      );
      final pubspec = loadYaml(fileContent);
      var version = pubspec['version'];

      String metaDartFileContents = """
/// DO NOT EDIT THIS FILE EXCEPT TO ENTER INITIAL VERSION AND OTHER META INFO 
/// THIS FILE IS AUTOMATICALLY OVER WRITTEN BY MetaUpdate 
Map<String, String> meta = <String, String>{
  "version":"$version",
};
  """;

      var metaDartFile = File('lib/src/store/memory/in_memory_meta.dart');
      await metaDartFile.writeAsString(metaDartFileContents, flush: true);
    });
  });
}
