// coverage:ignore-file

import 'languages.dart';

class Afrikaans implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "'n",
      "aan",
      "af",
      "al",
      "as",
      "baie",
      "by",
      "daar",
      "dag",
      "dat",
      "die",
      "dit",
      "een",
      "ek",
      "en",
      "gaan",
      "gesê",
      "haar",
      "het",
      "hom",
      "hulle",
      "hy",
      "in",
      "is",
      "jou",
      "jy",
      "kan",
      "kom",
      "ma",
      "maar",
      "met",
      "my",
      "na",
      "nie",
      "om",
      "ons",
      "op",
      "saam",
      "sal",
      "se",
      "sien",
      "so",
      "sy",
      "te",
      "toe",
      "uit",
      "van",
      "vir",
      "was",
      "wat",
      "ŉ"
    };
  }
}

class Arabic implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "،",
      "آض",
      "آمينَ",
      "آه",
      "آهاً",
      "آي",
      "أ",
      "أب",
      "أجل",
      "أجمع",
      "أخ",
      "أخذ",
      "أصبح",
      "أضحى",
      "أقبل",
      "أقل",
      "أكثر",
      "ألا",
      "أم",
      "أما",
      "أمامك",
      "أمامكَ",
      "أمسى",
      "أمّا",
      "أن",
      "أنا",
      "أنت",
      "أنتم",
      "أنتما",
      "أنتن",
      "أنتِ",
      "أنشأ",
      "أنّى",
      "أو",
      "أوشك",
      "أولئك",
      "أولئكم",
      "أولاء",
      "أولالك",
      "أوّهْ",
      "أي",
      "أيا",
      "أين",
      "أينما",
      "أيّ",
      "أَنَّ",
      "أََيُّ",
      "أُفٍّ",
      "إذ",
      "إذا",
      "إذاً",
      "إذما",
      "إذن",
      "إلى",
      "إليكم",
      "إليكما",
      "إليكنّ",
      "إليكَ",
      "إلَيْكَ",
      "إلّا",
      "إمّا",
      "إن",
      "إنّما",
      "إي",
      "إياك",
      "إياكم",
      "إياكما",
      "إياكن",
      "إيانا",
      "إياه",
      "إياها",
      "إياهم",
      "إياهما",
      "إياهن",
      "إياي",
      "إيهٍ",
      "إِنَّ",
      "ا",
      "ابتدأ",
      "اثر",
      "اجل",
      "احد",
      "اخرى",
      "اخلولق",
      "اذا",
      "اربعة",
      "ارتدّ",
      "استحال",
      "اطار",
      "اعادة",
      "اعلنت",
      "اف",
      "اكثر",
      "اكد",
      "الألاء",
      "الألى",
      "الا",
      "الاخيرة",
      "الان",
      "الاول",
      "الاولى",
      "التى",
      "التي",
      "الثاني",
      "الثانية",
      "الذاتي",
      "الذى",
      "الذي",
      "الذين",
      "السابق",
      "الف",
      "اللائي",
      "اللاتي",
      "اللتان",
      "اللتيا",
      "اللتين",
      "اللذان",
      "اللذين",
      "اللواتي",
      "الماضي",
      "المقبل",
      "الوقت",
      "الى",
      "اليوم",
      "اما",
      "امام",
      "امس",
      "ان",
      "انبرى",
      "انقلب",
      "انه",
      "انها",
      "او",
      "اول",
      "اي",
      "ايار",
      "ايام",
      "ايضا",
      "ب",
      "بات",
      "باسم",
      "بان",
      "بخٍ",
      "برس",
      "بسبب",
      "بسّ",
      "بشكل",
      "بضع",
      "بطآن",
      "بعد",
      "بعض",
      "بك",
      "بكم",
      "بكما",
      "بكن",
      "بل",
      "بلى",
      "بما",
      "بماذا",
      "بمن",
      "بن",
      "بنا",
      "به",
      "بها",
      "بي",
      "بيد",
      "بين",
      "بَسْ",
      "بَلْهَ",
      "بِئْسَ",
      "تانِ",
      "تانِك",
      "تبدّل",
      "تجاه",
      "تحوّل",
      "تلقاء",
      "تلك",
      "تلكم",
      "تلكما",
      "تم",
      "تينك",
      "تَيْنِ",
      "تِه",
      "تِي",
      "ثلاثة",
      "ثم",
      "ثمّ",
      "ثمّة",
      "ثُمَّ",
      "جعل",
      "جلل",
      "جميع",
      "جير",
      "حار",
      "حاشا",
      "حاليا",
      "حاي",
      "حتى",
      "حرى",
      "حسب",
      "حم",
      "حوالى",
      "حول",
      "حيث",
      "حيثما",
      "حين",
      "حيَّ",
      "حَبَّذَا",
      "حَتَّى",
      "حَذارِ",
      "خلا",
      "خلال",
      "دون",
      "دونك",
      "ذا",
      "ذات",
      "ذاك",
      "ذانك",
      "ذانِ",
      "ذلك",
      "ذلكم",
      "ذلكما",
      "ذلكن",
      "ذو",
      "ذوا",
      "ذواتا",
      "ذواتي",
      "ذيت",
      "ذينك",
      "ذَيْنِ",
      "ذِه",
      "ذِي",
      "راح",
      "رجع",
      "رويدك",
      "ريث",
      "رُبَّ",
      "زيارة",
      "سبحان",
      "سرعان",
      "سنة",
      "سنوات",
      "سوف",
      "سوى",
      "سَاءَ",
      "سَاءَمَا",
      "شبه",
      "شخصا",
      "شرع",
      "شَتَّانَ",
      "صار",
      "صباح",
      "صفر",
      "صهٍ",
      "صهْ",
      "ضد",
      "ضمن",
      "طاق",
      "طالما",
      "طفق",
      "طَق",
      "ظلّ",
      "عاد",
      "عام",
      "عاما",
      "عامة",
      "عدا",
      "عدة",
      "عدد",
      "عدم",
      "عسى",
      "عشر",
      "عشرة",
      "علق",
      "على",
      "عليك",
      "عليه",
      "عليها",
      "علًّ",
      "عن",
      "عند",
      "عندما",
      "عوض",
      "عين",
      "عَدَسْ",
      "عَمَّا",
      "غدا",
      "غير",
      "ـ",
      "ف",
      "فان",
      "فلان",
      "فو",
      "فى",
      "في",
      "فيم",
      "فيما",
      "فيه",
      "فيها",
      "قال",
      "قام",
      "قبل",
      "قد",
      "قطّ",
      "قلما",
      "قوة",
      "كأنّما",
      "كأين",
      "كأيّ",
      "كأيّن",
      "كاد",
      "كان",
      "كانت",
      "كذا",
      "كذلك",
      "كرب",
      "كل",
      "كلا",
      "كلاهما",
      "كلتا",
      "كلم",
      "كليكما",
      "كليهما",
      "كلّما",
      "كلَّا",
      "كم",
      "كما",
      "كي",
      "كيت",
      "كيف",
      "كيفما",
      "كَأَنَّ",
      "كِخ",
      "لئن",
      "لا",
      "لات",
      "لاسيما",
      "لدن",
      "لدى",
      "لعمر",
      "لقاء",
      "لك",
      "لكم",
      "لكما",
      "لكن",
      "لكنَّما",
      "لكي",
      "لكيلا",
      "للامم",
      "لم",
      "لما",
      "لمّا",
      "لن",
      "لنا",
      "له",
      "لها",
      "لو",
      "لوكالة",
      "لولا",
      "لوما",
      "لي",
      "لَسْتَ",
      "لَسْتُ",
      "لَسْتُم",
      "لَسْتُمَا",
      "لَسْتُنَّ",
      "لَسْتِ",
      "لَسْنَ",
      "لَعَلَّ",
      "لَكِنَّ",
      "لَيْتَ",
      "لَيْسَ",
      "لَيْسَا",
      "لَيْسَتَا",
      "لَيْسَتْ",
      "لَيْسُوا",
      "لَِسْنَا",
      "ما",
      "ماانفك",
      "مابرح",
      "مادام",
      "ماذا",
      "مازال",
      "مافتئ",
      "مايو",
      "متى",
      "مثل",
      "مذ",
      "مساء",
      "مع",
      "معاذ",
      "مقابل",
      "مكانكم",
      "مكانكما",
      "مكانكنّ",
      "مكانَك",
      "مليار",
      "مليون",
      "مما",
      "ممن",
      "من",
      "منذ",
      "منها",
      "مه",
      "مهما",
      "مَنْ",
      "مِن",
      "نحن",
      "نحو",
      "نعم",
      "نفس",
      "نفسه",
      "نهاية",
      "نَخْ",
      "نِعِمّا",
      "نِعْمَ",
      "ها",
      "هاؤم",
      "هاكَ",
      "هاهنا",
      "هبّ",
      "هذا",
      "هذه",
      "هكذا",
      "هل",
      "هلمَّ",
      "هلّا",
      "هم",
      "هما",
      "هن",
      "هنا",
      "هناك",
      "هنالك",
      "هو",
      "هي",
      "هيا",
      "هيت",
      "هيّا",
      "هَؤلاء",
      "هَاتانِ",
      "هَاتَيْنِ",
      "هَاتِه",
      "هَاتِي",
      "هَجْ",
      "هَذا",
      "هَذانِ",
      "هَذَيْنِ",
      "هَذِه",
      "هَذِي",
      "هَيْهَاتَ",
      "و",
      "و6",
      "وا",
      "واحد",
      "واضاف",
      "واضافت",
      "واكد",
      "وان",
      "واهاً",
      "واوضح",
      "وراءَك",
      "وفي",
      "وقال",
      "وقالت",
      "وقد",
      "وقف",
      "وكان",
      "وكانت",
      "ولا",
      "ولم",
      "ومن",
      "وهو",
      "وهي",
      "ويكأنّ",
      "وَيْ",
      "وُشْكَانََ",
      "يكون",
      "يمكن",
      "يوم",
      "ّأيّان"
    };
  }
}

class Armenian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "այդ",
      "այլ",
      "այն",
      "այս",
      "դու",
      "դուք",
      "եմ",
      "են",
      "ենք",
      "ես",
      "եք",
      "է",
      "էի",
      "էին",
      "էինք",
      "էիր",
      "էիք",
      "էր",
      "ըստ",
      "թ",
      "ի",
      "ին",
      "իսկ",
      "իր",
      "կամ",
      "համար",
      "հետ",
      "հետո",
      "մենք",
      "մեջ",
      "մի",
      "ն",
      "նա",
      "նաև",
      "նրա",
      "նրանք",
      "որ",
      "որը",
      "որոնք",
      "որպես",
      "ու",
      "ում",
      "պիտի",
      "վրա",
      "և"
    };
  }
}

class Basque implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "al",
      "anitz",
      "arabera",
      "asko",
      "baina",
      "bat",
      "batean",
      "batek",
      "bati",
      "batzuei",
      "batzuek",
      "batzuetan",
      "batzuk",
      "bera",
      "beraiek",
      "berau",
      "berauek",
      "bere",
      "berori",
      "beroriek",
      "beste",
      "bezala",
      "da",
      "dago",
      "dira",
      "ditu",
      "du",
      "dute",
      "edo",
      "egin",
      "ere",
      "eta",
      "eurak",
      "ez",
      "gainera",
      "gu",
      "gutxi",
      "guzti",
      "haiei",
      "haiek",
      "haietan",
      "hainbeste",
      "hala",
      "han",
      "handik",
      "hango",
      "hara",
      "hari",
      "hark",
      "hartan",
      "hau",
      "hauei",
      "hauek",
      "hauetan",
      "hemen",
      "hemendik",
      "hemengo",
      "hi",
      "hona",
      "honek",
      "honela",
      "honetan",
      "honi",
      "hor",
      "hori",
      "horiei",
      "horiek",
      "horietan",
      "horko",
      "horra",
      "horrek",
      "horrela",
      "horretan",
      "horri",
      "hortik",
      "hura",
      "izan",
      "ni",
      "noiz",
      "nola",
      "non",
      "nondik",
      "nongo",
      "nor",
      "nora",
      "ze",
      "zein",
      "zen",
      "zenbait",
      "zenbat",
      "zer",
      "zergatik",
      "ziren",
      "zituen",
      "zu",
      "zuek",
      "zuen",
      "zuten"
    };
  }
}

class Bengali implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "অতএব",
      "অথচ",
      "অথবা",
      "অনুযায়ী",
      "অনেক",
      "অনেকে",
      "অনেকেই",
      "অন্তত",
      "অন্য",
      "অবধি",
      "অবশ্য",
      "অর্থাত",
      "আই",
      "আগামী",
      "আগে",
      "আগেই",
      "আছে",
      "আজ",
      "আদ্যভাগে",
      "আপনার",
      "আপনি",
      "আবার",
      "আমরা",
      "আমাকে",
      "আমাদের",
      "আমার",
      "আমি",
      "আর",
      "আরও",
      "ই",
      "ইত্যাদি",
      "ইহা",
      "উচিত",
      "উত্তর",
      "উনি",
      "উপর",
      "উপরে",
      "এ",
      "এঁদের",
      "এঁরা",
      "এই",
      "একই",
      "একটি",
      "একবার",
      "একে",
      "এক্",
      "এখন",
      "এখনও",
      "এখানে",
      "এখানেই",
      "এটা",
      "এটাই",
      "এটি",
      "এত",
      "এতটাই",
      "এতে",
      "এদের",
      "এব",
      "এবং",
      "এবার",
      "এমন",
      "এমনকী",
      "এমনি",
      "এর",
      "এরা",
      "এল",
      "এস",
      "এসে",
      "ঐ",
      "ও",
      "ওঁদের",
      "ওঁর",
      "ওঁরা",
      "ওই",
      "ওকে",
      "ওখানে",
      "ওদের",
      "ওর",
      "ওরা",
      "কখনও",
      "কত",
      "কবে",
      "কমনে",
      "কয়েক",
      "কয়েকটি",
      "করছে",
      "করছেন",
      "করতে",
      "করবে",
      "করবেন",
      "করলে",
      "করলেন",
      "করা",
      "করাই",
      "করায়",
      "করার",
      "করি",
      "করিতে",
      "করিয়া",
      "করিয়ে",
      "করে",
      "করেই",
      "করেছিলেন",
      "করেছে",
      "করেছেন",
      "করেন",
      "কাউকে",
      "কাছ",
      "কাছে",
      "কাজ",
      "কাজে",
      "কারও",
      "কারণ",
      "কি",
      "কিংবা",
      "কিছু",
      "কিছুই",
      "কিন্তু",
      "কী",
      "কে",
      "কেউ",
      "কেউই",
      "কেখা",
      "কেন",
      "কোটি",
      "কোন",
      "কোনও",
      "কোনো",
      "ক্ষেত্রে",
      "কয়েক",
      "খুব",
      "গিয়ে",
      "গিয়েছে",
      "গিয়ে",
      "গুলি",
      "গেছে",
      "গেল",
      "গেলে",
      "গোটা",
      "চলে",
      "চান",
      "চায়",
      "চার",
      "চালু",
      "চেয়ে",
      "চেষ্টা",
      "ছাড়া",
      "ছাড়াও",
      "ছিল",
      "ছিলেন",
      "জন",
      "জনকে",
      "জনের",
      "জন্য",
      "জন্যওজে",
      "জানতে",
      "জানা",
      "জানানো",
      "জানায়",
      "জানিয়ে",
      "জানিয়েছে",
      "জে",
      "জ্নজন",
      "টি",
      "ঠিক",
      "তখন",
      "তত",
      "তথা",
      "তবু",
      "তবে",
      "তা",
      "তাঁকে",
      "তাঁদের",
      "তাঁর",
      "তাঁরা",
      "তাঁাহারা",
      "তাই",
      "তাও",
      "তাকে",
      "তাতে",
      "তাদের",
      "তার",
      "তারপর",
      "তারা",
      "তারৈ",
      "তাহলে",
      "তাহা",
      "তাহাতে",
      "তাহার",
      "তিনঐ",
      "তিনি",
      "তিনিও",
      "তুমি",
      "তুলে",
      "তেমন",
      "তো",
      "তোমার",
      "থাকবে",
      "থাকবেন",
      "থাকা",
      "থাকায়",
      "থাকে",
      "থাকেন",
      "থেকে",
      "থেকেই",
      "থেকেও",
      "দিকে",
      "দিতে",
      "দিন",
      "দিয়ে",
      "দিয়েছে",
      "দিয়েছেন",
      "দিলেন",
      "দু",
      "দুই",
      "দুটি",
      "দুটো",
      "দেওয়া",
      "দেওয়ার",
      "দেওয়া",
      "দেখতে",
      "দেখা",
      "দেখে",
      "দেন",
      "দেয়",
      "দ্বারা",
      "ধরা",
      "ধরে",
      "ধামার",
      "নতুন",
      "নয়",
      "না",
      "নাই",
      "নাকি",
      "নাগাদ",
      "নানা",
      "নিজে",
      "নিজেই",
      "নিজেদের",
      "নিজের",
      "নিতে",
      "নিয়ে",
      "নিয়ে",
      "নেই",
      "নেওয়া",
      "নেওয়ার",
      "নেওয়া",
      "নয়",
      "পক্ষে",
      "পর",
      "পরে",
      "পরেই",
      "পরেও",
      "পর্যন্ত",
      "পাওয়া",
      "পাচ",
      "পারি",
      "পারে",
      "পারেন",
      "পি",
      "পেয়ে",
      "পেয়্র্",
      "প্রতি",
      "প্রথম",
      "প্রভৃতি",
      "প্রযন্ত",
      "প্রাথমিক",
      "প্রায়",
      "প্রায়",
      "ফলে",
      "ফিরে",
      "ফের",
      "বক্তব্য",
      "বদলে",
      "বন",
      "বরং",
      "বলতে",
      "বলল",
      "বললেন",
      "বলা",
      "বলে",
      "বলেছেন",
      "বলেন",
      "বসে",
      "বহু",
      "বা",
      "বাদে",
      "বার",
      "বি",
      "বিনা",
      "বিভিন্ন",
      "বিশেষ",
      "বিষয়টি",
      "বেশ",
      "বেশি",
      "ব্যবহার",
      "ব্যাপারে",
      "ভাবে",
      "ভাবেই",
      "মতো",
      "মতোই",
      "মধ্যভাগে",
      "মধ্যে",
      "মধ্যেই",
      "মধ্যেও",
      "মনে",
      "মাত্র",
      "মাধ্যমে",
      "মোট",
      "মোটেই",
      "যখন",
      "যত",
      "যতটা",
      "যথেষ্ট",
      "যদি",
      "যদিও",
      "যা",
      "যাঁর",
      "যাঁরা",
      "যাওয়া",
      "যাওয়ার",
      "যাওয়া",
      "যাকে",
      "যাচ্ছে",
      "যাতে",
      "যাদের",
      "যান",
      "যাবে",
      "যায়",
      "যার",
      "যারা",
      "যিনি",
      "যে",
      "যেখানে",
      "যেতে",
      "যেন",
      "যেমন",
      "র",
      "রকম",
      "রয়েছে",
      "রাখা",
      "রেখে",
      "লক্ষ",
      "শুধু",
      "শুরু",
      "সঙ্গে",
      "সঙ্গেও",
      "সব",
      "সবার",
      "সমস্ত",
      "সম্প্রতি",
      "সহ",
      "সহিত",
      "সাধারণ",
      "সামনে",
      "সি",
      "সুতরাং",
      "সে",
      "সেই",
      "সেখান",
      "সেখানে",
      "সেটা",
      "সেটাই",
      "সেটাও",
      "সেটি",
      "স্পষ্ট",
      "স্বয়ং",
      "হইতে",
      "হইবে",
      "হইয়া",
      "হওয়া",
      "হওয়ায়",
      "হওয়ার",
      "হচ্ছে",
      "হত",
      "হতে",
      "হতেই",
      "হন",
      "হবে",
      "হবেন",
      "হয়",
      "হয়তো",
      "হয়নি",
      "হয়ে",
      "হয়েই",
      "হয়েছিল",
      "হয়েছে",
      "হয়েছেন",
      "হল",
      "হলে",
      "হলেই",
      "হলেও",
      "হলো",
      "হাজার",
      "হিসাবে",
      "হৈলে",
      "হোক",
      "হয়"
    };
  }
}

class BrazilianPortuguese implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "ainda",
      "alem",
      "ambas",
      "ambos",
      "antes",
      "ao",
      "aonde",
      "aos",
      "apos",
      "aquele",
      "aqueles",
      "as",
      "assim",
      "com",
      "como",
      "contra",
      "contudo",
      "cuja",
      "cujas",
      "cujo",
      "cujos",
      "da",
      "das",
      "de",
      "dela",
      "dele",
      "deles",
      "demais",
      "depois",
      "desde",
      "desta",
      "deste",
      "dispoe",
      "dispoem",
      "diversa",
      "diversas",
      "diversos",
      "do",
      "dos",
      "durante",
      "e",
      "ela",
      "elas",
      "ele",
      "eles",
      "em",
      "entao",
      "entre",
      "essa",
      "essas",
      "esse",
      "esses",
      "esta",
      "estas",
      "este",
      "estes",
      "ha",
      "isso",
      "isto",
      "logo",
      "mais",
      "mas",
      "mediante",
      "menos",
      "mesma",
      "mesmas",
      "mesmo",
      "mesmos",
      "na",
      "nao",
      "nas",
      "nem",
      "nesse",
      "neste",
      "nos",
      "o",
      "os",
      "ou",
      "outra",
      "outras",
      "outro",
      "outros",
      "pelas",
      "pelo",
      "pelos",
      "perante",
      "pois",
      "por",
      "porque",
      "portanto",
      "propios",
      "proprio",
      "quais",
      "qual",
      "qualquer",
      "quando",
      "quanto",
      "que",
      "quem",
      "quer",
      "se",
      "seja",
      "sem",
      "sendo",
      "seu",
      "seus",
      "sob",
      "sobre",
      "sua",
      "suas",
      "tal",
      "tambem",
      "teu",
      "teus",
      "toda",
      "todas",
      "todo",
      "todos",
      "tua",
      "tuas",
      "tudo",
      "um",
      "uma",
      "umas",
      "uns"
    };
  }
}

class Breton implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "'blam",
      "'d",
      "'m",
      "'r",
      "'ta",
      "'vat",
      "'z",
      "'zo",
      "a",
      "a:",
      "aba",
      "abalamour",
      "abaoe",
      "ac'hane",
      "ac'hanoc'h",
      "ac'hanomp",
      "ac'hanon",
      "ac'hanout",
      "adal",
      "adalek",
      "adarre",
      "ae",
      "aec'h",
      "aed",
      "aemp",
      "aen",
      "aent",
      "aes",
      "afe",
      "afec'h",
      "afed",
      "afemp",
      "afen",
      "afent",
      "afes",
      "ag",
      "ah",
      "aimp",
      "aint",
      "aio",
      "aiou",
      "aje",
      "ajec'h",
      "ajed",
      "ajemp",
      "ajen",
      "ajent",
      "ajes",
      "al",
      "alato",
      "alies",
      "aliesañ",
      "alkent",
      "all",
      "allas",
      "allo",
      "allô",
      "am",
      "amañ",
      "amzer",
      "an",
      "anezhañ",
      "anezhe",
      "anezhi",
      "anezho",
      "anvet",
      "aon",
      "aotren",
      "ar",
      "arall",
      "araok",
      "araoki",
      "araozañ",
      "araozo",
      "araozoc'h",
      "araozomp",
      "araozon",
      "araozor",
      "araozout",
      "arbenn",
      "arre",
      "atalek",
      "atav",
      "az",
      "azalek",
      "azirazañ",
      "azirazi",
      "azirazo",
      "azirazoc'h",
      "azirazomp",
      "azirazon",
      "azirazor",
      "azirazout",
      "b:",
      "ba",
      "ba'l",
      "ba'n",
      "ba'r",
      "bad",
      "bah",
      "bal",
      "ban",
      "bar",
      "bastañ",
      "befe",
      "bell",
      "benaos",
      "benn",
      "bennag",
      "bennak",
      "bennozh",
      "bep",
      "bepred",
      "berr",
      "berzh",
      "bet",
      "betek",
      "betra",
      "bev",
      "bevet",
      "bez",
      "bezañ",
      "beze",
      "bezent",
      "bezet",
      "bezh",
      "bezit",
      "bezomp",
      "bihan",
      "bije",
      "biou",
      "biskoazh",
      "blam",
      "bo",
      "boa",
      "bominapl",
      "boudoudom",
      "bouez",
      "boull",
      "boum",
      "bout",
      "bras",
      "brasañ",
      "brav",
      "bravo",
      "bremañ",
      "bres",
      "brokenn",
      "bronn",
      "brrr",
      "brutal",
      "buhezek",
      "c'h:",
      "c'haout",
      "c'he",
      "c'hem",
      "c'herz",
      "c'heñver",
      "c'hichen",
      "c'hiz",
      "c'hoazh",
      "c'horre",
      "c'houde",
      "c'houst",
      "c'hreiz",
      "c'hwec'h",
      "c'hwec'hvet",
      "c'hwezek",
      "c'hwi",
      "ch:",
      "chaous",
      "chik",
      "chit",
      "chom",
      "chut",
      "d'",
      "d'al",
      "d'an",
      "d'ar",
      "d'az",
      "d'e",
      "d'he",
      "d'ho",
      "d'hol",
      "d'hon",
      "d'hor",
      "d'o",
      "d'ober",
      "d'ul",
      "d'un",
      "d'ur",
      "d:",
      "da",
      "dak",
      "daka",
      "dal",
      "dalbezh",
      "dalc'hmat",
      "dalit",
      "damdost",
      "damheñvel",
      "damm",
      "dan",
      "danvez",
      "dao",
      "daol",
      "daonet",
      "daou",
      "daoust",
      "daouzek",
      "daouzekvet",
      "darn",
      "dastrewiñ",
      "dav",
      "davedoc'h",
      "davedomp",
      "davedon",
      "davedor",
      "davedout",
      "davet",
      "davetañ",
      "davete",
      "daveti",
      "daveto",
      "defe",
      "dehou",
      "dek",
      "dekvet",
      "den",
      "deoc'h",
      "deomp",
      "deor",
      "derc'hel",
      "deus",
      "dez",
      "deze",
      "dezhañ",
      "dezhe",
      "dezhi",
      "dezho",
      "di",
      "diabarzh",
      "diagent",
      "diar",
      "diaraok",
      "diavaez",
      "dibaoe",
      "dibaot",
      "dibar",
      "dic'halañ",
      "didiac'h",
      "dienn",
      "difer",
      "diganeoc'h",
      "diganeomp",
      "diganeor",
      "diganimp",
      "diganin",
      "diganit",
      "digant",
      "digantañ",
      "digante",
      "diganti",
      "diganto",
      "digemmesk",
      "diget",
      "digor",
      "digoret",
      "dija",
      "dije",
      "dimp",
      "din",
      "dinaou",
      "dindan",
      "dindanañ",
      "dindani",
      "dindano",
      "dindanoc'h",
      "dindanomp",
      "dindanon",
      "dindanor",
      "dindanout",
      "dioutañ",
      "dioute",
      "diouti",
      "diouto",
      "diouzh",
      "diouzhin",
      "diouzhit",
      "diouzhoc'h",
      "diouzhomp",
      "diouzhor",
      "dirak",
      "dirazañ",
      "dirazi",
      "dirazo",
      "dirazoc'h",
      "dirazomp",
      "dirazon",
      "dirazor",
      "dirazout",
      "disheñvel",
      "dispar",
      "distank",
      "dister",
      "disterañ",
      "disterig",
      "distro",
      "dit",
      "divaez",
      "diwar",
      "diwezhat",
      "diwezhañ",
      "do",
      "doa",
      "doare",
      "dont",
      "dost",
      "doue",
      "douetus",
      "douez",
      "doug",
      "draou",
      "draoñ",
      "dre",
      "drede",
      "dreist",
      "dreistañ",
      "dreisti",
      "dreisto",
      "dreistoc'h",
      "dreistomp",
      "dreiston",
      "dreistor",
      "dreistout",
      "drek",
      "dreñv",
      "dring",
      "dro",
      "du",
      "e",
      "e:",
      "eas",
      "ebet",
      "ec'h",
      "edo",
      "edoc'h",
      "edod",
      "edomp",
      "edon",
      "edont",
      "edos",
      "eer",
      "eeun",
      "efed",
      "egedoc'h",
      "egedomp",
      "egedon",
      "egedor",
      "egedout",
      "eget",
      "egetañ",
      "egete",
      "egeti",
      "egeto",
      "eh",
      "eil",
      "eilvet",
      "eizh",
      "eizhvet",
      "ejoc'h",
      "ejod",
      "ejomp",
      "ejont",
      "ejout",
      "el",
      "em",
      "emaint",
      "emaoc'h",
      "emaomp",
      "emaon",
      "emaout",
      "emañ",
      "eme",
      "emeur",
      "emezañ",
      "emezi",
      "emezo",
      "emezoc'h",
      "emezomp",
      "emezon",
      "emezout",
      "emporzhiañ",
      "en",
      "end",
      "endan",
      "endra",
      "enep",
      "ennañ",
      "enni",
      "enno",
      "ennoc'h",
      "ennomp",
      "ennon",
      "ennor",
      "ennout",
      "enta",
      "eo",
      "eomp",
      "eont",
      "eor",
      "eot",
      "er",
      "erbet",
      "erfin",
      "esa",
      "esae",
      "espar",
      "estlamm",
      "estrañj",
      "eta",
      "etre",
      "etreoc'h",
      "etrezo",
      "etrezoc'h",
      "etrezomp",
      "etrezor",
      "euh",
      "eur",
      "eus",
      "evel",
      "evelato",
      "eveldoc'h",
      "eveldomp",
      "eveldon",
      "eveldor",
      "eveldout",
      "evelkent",
      "eveltañ",
      "evelte",
      "evelti",
      "evelto",
      "evidoc'h",
      "evidomp",
      "evidon",
      "evidor",
      "evidout",
      "evit",
      "evitañ",
      "evite",
      "eviti",
      "evito",
      "ez",
      "eñ",
      "f:",
      "fac'h",
      "fall",
      "fed",
      "feiz",
      "fenn",
      "fezh",
      "fin",
      "finsalvet",
      "foei",
      "fouilhezañ",
      "g:",
      "gallout",
      "ganeoc'h",
      "ganeomp",
      "ganin",
      "ganit",
      "gant",
      "gantañ",
      "ganti",
      "ganto",
      "gaout",
      "gast",
      "gein",
      "gellout",
      "genndost",
      "gentañ",
      "ger",
      "gerz",
      "get",
      "geñver",
      "gichen",
      "gin",
      "giz",
      "glan",
      "gloev",
      "goll",
      "gorre",
      "goude",
      "gouez",
      "gouezit",
      "gouezomp",
      "goulz",
      "gounnar",
      "gour",
      "goust",
      "gouze",
      "gouzout",
      "gra",
      "grak",
      "grec'h",
      "greiz",
      "grenn",
      "greomp",
      "grit",
      "groñs",
      "gutez",
      "gwall",
      "gwashoc'h",
      "gwazh",
      "gwech",
      "gwechall",
      "gwechoù",
      "gwell",
      "gwezh",
      "gwezhall",
      "gwezharall",
      "gwezhoù",
      "gwig",
      "gwirionez",
      "gwitibunan",
      "gêr",
      "h:",
      "ha",
      "hag",
      "han",
      "hanter",
      "hanterc'hantad",
      "hanterkantved",
      "harz",
      "hañ",
      "hañval",
      "he",
      "hebioù",
      "hec'h",
      "hei",
      "hein",
      "hem",
      "hemañ",
      "hen",
      "hend",
      "henhont",
      "henn",
      "hennezh",
      "hent",
      "hep",
      "hervez",
      "hervezañ",
      "hervezi",
      "hervezo",
      "hervezoc'h",
      "hervezomp",
      "hervezon",
      "hervezor",
      "hervezout",
      "heul",
      "heuliañ",
      "hevelep",
      "heverk",
      "heñvel",
      "heñvelat",
      "heñvelañ",
      "heñveliñ",
      "heñveloc'h",
      "heñvelout",
      "hi",
      "hilh",
      "hini",
      "hirie",
      "hirio",
      "hiziv",
      "hiziviken",
      "ho",
      "hoaliñ",
      "hoc'h",
      "hogen",
      "hogos",
      "hogozik",
      "hol",
      "holl",
      "holà",
      "homañ",
      "hon",
      "honhont",
      "honnezh",
      "hont",
      "hop",
      "hopala",
      "hor",
      "hou",
      "houp",
      "hudu",
      "hue",
      "hui",
      "hum",
      "hurrah",
      "i",
      "i:",
      "in",
      "int",
      "is",
      "ispisial",
      "isurzhiet",
      "it",
      "ivez",
      "izelañ",
      "j:",
      "just",
      "k:",
      "kae",
      "kaer",
      "kalon",
      "kalz",
      "kant",
      "kaout",
      "kar",
      "kazi",
      "keid",
      "kein",
      "keit",
      "kel",
      "kellies",
      "keloù",
      "kement",
      "ken",
      "kenkent",
      "kenkoulz",
      "kenment",
      "kent",
      "kentañ",
      "kentizh",
      "kentoc'h",
      "kentre",
      "ker",
      "kerkent",
      "kerz",
      "kerzh",
      "ket",
      "keta",
      "keñver",
      "keñverel",
      "keñverius",
      "kichen",
      "kichenik",
      "kit",
      "kiz",
      "klak",
      "klek",
      "klik",
      "komprenet",
      "komz",
      "kont",
      "korf",
      "korre",
      "koulskoude",
      "koulz",
      "koust",
      "krak",
      "krampouezh",
      "krec'h",
      "kreiz",
      "kuit",
      "kwir",
      "l:",
      "la",
      "laez",
      "laoskel",
      "laouen",
      "lavar",
      "lavaret",
      "lavarout",
      "lec'h",
      "lein",
      "leizh",
      "lerc'h",
      "leun",
      "leuskel",
      "lew",
      "lies",
      "liesañ",
      "lod",
      "lusk",
      "lâr",
      "lârout",
      "m:",
      "ma",
      "ma'z",
      "mac'h",
      "mac'hat",
      "mac'hañ",
      "mac'hoc'h",
      "mad",
      "maez",
      "maksimal",
      "mann",
      "mar",
      "mard",
      "marg",
      "marzh",
      "mat",
      "mañ",
      "me",
      "memes",
      "memestra",
      "merkapl",
      "mersi",
      "mes",
      "mesk",
      "met",
      "meur",
      "mil",
      "minimal",
      "moan",
      "moaniaat",
      "mod",
      "mont",
      "mout",
      "mui",
      "muiañ",
      "muioc'h",
      "n",
      "n'",
      "n:",
      "na",
      "nag",
      "naontek",
      "naturel",
      "nav",
      "navet",
      "ne",
      "nebeudig",
      "nebeut",
      "nebeutañ",
      "nebeutoc'h",
      "neketa",
      "nemedoc'h",
      "nemedomp",
      "nemedon",
      "nemedor",
      "nemedout",
      "nemet",
      "nemetañ",
      "nemete",
      "nemeti",
      "nemeto",
      "nemeur",
      "neoac'h",
      "nepell",
      "nerzh",
      "nes",
      "neseser",
      "netra",
      "neubeudoù",
      "neuhe",
      "neuze",
      "nevez",
      "newazh",
      "nez",
      "ni",
      "nikun",
      "niverus",
      "nul",
      "o",
      "o:",
      "oa",
      "oac'h",
      "oad",
      "oamp",
      "oan",
      "oant",
      "oar",
      "oas",
      "ober",
      "oc'h",
      "oc'ho",
      "oc'hola",
      "oc'hpenn",
      "oh",
      "ohe",
      "ollé",
      "olole",
      "olé",
      "omp",
      "on",
      "ordin",
      "ordinal",
      "ouejoc'h",
      "ouejod",
      "ouejomp",
      "ouejont",
      "ouejout",
      "ouek",
      "ouezas",
      "ouezi",
      "ouezimp",
      "ouezin",
      "ouezint",
      "ouezis",
      "ouezo",
      "ouezoc'h",
      "ouezor",
      "ouf",
      "oufe",
      "oufec'h",
      "oufed",
      "oufemp",
      "oufen",
      "oufent",
      "oufes",
      "ouie",
      "ouiec'h",
      "ouied",
      "ouiemp",
      "ouien",
      "ouient",
      "ouies",
      "ouije",
      "ouijec'h",
      "ouijed",
      "ouijemp",
      "ouijen",
      "ouijent",
      "ouijes",
      "out",
      "outañ",
      "outi",
      "outo",
      "ouzer",
      "ouzh",
      "ouzhin",
      "ouzhit",
      "ouzhoc'h",
      "ouzhomp",
      "ouzhor",
      "ouzhpenn",
      "ouzhpennik",
      "ouzoc'h",
      "ouzomp",
      "ouzon",
      "ouzont",
      "ouzout",
      "p'",
      "p:",
      "pa",
      "pad",
      "padal",
      "paf",
      "pan",
      "panevedeoc'h",
      "panevedo",
      "panevedomp",
      "panevedon",
      "panevedout",
      "panevet",
      "panevetañ",
      "paneveti",
      "pas",
      "paseet",
      "pe",
      "peadra",
      "peder",
      "pedervet",
      "pedervetvet",
      "pefe",
      "pegeit",
      "pegement",
      "pegen",
      "pegiz",
      "pegoulz",
      "pehini",
      "pelec'h",
      "pell",
      "pemod",
      "pemp",
      "pempved",
      "pemzek",
      "penaos",
      "penn",
      "peogwir",
      "peotramant",
      "pep",
      "perak",
      "perc'hennañ",
      "pergen",
      "permetiñ",
      "peseurt",
      "pet",
      "petiaoul",
      "petoare",
      "petra",
      "peur",
      "peurgetket",
      "peurheñvel",
      "peurliesañ",
      "peurvuiañ",
      "peus",
      "peustost",
      "peuz",
      "pevar",
      "pevare",
      "pevarevet",
      "pevarzek",
      "pez",
      "peze",
      "pezh",
      "pff",
      "pfft",
      "pfut",
      "picher",
      "pif",
      "pife",
      "pign",
      "pije",
      "pikol",
      "pitiaoul",
      "piv",
      "plaouf",
      "plok",
      "plouf",
      "po",
      "poa",
      "poelladus",
      "pof",
      "pok",
      "posupl",
      "pouah",
      "pourc'henn",
      "prest",
      "prestik",
      "prim",
      "prin",
      "provostapl",
      "pst",
      "pu",
      "pur",
      "r:",
      "ra",
      "rae",
      "raec'h",
      "raed",
      "raemp",
      "raen",
      "raent",
      "raes",
      "rafe",
      "rafec'h",
      "rafed",
      "rafemp",
      "rafen",
      "rafent",
      "rafes",
      "rag",
      "raimp",
      "raint",
      "raio",
      "raje",
      "rajec'h",
      "rajed",
      "rajemp",
      "rajen",
      "rajent",
      "rajes",
      "rak",
      "ral",
      "ran",
      "rankout",
      "raok",
      "razh",
      "re",
      "reas",
      "reer",
      "regennoù",
      "reiñ",
      "rejoc'h",
      "rejod",
      "rejomp",
      "rejont",
      "rejout",
      "rener",
      "rentañ",
      "reoc'h",
      "reomp",
      "reont",
      "reor",
      "reot",
      "resis",
      "ret",
      "reve",
      "rez",
      "ri",
      "rik",
      "rin",
      "ris",
      "rit",
      "rouez",
      "s:",
      "sac'h",
      "sant",
      "sav",
      "sañset",
      "se",
      "sed",
      "seitek",
      "seizh",
      "seizhvet",
      "sell",
      "sellit",
      "ser",
      "setu",
      "seul",
      "seurt",
      "siwazh",
      "skignañ",
      "skoaz",
      "skouer",
      "sort",
      "souden",
      "souvitañ",
      "soñj",
      "speriañ",
      "spririñ",
      "stad",
      "stlabezañ",
      "stop",
      "stranañ",
      "strewiñ",
      "strishaat",
      "stumm",
      "sujed",
      "surtoud",
      "t:",
      "ta",
      "taer",
      "tailh",
      "tak",
      "tal",
      "talvoudegezh",
      "tamm",
      "tanav",
      "taol",
      "te",
      "techet",
      "teir",
      "teirvet",
      "telt",
      "teltenn",
      "teus",
      "teut",
      "teuteu",
      "ti",
      "tik",
      "toa",
      "tok",
      "tost",
      "tostig",
      "toud",
      "touesk",
      "touez",
      "toull",
      "tra",
      "trantenn",
      "traoñ",
      "trawalc'h",
      "tre",
      "trede",
      "tregont",
      "tremenet",
      "tri",
      "trivet",
      "triwec'h",
      "trizek",
      "tro",
      "trugarez",
      "trumm",
      "tsoin",
      "tsouin",
      "tu",
      "tud",
      "u:",
      "ugent",
      "uhel",
      "uhelañ",
      "ul",
      "un",
      "unan",
      "unanez",
      "unanig",
      "unnek",
      "unnekvet",
      "ur",
      "urzh",
      "us",
      "v:",
      "va",
      "vale",
      "van",
      "vare",
      "vat",
      "vefe",
      "vefec'h",
      "vefed",
      "vefemp",
      "vefen",
      "vefent",
      "vefes",
      "vesk",
      "vete",
      "vez",
      "vezan",
      "vezañ",
      "veze",
      "vezec'h",
      "vezed",
      "vezemp",
      "vezen",
      "vezent",
      "vezer",
      "vezes",
      "vezez",
      "vezit",
      "vezomp",
      "vezont",
      "vi",
      "vihan",
      "vihanañ",
      "vije",
      "vijec'h",
      "vijed",
      "vijemp",
      "vijen",
      "vijent",
      "vijes",
      "viken",
      "vimp",
      "vin",
      "vint",
      "vior",
      "viot",
      "virviken",
      "viskoazh",
      "vlan",
      "vlaou",
      "vo",
      "vod",
      "voe",
      "voec'h",
      "voed",
      "voemp",
      "voen",
      "voent",
      "voes",
      "vont",
      "vostapl",
      "vrac'h",
      "vrasañ",
      "vremañ",
      "w:",
      "walc'h",
      "war",
      "warnañ",
      "warni",
      "warno",
      "warnoc'h",
      "warnomp",
      "warnon",
      "warnor",
      "warnout",
      "wazh",
      "wech",
      "wechoù",
      "well",
      "y:",
      "you",
      "youadenn",
      "youc'hadenn",
      "youc'hou",
      "z:",
      "za",
      "zan",
      "zaw",
      "zeu",
      "zi",
      "ziar",
      "zigarez",
      "ziget",
      "zindan",
      "zioc'h",
      "ziouzh",
      "zirak",
      "zivout",
      "ziwar",
      "ziwezhañ",
      "zo",
      "zoken",
      "zokenoc'h",
      "zouesk",
      "zouez",
      "zro",
      "zu"
    };
  }
}

class Bulgarian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "ð°",
      "ð°ð²ñ‚ðµð½ñ‚ð¸ñ‡ðµð½",
      "ð°ð·",
      "ð°ðºð¾",
      "ð°ð»ð°",
      "ð±ðµ",
      "ð±ðµð·",
      "ð±ðµñˆðµ",
      "ð±ð¸",
      "ð±ð¸ð²ñˆ",
      "ð±ð¸ð²ñˆð°",
      "ð±ð¸ð²ñˆð¾",
      "ð±ð¸ð»",
      "ð±ð¸ð»ð°",
      "ð±ð¸ð»ð¸",
      "ð±ð¸ð»ð¾",
      "ð±ð»ð°ð³ð¾ð´ð°ñ€ñ",
      "ð±ð»ð¸ð·ð¾",
      "ð±ññ…ð°",
      "ð±ñšð´ð°ñ‚",
      "ð±ñšð´ðµ",
      "ð²",
      "ð²ð°ñ",
      "ð²ð°ñˆ",
      "ð²ð°ñˆð°",
      "ð²ðµñ‡ðµ",
      "ð²ðµñ€ð¾ññ‚ð½ð¾",
      "ð²ð·ðµð¼ð°",
      "ð²ð¸",
      "ð²ð¸ðµ",
      "ð²ð¸ð½ð°ð³ð¸",
      "ð²ð½ð¸ð¼ð°ð²ð°",
      "ð²ñðµ",
      "ð²ñðµðºð¸",
      "ð²ñð¸ñ‡ðºð¸",
      "ð²ñð¸ñ‡ðºð¾",
      "ð²ññðºð°",
      "ð²ñšð²",
      "ð²ñšð¿ñ€ðµðºð¸",
      "ð²ñšñ€ñ…ñƒ",
      "ð²ñ€ðµð¼ðµ",
      "ð³",
      "ð³ð¸",
      "ð³ð»ð°ð²ðµð½",
      "ð³ð»ð°ð²ð½ð°",
      "ð³ð»ð°ð²ð½ð¾",
      "ð³ð»ð°ñ",
      "ð³ð¾",
      "ð³ð¾ð´ð¸ð½ð°",
      "ð³ð¾ð´ð¸ð½ð¸",
      "ð³ð¾ð´ð¸ñˆðµð½",
      "ð´",
      "ð´ð°",
      "ð´ð°ð»ð¸",
      "ð´ð²ð°",
      "ð´ð²ð°ð¼ð°",
      "ð´ð²ð°ð¼ð°ñ‚ð°",
      "ð´ð²ðµ",
      "ð´ð²ðµñ‚ðµ",
      "ð´ðµð½",
      "ð´ð½ðµñ",
      "ð´ð½ð¸",
      "ð´ð¾",
      "ð´ð¾ð±ñšñ€",
      "ð´ð¾ð±ñ€ð°",
      "ð´ð¾ð±ñ€ðµ",
      "ð´ð¾ð±ñ€ð¾",
      "ð´ð¾ðºð°ñ‚ð¾",
      "ð´ð¾ðºð¾ð³ð°",
      "ð´ð¾ñðµð³ð°",
      "ð´ð¾ññ‚ð°",
      "ð´ð¾ñ€ð¸",
      "ð´ñ€ñƒð³",
      "ð´ñ€ñƒð³ð°",
      "ð´ñ€ñƒð³ð¸",
      "ðµ",
      "ðµð²ñ‚ð¸ð½",
      "ðµð´ð²ð°",
      "ðµð´ð¸ð½",
      "ðµð´ð½ð°",
      "ðµð´ð½ð°ðºð²ð°",
      "ðµð´ð½ð°ðºð²ð¸",
      "ðµð´ð½ð°ðºñšð²",
      "ðµð´ð½ð¾",
      "ðµðºð¸ð¿",
      "ðµñ‚ð¾",
      "ð¶ð¸ð²ð¾ñ‚",
      "ð·ð°",
      "ð·ð°ð±ð°ð²ñð¼",
      "ð·ð°ð´",
      "ð·ð°ðµð´ð½ð¾",
      "ð·ð°ñðµð³ð°",
      "ð·ð°ñð¿ð°ð»",
      "ð·ð°ñ‚ð¾ð²ð°",
      "ð·ð°ñ‰ð¾",
      "ð·ð°ñ‰ð¾ñ‚ð¾",
      "ð·ð°ñ€ð°ð´ð¸",
      "ð¸",
      "ð¸ð·",
      "ð¸ð»ð¸",
      "ð¸ð¼",
      "ð¸ð¼ð°",
      "ð¸ð¼ð°ñ‚",
      "ð¸ñðºð°",
      "ð¹",
      "ðºð°ð·ð°",
      "ðºð°ðº",
      "ðºð°ðºð²ð°",
      "ðºð°ðºð²ð¾",
      "ðºð°ðºñšð²",
      "ðºð°ðºñ‚ð¾",
      "ðºð°ñ‚ð¾",
      "ðºð¾ð³ð°",
      "ðºð¾ð³ð°ñ‚ð¾",
      "ðºð¾ðµñ‚ð¾",
      "ðºð¾ð¸ñ‚ð¾",
      "ðºð¾ð¹",
      "ðºð¾ð¹ñ‚ð¾",
      "ðºð¾ð»ðºð¾",
      "ðºð¾ññ‚ð¾",
      "ðºñšð´ðµ",
      "ðºñšð´ðµñ‚ð¾",
      "ðºñšð¼",
      "ð»ðµñðµð½",
      "ð»ðµñð½ð¾",
      "ð»ð¸",
      "ð»ð¾ñˆ",
      "ð¼",
      "ð¼ð°ð¹",
      "ð¼ð°ð»ðºð¾",
      "ð¼ðµ",
      "ð¼ðµð¶ð´ñƒ",
      "ð¼ðµðº",
      "ð¼ðµð½",
      "ð¼ðµñðµñ†",
      "ð¼ð¸",
      "ð¼ð½ð¾ð³ð¾",
      "ð¼ð½ð¾ð·ð¸ð½ð°",
      "ð¼ð¾ð³ð°",
      "ð¼ð¾ð³ð°ñ‚",
      "ð¼ð¾ð¶ðµ",
      "ð¼ð¾ðºñšñ€",
      "ð¼ð¾ð»ñ",
      "ð¼ð¾ð¼ðµð½ñ‚ð°",
      "ð¼ñƒ",
      "ð½",
      "ð½ð°",
      "ð½ð°ð´",
      "ð½ð°ð·ð°ð´",
      "ð½ð°ð¹",
      "ð½ð°ð¿ñ€ð°ð²ð¸",
      "ð½ð°ð¿ñ€ðµð´",
      "ð½ð°ð¿ñ€ð¸ð¼ðµñ€",
      "ð½ð°ñ",
      "ð½ðµ",
      "ð½ðµð³ð¾",
      "ð½ðµñ",
      "ð½ðµñ‰ð¾",
      "ð½ð¸",
      "ð½ð¸ðµ",
      "ð½ð¸ðºð¾ð¹",
      "ð½ð¸ñ‚ð¾",
      "ð½ð¸ñ‰ð¾",
      "ð½ð¾",
      "ð½ð¾ð²",
      "ð½ð¾ð²ð°",
      "ð½ð¾ð²ð¸",
      "ð½ð¾ð²ð¸ð½ð°",
      "ð½ñðºð¾ð¸",
      "ð½ñðºð¾ð¹",
      "ð½ñðºð¾ð»ðºð¾",
      "ð½ñð¼ð°",
      "ð¾ð±ð°ñ‡ðµ",
      "ð¾ðºð¾ð»ð¾",
      "ð¾ñð²ðµð½",
      "ð¾ñð¾ð±ðµð½ð¾",
      "ð¾ñ‚",
      "ð¾ñ‚ð³ð¾ñ€ðµ",
      "ð¾ñ‚ð½ð¾ð²ð¾",
      "ð¾ñ‰ðµ",
      "ð¿ð°ðº",
      "ð¿ð¾",
      "ð¿ð¾ð²ðµñ‡ðµ",
      "ð¿ð¾ð²ðµñ‡ðµñ‚ð¾",
      "ð¿ð¾ð´",
      "ð¿ð¾ð½ðµ",
      "ð¿ð¾ñð»ðµ",
      "ð¿ð¾ñ‡ñ‚ð¸",
      "ð¿ð¾ñ€ð°ð´ð¸",
      "ð¿ñšðº",
      "ð¿ñšñ‚ð¸",
      "ð¿ñšñ€ð²ð°ñ‚ð°",
      "ð¿ñšñ€ð²ð¸",
      "ð¿ñšñ€ð²ð¾",
      "ð¿ñ€ð°ð²ð¸",
      "ð¿ñ€ðµð´",
      "ð¿ñ€ðµð´ð¸",
      "ð¿ñ€ðµð·",
      "ð¿ñ€ð¸",
      "ñ",
      "ñð°",
      "ñð°ð¼",
      "ñð°ð¼ð¾",
      "ñðµ",
      "ñðµð³ð°",
      "ñð¸",
      "ñð¸ð½",
      "ñðºð¾ñ€ð¾",
      "ñð»ðµð´",
      "ñð»ðµð´ð²ð°ñ‰",
      "ñð¼ðµ",
      "ñð¼ññ…",
      "ñð¿ð¾ñ€ðµð´",
      "ññšð¼",
      "ññšñ",
      "ññšñ‰ð¾",
      "ññ‚ðµ",
      "ññ€ðµð´",
      "ññ€ðµñ‰ñƒ",
      "ñ",
      "ñðº",
      "ñžð¼ñ€ñƒðº",
      "ñƒ",
      "ñƒñ‚ñ€ðµ",
      "ñ‚",
      "ñ‚.ð½.",
      "ñ‚ð°ð·ð¸",
      "ñ‚ð°ðºð°",
      "ñ‚ð°ðºð¸ð²ð°",
      "ñ‚ð°ðºñšð²",
      "ñ‚ð°ð¼",
      "ñ‚ð²ð¾ð¹",
      "ñ‚ðµ",
      "ñ‚ðµð·ð¸",
      "ñ‚ð¸",
      "ñ‚ð¾",
      "ñ‚ð¾ð²ð°",
      "ñ‚ð¾ð³ð°ð²ð°",
      "ñ‚ð¾ð·ð¸",
      "ñ‚ð¾ð¹",
      "ñ‚ð¾ð»ðºð¾ð²ð°",
      "ñ‚ð¾ñ‡ð½ð¾",
      "ñ‚ñ",
      "ñ‚ññ…",
      "ñ‚ñšð¹",
      "ñ‚ñƒðº",
      "ñ‚ñ€ð¸",
      "ñ‚ñ€ñð±ð²ð°",
      "ñ‡",
      "ñ‡ð°ñð°",
      "ñ‡ðµ",
      "ñ‡ðµññ‚ð¾",
      "ñ‡ñ€ðµð·",
      "ñ…ð°ñ€ðµñð²ð°",
      "ñ…ð¸ð»ñð´ð¸",
      "ñ‰ðµ",
      "ñ‰ð¾ð¼",
      "ñ€ð°ð²ðµð½",
      "ñ€ð°ð²ð½ð°",
      "а",
      "автентичен",
      "аз",
      "ако",
      "ала",
      "бе",
      "без",
      "беше",
      "би",
      "бивш",
      "бивша",
      "бившо",
      "бил",
      "била",
      "били",
      "било",
      "благодаря",
      "близо",
      "бъдат",
      "бъде",
      "бяха",
      "в",
      "вас",
      "ваш",
      "ваша",
      "вероятно",
      "вече",
      "взема",
      "ви",
      "вие",
      "винаги",
      "внимава",
      "време",
      "все",
      "всеки",
      "всички",
      "всичко",
      "всяка",
      "във",
      "въпреки",
      "върху",
      "г",
      "ги",
      "главен",
      "главна",
      "главно",
      "глас",
      "го",
      "година",
      "години",
      "годишен",
      "д",
      "да",
      "дали",
      "два",
      "двама",
      "двамата",
      "две",
      "двете",
      "ден",
      "днес",
      "дни",
      "до",
      "добра",
      "добре",
      "добро",
      "добър",
      "докато",
      "докога",
      "дори",
      "досега",
      "доста",
      "друг",
      "друга",
      "други",
      "е",
      "евтин",
      "едва",
      "един",
      "една",
      "еднаква",
      "еднакви",
      "еднакъв",
      "едно",
      "екип",
      "ето",
      "живот",
      "за",
      "забавям",
      "зад",
      "заедно",
      "заради",
      "засега",
      "заспал",
      "затова",
      "защо",
      "защото",
      "и",
      "из",
      "или",
      "им",
      "има",
      "имат",
      "иска",
      "й",
      "каза",
      "как",
      "каква",
      "какво",
      "както",
      "какъв",
      "като",
      "кога",
      "когато",
      "което",
      "които",
      "кой",
      "който",
      "колко",
      "която",
      "къде",
      "където",
      "към",
      "лесен",
      "лесно",
      "ли",
      "лош",
      "м",
      "май",
      "малко",
      "ме",
      "между",
      "мек",
      "мен",
      "месец",
      "ми",
      "много",
      "мнозина",
      "мога",
      "могат",
      "може",
      "мокър",
      "моля",
      "момента",
      "му",
      "н",
      "на",
      "над",
      "назад",
      "най",
      "направи",
      "напред",
      "например",
      "нас",
      "не",
      "него",
      "нещо",
      "нея",
      "ни",
      "ние",
      "никой",
      "нито",
      "нищо",
      "но",
      "нов",
      "нова",
      "нови",
      "новина",
      "някои",
      "някой",
      "няколко",
      "няма",
      "обаче",
      "около",
      "освен",
      "особено",
      "от",
      "отгоре",
      "отново",
      "още",
      "пак",
      "по",
      "повече",
      "повечето",
      "под",
      "поне",
      "поради",
      "после",
      "почти",
      "прави",
      "пред",
      "преди",
      "през",
      "при",
      "пък",
      "първата",
      "първи",
      "първо",
      "пъти",
      "равен",
      "равна",
      "с",
      "са",
      "сам",
      "само",
      "се",
      "сега",
      "си",
      "син",
      "скоро",
      "след",
      "следващ",
      "сме",
      "смях",
      "според",
      "сред",
      "срещу",
      "сте",
      "съм",
      "със",
      "също",
      "т",
      "т.н.",
      "тази",
      "така",
      "такива",
      "такъв",
      "там",
      "твой",
      "те",
      "тези",
      "ти",
      "то",
      "това",
      "тогава",
      "този",
      "той",
      "толкова",
      "точно",
      "три",
      "трябва",
      "тук",
      "тъй",
      "тя",
      "тях",
      "у",
      "утре",
      "харесва",
      "хиляди",
      "ч",
      "часа",
      "че",
      "често",
      "чрез",
      "ще",
      "щом",
      "юмрук",
      "я",
      "як"
    };
  }
}

class Catalan implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "abans",
      "ací",
      "ah",
      "així",
      "això",
      "al",
      "aleshores",
      "algun",
      "alguna",
      "algunes",
      "alguns",
      "alhora",
      "allà",
      "allí",
      "allò",
      "als",
      "altra",
      "altre",
      "altres",
      "amb",
      "ambdues",
      "ambdós",
      "anar",
      "ans",
      "apa",
      "aquell",
      "aquella",
      "aquelles",
      "aquells",
      "aquest",
      "aquesta",
      "aquestes",
      "aquests",
      "aquí",
      "baix",
      "bastant",
      "bé",
      "cada",
      "cadascuna",
      "cadascunes",
      "cadascuns",
      "cadascú",
      "com",
      "consegueixo",
      "conseguim",
      "conseguir",
      "consigueix",
      "consigueixen",
      "consigueixes",
      "contra",
      "d'un",
      "d'una",
      "d'unes",
      "d'uns",
      "dalt",
      "de",
      "del",
      "dels",
      "des",
      "des de",
      "després",
      "dins",
      "dintre",
      "donat",
      "doncs",
      "durant",
      "e",
      "eh",
      "el",
      "elles",
      "ells",
      "els",
      "em",
      "en",
      "encara",
      "ens",
      "entre",
      "era",
      "erem",
      "eren",
      "eres",
      "es",
      "esta",
      "estan",
      "estat",
      "estava",
      "estaven",
      "estem",
      "esteu",
      "estic",
      "està",
      "estàvem",
      "estàveu",
      "et",
      "etc",
      "ets",
      "fa",
      "faig",
      "fan",
      "fas",
      "fem",
      "fer",
      "feu",
      "fi",
      "fins",
      "fora",
      "gairebé",
      "ha",
      "han",
      "has",
      "haver",
      "havia",
      "he",
      "hem",
      "heu",
      "hi",
      "ho",
      "i",
      "igual",
      "iguals",
      "inclòs",
      "ja",
      "jo",
      "l'hi",
      "la",
      "les",
      "li",
      "li'n",
      "llarg",
      "llavors",
      "m'he",
      "ma",
      "mal",
      "malgrat",
      "mateix",
      "mateixa",
      "mateixes",
      "mateixos",
      "me",
      "mentre",
      "meu",
      "meus",
      "meva",
      "meves",
      "mode",
      "molt",
      "molta",
      "moltes",
      "molts",
      "mon",
      "mons",
      "més",
      "n'he",
      "n'hi",
      "ne",
      "ni",
      "no",
      "nogensmenys",
      "només",
      "nosaltres",
      "nostra",
      "nostre",
      "nostres",
      "o",
      "oh",
      "oi",
      "on",
      "pas",
      "pel",
      "pels",
      "per",
      "per que",
      "perquè",
      "però",
      "poc",
      "poca",
      "pocs",
      "podem",
      "poden",
      "poder",
      "podeu",
      "poques",
      "potser",
      "primer",
      "propi",
      "puc",
      "qual",
      "quals",
      "quan",
      "quant",
      "que",
      "quelcom",
      "qui",
      "quin",
      "quina",
      "quines",
      "quins",
      "què",
      "s'ha",
      "s'han",
      "sa",
      "sabem",
      "saben",
      "saber",
      "sabeu",
      "sap",
      "saps",
      "semblant",
      "semblants",
      "sense",
      "ser",
      "ses",
      "seu",
      "seus",
      "seva",
      "seves",
      "si",
      "sobre",
      "sobretot",
      "soc",
      "solament",
      "sols",
      "som",
      "son",
      "sons",
      "sota",
      "sou",
      "sóc",
      "són",
      "t'ha",
      "t'han",
      "t'he",
      "ta",
      "tal",
      "també",
      "tampoc",
      "tan",
      "tant",
      "tanta",
      "tantes",
      "te",
      "tene",
      "tenim",
      "tenir",
      "teniu",
      "teu",
      "teus",
      "teva",
      "teves",
      "tinc",
      "ton",
      "tons",
      "tot",
      "tota",
      "totes",
      "tots",
      "un",
      "una",
      "unes",
      "uns",
      "us",
      "va",
      "vaig",
      "vam",
      "van",
      "vas",
      "veu",
      "vosaltres",
      "vostra",
      "vostre",
      "vostres",
      "érem",
      "éreu",
      "és",
      "éssent",
      "últim",
      "ús"
    };
  }
}

class Chinese implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "、",
      "。",
      "〈",
      "〉",
      "《",
      "》",
      "一",
      "一些",
      "一何",
      "一切",
      "一则",
      "一方面",
      "一旦",
      "一来",
      "一样",
      "一般",
      "一转眼",
      "七",
      "万一",
      "三",
      "上",
      "上下",
      "下",
      "不",
      "不仅",
      "不但",
      "不光",
      "不单",
      "不只",
      "不外乎",
      "不如",
      "不妨",
      "不尽",
      "不尽然",
      "不得",
      "不怕",
      "不惟",
      "不成",
      "不拘",
      "不料",
      "不是",
      "不比",
      "不然",
      "不特",
      "不独",
      "不管",
      "不至于",
      "不若",
      "不论",
      "不过",
      "不问",
      "与",
      "与其",
      "与其说",
      "与否",
      "与此同时",
      "且",
      "且不说",
      "且说",
      "两者",
      "个",
      "个别",
      "中",
      "临",
      "为",
      "为了",
      "为什么",
      "为何",
      "为止",
      "为此",
      "为着",
      "乃",
      "乃至",
      "乃至于",
      "么",
      "之",
      "之一",
      "之所以",
      "之类",
      "乌乎",
      "乎",
      "乘",
      "九",
      "也",
      "也好",
      "也罢",
      "了",
      "二",
      "二来",
      "于",
      "于是",
      "于是乎",
      "云云",
      "云尔",
      "五",
      "些",
      "亦",
      "人",
      "人们",
      "人家",
      "什",
      "什么",
      "什么样",
      "今",
      "介于",
      "仍",
      "仍旧",
      "从",
      "从此",
      "从而",
      "他",
      "他人",
      "他们",
      "他们们",
      "以",
      "以上",
      "以为",
      "以便",
      "以免",
      "以及",
      "以故",
      "以期",
      "以来",
      "以至",
      "以至于",
      "以致",
      "们",
      "任",
      "任何",
      "任凭",
      "会",
      "似的",
      "但",
      "但凡",
      "但是",
      "何",
      "何以",
      "何况",
      "何处",
      "何时",
      "余外",
      "作为",
      "你",
      "你们",
      "使",
      "使得",
      "例如",
      "依",
      "依据",
      "依照",
      "便于",
      "俺",
      "俺们",
      "倘",
      "倘使",
      "倘或",
      "倘然",
      "倘若",
      "借",
      "借傥然",
      "假使",
      "假如",
      "假若",
      "做",
      "像",
      "儿",
      "先不先",
      "光是",
      "全体",
      "全部",
      "八",
      "六",
      "兮",
      "共",
      "关于",
      "关于具体地说",
      "其",
      "其一",
      "其中",
      "其二",
      "其他",
      "其余",
      "其它",
      "其次",
      "具体地说",
      "具体说来",
      "兼之",
      "内",
      "再",
      "再其次",
      "再则",
      "再有",
      "再者",
      "再者说",
      "再说",
      "冒",
      "冲",
      "况且",
      "几",
      "几时",
      "凡",
      "凡是",
      "凭",
      "凭借",
      "出于",
      "出来",
      "分",
      "分别",
      "则",
      "则甚",
      "别",
      "别人",
      "别处",
      "别是",
      "别的",
      "别管",
      "别说",
      "到",
      "前后",
      "前此",
      "前者",
      "加之",
      "加以",
      "即",
      "即令",
      "即使",
      "即便",
      "即如",
      "即或",
      "即若",
      "却",
      "去",
      "又",
      "又及",
      "及",
      "及其",
      "及至",
      "反之",
      "反而",
      "反过来",
      "反过来说",
      "受到",
      "另",
      "另一方面",
      "另外",
      "另悉",
      "只",
      "只当",
      "只怕",
      "只是",
      "只有",
      "只消",
      "只要",
      "只限",
      "叫",
      "叮咚",
      "可",
      "可以",
      "可是",
      "可见",
      "各",
      "各个",
      "各位",
      "各种",
      "各自",
      "同",
      "同时",
      "后",
      "后者",
      "向",
      "向使",
      "向着",
      "吓",
      "吗",
      "否则",
      "吧",
      "吧哒",
      "含",
      "吱",
      "呀",
      "呃",
      "呕",
      "呗",
      "呜",
      "呜呼",
      "呢",
      "呵",
      "呵呵",
      "呸",
      "呼哧",
      "咋",
      "和",
      "咚",
      "咦",
      "咧",
      "咱",
      "咱们",
      "咳",
      "哇",
      "哈",
      "哈哈",
      "哉",
      "哎",
      "哎呀",
      "哎哟",
      "哗",
      "哟",
      "哦",
      "哩",
      "哪",
      "哪个",
      "哪些",
      "哪儿",
      "哪天",
      "哪年",
      "哪怕",
      "哪样",
      "哪边",
      "哪里",
      "哼",
      "哼唷",
      "唉",
      "唯有",
      "啊",
      "啐",
      "啥",
      "啦",
      "啪达",
      "啷当",
      "喂",
      "喏",
      "喔唷",
      "喽",
      "嗡",
      "嗡嗡",
      "嗬",
      "嗯",
      "嗳",
      "嘎",
      "嘎登",
      "嘘",
      "嘛",
      "嘻",
      "嘿",
      "嘿嘿",
      "四",
      "因",
      "因为",
      "因了",
      "因此",
      "因着",
      "因而",
      "固然",
      "在",
      "在下",
      "在于",
      "地",
      "基于",
      "处在",
      "多",
      "多么",
      "多少",
      "大",
      "大家",
      "她",
      "她们",
      "好",
      "如",
      "如上",
      "如上所述",
      "如下",
      "如何",
      "如其",
      "如同",
      "如是",
      "如果",
      "如此",
      "如若",
      "始而",
      "孰料",
      "孰知",
      "宁",
      "宁可",
      "宁愿",
      "宁肯",
      "它",
      "它们",
      "对",
      "对于",
      "对待",
      "对方",
      "对比",
      "将",
      "小",
      "尔",
      "尔后",
      "尔尔",
      "尚且",
      "就",
      "就是",
      "就是了",
      "就是说",
      "就算",
      "就要",
      "尽",
      "尽管",
      "尽管如此",
      "岂但",
      "己",
      "已",
      "已矣",
      "巴",
      "巴巴",
      "年",
      "并",
      "并且",
      "庶乎",
      "庶几",
      "开外",
      "开始",
      "归",
      "归齐",
      "当",
      "当地",
      "当然",
      "当着",
      "彼",
      "彼时",
      "彼此",
      "往",
      "待",
      "很",
      "得",
      "得了",
      "怎",
      "怎么",
      "怎么办",
      "怎么样",
      "怎奈",
      "怎样",
      "总之",
      "总的来看",
      "总的来说",
      "总的说来",
      "总而言之",
      "恰恰相反",
      "您",
      "惟其",
      "慢说",
      "我",
      "我们",
      "或",
      "或则",
      "或是",
      "或曰",
      "或者",
      "截至",
      "所",
      "所以",
      "所在",
      "所幸",
      "所有",
      "才",
      "才能",
      "打",
      "打从",
      "把",
      "抑或",
      "拿",
      "按",
      "按照",
      "换句话说",
      "换言之",
      "据",
      "据此",
      "接着",
      "故",
      "故此",
      "故而",
      "旁人",
      "无",
      "无宁",
      "无论",
      "既",
      "既往",
      "既是",
      "既然",
      "日",
      "时",
      "时候",
      "是",
      "是以",
      "是的",
      "更",
      "曾",
      "替",
      "替代",
      "最",
      "月",
      "有",
      "有些",
      "有关",
      "有及",
      "有时",
      "有的",
      "望",
      "朝",
      "朝着",
      "本",
      "本人",
      "本地",
      "本着",
      "本身",
      "来",
      "来着",
      "来自",
      "来说",
      "极了",
      "果然",
      "果真",
      "某",
      "某个",
      "某些",
      "某某",
      "根据",
      "欤",
      "正值",
      "正如",
      "正巧",
      "正是",
      "此",
      "此地",
      "此处",
      "此外",
      "此时",
      "此次",
      "此间",
      "毋宁",
      "每",
      "每当",
      "比",
      "比及",
      "比如",
      "比方",
      "没奈何",
      "沿",
      "沿着",
      "漫说",
      "焉",
      "然则",
      "然后",
      "然而",
      "照",
      "照着",
      "犹且",
      "犹自",
      "甚且",
      "甚么",
      "甚或",
      "甚而",
      "甚至",
      "甚至于",
      "用",
      "用来",
      "由",
      "由于",
      "由是",
      "由此",
      "由此可见",
      "的",
      "的确",
      "的话",
      "直到",
      "相对而言",
      "省得",
      "看",
      "眨眼",
      "着",
      "着呢",
      "矣",
      "矣乎",
      "矣哉",
      "离",
      "秒",
      "竟而",
      "第",
      "等",
      "等到",
      "等等",
      "简言之",
      "管",
      "类如",
      "紧接着",
      "纵",
      "纵令",
      "纵使",
      "纵然",
      "经",
      "经过",
      "结果",
      "给",
      "继之",
      "继后",
      "继而",
      "综上所述",
      "罢了",
      "者",
      "而",
      "而且",
      "而况",
      "而后",
      "而外",
      "而已",
      "而是",
      "而言",
      "能",
      "能否",
      "腾",
      "自",
      "自个儿",
      "自从",
      "自各儿",
      "自后",
      "自家",
      "自己",
      "自打",
      "自身",
      "至",
      "至于",
      "至今",
      "至若",
      "致",
      "般的",
      "若",
      "若夫",
      "若是",
      "若果",
      "若非",
      "莫不然",
      "莫如",
      "莫若",
      "虽",
      "虽则",
      "虽然",
      "虽说",
      "被",
      "要",
      "要不",
      "要不是",
      "要不然",
      "要么",
      "要是",
      "譬喻",
      "譬如",
      "让",
      "许多",
      "论",
      "设使",
      "设或",
      "设若",
      "诚如",
      "诚然",
      "该",
      "说",
      "说来",
      "请",
      "诸",
      "诸位",
      "诸如",
      "谁",
      "谁人",
      "谁料",
      "谁知",
      "贼死",
      "赖以",
      "赶",
      "起",
      "起见",
      "趁",
      "趁着",
      "越是",
      "距",
      "跟",
      "较",
      "较之",
      "边",
      "过",
      "还",
      "还是",
      "还有",
      "还要",
      "这",
      "这一来",
      "这个",
      "这么",
      "这么些",
      "这么样",
      "这么点儿",
      "这些",
      "这会儿",
      "这儿",
      "这就是说",
      "这时",
      "这样",
      "这次",
      "这般",
      "这边",
      "这里",
      "进而",
      "连",
      "连同",
      "逐步",
      "通过",
      "遵循",
      "遵照",
      "那",
      "那个",
      "那么",
      "那么些",
      "那么样",
      "那些",
      "那会儿",
      "那儿",
      "那时",
      "那样",
      "那般",
      "那边",
      "那里",
      "都",
      "鄙人",
      "鉴于",
      "针对",
      "阿",
      "除",
      "除了",
      "除外",
      "除开",
      "除此之外",
      "除非",
      "随",
      "随后",
      "随时",
      "随着",
      "难道说",
      "零",
      "非",
      "非但",
      "非徒",
      "非特",
      "非独",
      "靠",
      "顺",
      "顺着",
      "首先",
      "︿",
      "！",
      "＃",
      "＄",
      "％",
      "＆",
      "（",
      "）",
      "＊",
      "＋",
      "，",
      "０",
      "１",
      "２",
      "３",
      "４",
      "５",
      "６",
      "７",
      "８",
      "９",
      "：",
      "；",
      "＜",
      "＞",
      "？",
      "＠",
      "［",
      "］",
      "｛",
      "｜",
      "｝",
      "～",
      "￥"
    };
  }
}

class Croatian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "ako",
      "ali",
      "bi",
      "bih",
      "bila",
      "bili",
      "bilo",
      "bio",
      "bismo",
      "biste",
      "biti",
      "bumo",
      "da",
      "do",
      "duž",
      "ga",
      "hoće",
      "hoćemo",
      "hoćete",
      "hoćeš",
      "hoću",
      "i",
      "iako",
      "ih",
      "ili",
      "iz",
      "ja",
      "je",
      "jedna",
      "jedne",
      "jedno",
      "jer",
      "jesam",
      "jesi",
      "jesmo",
      "jest",
      "jeste",
      "jesu",
      "jim",
      "joj",
      "još",
      "ju",
      "kada",
      "kako",
      "kao",
      "koja",
      "koje",
      "koji",
      "kojima",
      "koju",
      "kroz",
      "li",
      "me",
      "mene",
      "meni",
      "mi",
      "mimo",
      "moj",
      "moja",
      "moje",
      "mu",
      "na",
      "nad",
      "nakon",
      "nam",
      "nama",
      "nas",
      "naš",
      "naša",
      "naše",
      "našeg",
      "ne",
      "nego",
      "neka",
      "neki",
      "nekog",
      "neku",
      "nema",
      "netko",
      "neće",
      "nećemo",
      "nećete",
      "nećeš",
      "neću",
      "nešto",
      "ni",
      "nije",
      "nikoga",
      "nikoje",
      "nikoju",
      "nisam",
      "nisi",
      "nismo",
      "niste",
      "nisu",
      "njega",
      "njegov",
      "njegova",
      "njegovo",
      "njemu",
      "njezin",
      "njezina",
      "njezino",
      "njih",
      "njihov",
      "njihova",
      "njihovo",
      "njim",
      "njima",
      "njoj",
      "nju",
      "no",
      "o",
      "od",
      "odmah",
      "on",
      "ona",
      "oni",
      "ono",
      "ova",
      "pa",
      "pak",
      "po",
      "pod",
      "pored",
      "prije",
      "s",
      "sa",
      "sam",
      "samo",
      "se",
      "sebe",
      "sebi",
      "si",
      "smo",
      "ste",
      "su",
      "sve",
      "svi",
      "svog",
      "svoj",
      "svoja",
      "svoje",
      "svom",
      "ta",
      "tada",
      "taj",
      "tako",
      "te",
      "tebe",
      "tebi",
      "ti",
      "to",
      "toj",
      "tome",
      "tu",
      "tvoj",
      "tvoja",
      "tvoje",
      "u",
      "uz",
      "vam",
      "vama",
      "vas",
      "vaš",
      "vaša",
      "vaše",
      "već",
      "vi",
      "vrlo",
      "za",
      "zar",
      "će",
      "ćemo",
      "ćete",
      "ćeš",
      "ću",
      "što"
    };
  }
}

class Czech implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "aby",
      "ahoj",
      "aj",
      "ale",
      "anebo",
      "ani",
      "aniž",
      "ano",
      "asi",
      "aspoåˆ",
      "aspoň",
      "atd",
      "atp",
      "az",
      "aäkoli",
      "ačkoli",
      "až",
      "bez",
      "beze",
      "blã­zko",
      "blízko",
      "bohuå¾el",
      "bohužel",
      "brzo",
      "bude",
      "budem",
      "budeme",
      "budes",
      "budete",
      "budeå¡",
      "budeš",
      "budou",
      "budu",
      "by",
      "byl",
      "byla",
      "byli",
      "bylo",
      "byly",
      "bys",
      "byt",
      "bä›hem",
      "být",
      "během",
      "chce",
      "chceme",
      "chcete",
      "chceå¡",
      "chceš",
      "chci",
      "chtã­t",
      "chtä›jã­",
      "chtít",
      "chtějí",
      "chut'",
      "chuti",
      "ci",
      "clanek",
      "clanku",
      "clanky",
      "co",
      "coz",
      "což",
      "cz",
      "daleko",
      "dalsi",
      "další",
      "den",
      "deset",
      "design",
      "devatenáct",
      "devatenã¡ct",
      "devä›t",
      "devět",
      "dnes",
      "do",
      "dobrã½",
      "dobrý",
      "docela",
      "dva",
      "dvacet",
      "dvanáct",
      "dvanã¡ct",
      "dvä›",
      "dvě",
      "dál",
      "dále",
      "dã¡l",
      "dã¡le",
      "dä›kovat",
      "dä›kujeme",
      "dä›kuji",
      "děkovat",
      "děkujeme",
      "děkuji",
      "email",
      "ho",
      "hodnä›",
      "hodně",
      "i",
      "jak",
      "jakmile",
      "jako",
      "jakož",
      "jde",
      "je",
      "jeden",
      "jedenáct",
      "jedenã¡ct",
      "jedna",
      "jedno",
      "jednou",
      "jedou",
      "jeho",
      "jehož",
      "jej",
      "jeji",
      "jejich",
      "jejã­",
      "její",
      "jelikož",
      "jemu",
      "jen",
      "jenom",
      "jenž",
      "jeste",
      "jestli",
      "jestliå¾e",
      "jestliže",
      "jeå¡tä›",
      "ještě",
      "jež",
      "ji",
      "jich",
      "jimi",
      "jinak",
      "jine",
      "jiné",
      "jiz",
      "již",
      "jsem",
      "jses",
      "jseš",
      "jsi",
      "jsme",
      "jsou",
      "jste",
      "já",
      "jã¡",
      "jã­",
      "jã­m",
      "jí",
      "jím",
      "jíž",
      "jšte",
      "k",
      "kam",
      "každý",
      "kde",
      "kdo",
      "kdy",
      "kdyz",
      "kdyå¾",
      "když",
      "ke",
      "kolik",
      "kromä›",
      "kromě",
      "ktera",
      "ktere",
      "kteri",
      "kterou",
      "ktery",
      "která",
      "kterã¡",
      "kterã©",
      "kterã½",
      "které",
      "který",
      "kteå™ã­",
      "kteři",
      "kteří",
      "ku",
      "kvå¯li",
      "kvůli",
      "ma",
      "majã­",
      "mají",
      "mate",
      "me",
      "mezi",
      "mi",
      "mit",
      "mne",
      "mnou",
      "mnä›",
      "mně",
      "moc",
      "mohl",
      "mohou",
      "moje",
      "moji",
      "moå¾nã¡",
      "možná",
      "muj",
      "musã­",
      "musí",
      "muze",
      "my",
      "má",
      "málo",
      "mám",
      "máme",
      "máte",
      "máš",
      "mã¡",
      "mã¡lo",
      "mã¡m",
      "mã¡me",
      "mã¡te",
      "mã¡å¡",
      "mã©",
      "mã­",
      "mã­t",
      "mä›",
      "må¯j",
      "må¯å¾e",
      "mé",
      "mí",
      "mít",
      "mě",
      "můj",
      "může",
      "na",
      "nad",
      "nade",
      "nam",
      "napiste",
      "napište",
      "naproti",
      "nas",
      "nasi",
      "naå¡e",
      "naå¡i",
      "načež",
      "naše",
      "naši",
      "ne",
      "nebo",
      "nebyl",
      "nebyla",
      "nebyli",
      "nebyly",
      "nechť",
      "nedä›lajã­",
      "nedä›lã¡",
      "nedä›lã¡m",
      "nedä›lã¡me",
      "nedä›lã¡te",
      "nedä›lã¡å¡",
      "nedělají",
      "nedělá",
      "nedělám",
      "neděláme",
      "neděláte",
      "neděláš",
      "neg",
      "nejsi",
      "nejsou",
      "nemajã­",
      "nemají",
      "nemáme",
      "nemáte",
      "nemã¡me",
      "nemã¡te",
      "nemä›l",
      "neměl",
      "neni",
      "nenã­",
      "není",
      "nestaäã­",
      "nestačí",
      "nevadã­",
      "nevadí",
      "nez",
      "neå¾",
      "než",
      "nic",
      "nich",
      "nimi",
      "nove",
      "novy",
      "nové",
      "nový",
      "nula",
      "ná",
      "nám",
      "námi",
      "nás",
      "náš",
      "nã¡m",
      "nã¡mi",
      "nã¡s",
      "nã¡å¡",
      "nã­m",
      "nä›",
      "nä›co",
      "nä›jak",
      "nä›kde",
      "nä›kdo",
      "nä›mu",
      "ní",
      "ním",
      "ně",
      "něco",
      "nějak",
      "někde",
      "někdo",
      "němu",
      "němuž",
      "o",
      "od",
      "ode",
      "on",
      "ona",
      "oni",
      "ono",
      "ony",
      "osm",
      "osmnáct",
      "osmnã¡ct",
      "pak",
      "patnáct",
      "patnã¡ct",
      "po",
      "pod",
      "podle",
      "pokud",
      "potom",
      "pouze",
      "pozdä›",
      "pozdě",
      "poå™ã¡d",
      "pořád",
      "prave",
      "pravé",
      "pred",
      "pres",
      "pri",
      "pro",
      "proc",
      "prostä›",
      "prostě",
      "prosã­m",
      "prosím",
      "proti",
      "proto",
      "protoze",
      "protoå¾e",
      "protože",
      "proä",
      "proč",
      "prvni",
      "první",
      "práve",
      "pta",
      "pä›t",
      "på™ed",
      "på™es",
      "på™ese",
      "pět",
      "před",
      "přede",
      "přes",
      "přese",
      "při",
      "přičemž",
      "re",
      "rovnä›",
      "rovně",
      "s",
      "se",
      "sedm",
      "sedmnáct",
      "sedmnã¡ct",
      "si",
      "sice",
      "skoro",
      "smã­",
      "smä›jã­",
      "smí",
      "smějí",
      "snad",
      "spolu",
      "sta",
      "sto",
      "strana",
      "stã©",
      "sté",
      "sve",
      "svych",
      "svym",
      "svymi",
      "své",
      "svých",
      "svým",
      "svými",
      "svůj",
      "ta",
      "tady",
      "tak",
      "take",
      "takhle",
      "taky",
      "takze",
      "také",
      "takže",
      "tam",
      "tamhle",
      "tamhleto",
      "tamto",
      "tato",
      "te",
      "tebe",
      "tebou",
      "ted'",
      "tedy",
      "tema",
      "ten",
      "tento",
      "teto",
      "ti",
      "tim",
      "timto",
      "tipy",
      "tisã­c",
      "tisã­ce",
      "tisíc",
      "tisíce",
      "to",
      "tobä›",
      "tobě",
      "tohle",
      "toho",
      "tohoto",
      "tom",
      "tomto",
      "tomu",
      "tomuto",
      "toto",
      "troå¡ku",
      "trošku",
      "tu",
      "tuto",
      "tvoje",
      "tvá",
      "tvã¡",
      "tvã©",
      "två¯j",
      "tvé",
      "tvůj",
      "ty",
      "tyto",
      "tä›",
      "tå™eba",
      "tå™i",
      "tå™inã¡ct",
      "téma",
      "této",
      "tím",
      "tímto",
      "tě",
      "těm",
      "těma",
      "těmu",
      "třeba",
      "tři",
      "třináct",
      "u",
      "uräitä›",
      "určitě",
      "uz",
      "uå¾",
      "už",
      "v",
      "vam",
      "vas",
      "vase",
      "vaå¡e",
      "vaå¡i",
      "vaše",
      "vaši",
      "ve",
      "vedle",
      "veäer",
      "večer",
      "vice",
      "vlastnä›",
      "vlastně",
      "vsak",
      "vy",
      "vám",
      "vámi",
      "vás",
      "váš",
      "vã¡m",
      "vã¡mi",
      "vã¡s",
      "vã¡å¡",
      "vå¡echno",
      "vå¡ichni",
      "vå¯bec",
      "vå¾dy",
      "více",
      "však",
      "všechen",
      "všechno",
      "všichni",
      "vůbec",
      "vždy",
      "z",
      "za",
      "zatã­mco",
      "zatímco",
      "zaä",
      "zač",
      "zda",
      "zde",
      "ze",
      "zpet",
      "zpravy",
      "zprávy",
      "zpět",
      "äau",
      "ätrnã¡ct",
      "ätyå™i",
      "å¡est",
      "å¡estnã¡ct",
      "å¾e",
      "čau",
      "či",
      "článek",
      "článku",
      "články",
      "čtrnáct",
      "čtyři",
      "šest",
      "šestnáct",
      "že"
    };
  }
}

class Danish implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "ad",
      "af",
      "aldrig",
      "alle",
      "alt",
      "anden",
      "andet",
      "andre",
      "at",
      "bare",
      "begge",
      "blev",
      "blive",
      "bliver",
      "da",
      "de",
      "dem",
      "den",
      "denne",
      "der",
      "deres",
      "det",
      "dette",
      "dig",
      "din",
      "dine",
      "disse",
      "dit",
      "dog",
      "du",
      "efter",
      "ej",
      "eller",
      "en",
      "end",
      "ene",
      "eneste",
      "enhver",
      "er",
      "et",
      "far",
      "fem",
      "fik",
      "fire",
      "flere",
      "fleste",
      "for",
      "fordi",
      "forrige",
      "fra",
      "få",
      "får",
      "før",
      "god",
      "godt",
      "ham",
      "han",
      "hans",
      "har",
      "havde",
      "have",
      "hej",
      "helt",
      "hende",
      "hendes",
      "her",
      "hos",
      "hun",
      "hvad",
      "hvem",
      "hver",
      "hvilken",
      "hvis",
      "hvor",
      "hvordan",
      "hvorfor",
      "hvornår",
      "i",
      "ikke",
      "ind",
      "ingen",
      "intet",
      "ja",
      "jeg",
      "jer",
      "jeres",
      "jo",
      "kan",
      "kom",
      "komme",
      "kommer",
      "kun",
      "kunne",
      "lad",
      "lav",
      "lidt",
      "lige",
      "lille",
      "man",
      "mand",
      "mange",
      "med",
      "meget",
      "men",
      "mens",
      "mere",
      "mig",
      "min",
      "mine",
      "mit",
      "mod",
      "må",
      "ned",
      "nej",
      "ni",
      "nogen",
      "noget",
      "nogle",
      "nu",
      "ny",
      "nyt",
      "når",
      "nær",
      "næste",
      "næsten",
      "og",
      "også",
      "okay",
      "om",
      "op",
      "os",
      "otte",
      "over",
      "på",
      "se",
      "seks",
      "selv",
      "ser",
      "ses",
      "sig",
      "sige",
      "sin",
      "sine",
      "sit",
      "skal",
      "skulle",
      "som",
      "stor",
      "store",
      "syv",
      "så",
      "sådan",
      "tag",
      "tage",
      "thi",
      "ti",
      "til",
      "to",
      "tre",
      "ud",
      "under",
      "var",
      "ved",
      "vi",
      "vil",
      "ville",
      "vor",
      "vores",
      "være",
      "været"
    };
  }
}

class Dutch implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "aan",
      "aangaande",
      "aangezien",
      "achte",
      "achter",
      "achterna",
      "af",
      "afgelopen",
      "al",
      "aldaar",
      "aldus",
      "alhoewel",
      "alias",
      "alle",
      "allebei",
      "alleen",
      "alles",
      "als",
      "alsnog",
      "altijd",
      "altoos",
      "ander",
      "andere",
      "anders",
      "anderszins",
      "beetje",
      "behalve",
      "behoudens",
      "beide",
      "beiden",
      "ben",
      "beneden",
      "bent",
      "bepaald",
      "betreffende",
      "bij",
      "bijna",
      "bijv",
      "binnen",
      "binnenin",
      "blijkbaar",
      "blijken",
      "boven",
      "bovenal",
      "bovendien",
      "bovengenoemd",
      "bovenstaand",
      "bovenvermeld",
      "buiten",
      "bv",
      "daar",
      "daardoor",
      "daarheen",
      "daarin",
      "daarna",
      "daarnet",
      "daarom",
      "daarop",
      "daaruit",
      "daarvanlangs",
      "dan",
      "dat",
      "de",
      "deden",
      "deed",
      "der",
      "derde",
      "derhalve",
      "dertig",
      "deze",
      "dhr",
      "die",
      "dikwijls",
      "dit",
      "doch",
      "doe",
      "doen",
      "doet",
      "door",
      "doorgaand",
      "drie",
      "duizend",
      "dus",
      "echter",
      "een",
      "eens",
      "eer",
      "eerdat",
      "eerder",
      "eerlang",
      "eerst",
      "eerste",
      "eigen",
      "eigenlijk",
      "elk",
      "elke",
      "en",
      "enig",
      "enige",
      "enigszins",
      "enkel",
      "er",
      "erdoor",
      "erg",
      "ergens",
      "etc",
      "etcetera",
      "even",
      "eveneens",
      "evenwel",
      "gauw",
      "ge",
      "gedurende",
      "geen",
      "gehad",
      "gekund",
      "geleden",
      "gelijk",
      "gemoeten",
      "gemogen",
      "genoeg",
      "geweest",
      "gewoon",
      "gewoonweg",
      "haar",
      "haarzelf",
      "had",
      "hadden",
      "hare",
      "heb",
      "hebben",
      "hebt",
      "hedden",
      "heeft",
      "heel",
      "hem",
      "hemzelf",
      "hen",
      "het",
      "hetzelfde",
      "hier",
      "hierbeneden",
      "hierboven",
      "hierin",
      "hierna",
      "hierom",
      "hij",
      "hijzelf",
      "hoe",
      "hoewel",
      "honderd",
      "hun",
      "hunne",
      "ieder",
      "iedere",
      "iedereen",
      "iemand",
      "iets",
      "ik",
      "ikzelf",
      "in",
      "inderdaad",
      "inmiddels",
      "intussen",
      "inzake",
      "is",
      "ja",
      "je",
      "jezelf",
      "jij",
      "jijzelf",
      "jou",
      "jouw",
      "jouwe",
      "juist",
      "jullie",
      "kan",
      "klaar",
      "kon",
      "konden",
      "krachtens",
      "kun",
      "kunnen",
      "kunt",
      "laatst",
      "later",
      "liever",
      "lijken",
      "lijkt",
      "maak",
      "maakt",
      "maakte",
      "maakten",
      "maar",
      "mag",
      "maken",
      "me",
      "meer",
      "meest",
      "meestal",
      "men",
      "met",
      "mevr",
      "mezelf",
      "mij",
      "mijn",
      "mijnent",
      "mijner",
      "mijzelf",
      "minder",
      "miss",
      "misschien",
      "missen",
      "mits",
      "mocht",
      "mochten",
      "moest",
      "moesten",
      "moet",
      "moeten",
      "mogen",
      "mr",
      "mrs",
      "mw",
      "na",
      "naar",
      "nadat",
      "nam",
      "namelijk",
      "nee",
      "neem",
      "negen",
      "nemen",
      "nergens",
      "net",
      "niemand",
      "niet",
      "niets",
      "niks",
      "noch",
      "nochtans",
      "nog",
      "nogal",
      "nooit",
      "nu",
      "nv",
      "of",
      "ofschoon",
      "om",
      "omdat",
      "omhoog",
      "omlaag",
      "omstreeks",
      "omtrent",
      "omver",
      "ondanks",
      "onder",
      "ondertussen",
      "ongeveer",
      "ons",
      "onszelf",
      "onze",
      "onzeker",
      "ooit",
      "ook",
      "op",
      "opnieuw",
      "opzij",
      "over",
      "overal",
      "overeind",
      "overige",
      "overigens",
      "paar",
      "pas",
      "per",
      "precies",
      "recent",
      "redelijk",
      "reeds",
      "rond",
      "rondom",
      "samen",
      "sedert",
      "sinds",
      "sindsdien",
      "slechts",
      "sommige",
      "spoedig",
      "steeds",
      "tamelijk",
      "te",
      "tegen",
      "tegenover",
      "tenzij",
      "terwijl",
      "thans",
      "tien",
      "tiende",
      "tijdens",
      "tja",
      "toch",
      "toe",
      "toen",
      "toenmaals",
      "toenmalig",
      "tot",
      "totdat",
      "tussen",
      "twee",
      "tweede",
      "u",
      "uit",
      "uitgezonderd",
      "uw",
      "vaak",
      "vaakwat",
      "van",
      "vanaf",
      "vandaan",
      "vanuit",
      "vanwege",
      "veel",
      "veeleer",
      "veertig",
      "verder",
      "verscheidene",
      "verschillende",
      "vervolgens",
      "via",
      "vier",
      "vierde",
      "vijf",
      "vijfde",
      "vijftig",
      "vol",
      "volgend",
      "volgens",
      "voor",
      "vooraf",
      "vooral",
      "vooralsnog",
      "voorbij",
      "voordat",
      "voordezen",
      "voordien",
      "voorheen",
      "voorop",
      "voorts",
      "vooruit",
      "vrij",
      "vroeg",
      "waar",
      "waarom",
      "waarschijnlijk",
      "wanneer",
      "want",
      "waren",
      "was",
      "wat",
      "we",
      "wederom",
      "weer",
      "weg",
      "wegens",
      "weinig",
      "wel",
      "weldra",
      "welk",
      "welke",
      "werd",
      "werden",
      "werder",
      "wezen",
      "whatever",
      "wie",
      "wiens",
      "wier",
      "wij",
      "wijzelf",
      "wil",
      "wilden",
      "willen",
      "word",
      "worden",
      "wordt",
      "zal",
      "ze",
      "zei",
      "zeker",
      "zelf",
      "zelfde",
      "zelfs",
      "zes",
      "zeven",
      "zich",
      "zichzelf",
      "zij",
      "zijn",
      "zijne",
      "zijzelf",
      "zo",
      "zoals",
      "zodat",
      "zodra",
      "zonder",
      "zou",
      "zouden",
      "zowat",
      "zulk",
      "zulke",
      "zullen",
      "zult"
    };
  }
}

class English implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "a's",
      "able",
      "about",
      "above",
      "according",
      "accordingly",
      "across",
      "actually",
      "after",
      "afterwards",
      "again",
      "against",
      "ain't",
      "all",
      "allow",
      "allows",
      "almost",
      "alone",
      "along",
      "already",
      "also",
      "although",
      "always",
      "am",
      "among",
      "amongst",
      "an",
      "and",
      "another",
      "any",
      "anybody",
      "anyhow",
      "anyone",
      "anything",
      "anyway",
      "anyways",
      "anywhere",
      "apart",
      "appear",
      "appreciate",
      "appropriate",
      "are",
      "aren't",
      "around",
      "as",
      "aside",
      "ask",
      "asking",
      "associated",
      "at",
      "available",
      "away",
      "awfully",
      "b",
      "be",
      "became",
      "because",
      "become",
      "becomes",
      "becoming",
      "been",
      "before",
      "beforehand",
      "behind",
      "being",
      "believe",
      "below",
      "beside",
      "besides",
      "best",
      "better",
      "between",
      "beyond",
      "both",
      "brief",
      "but",
      "by",
      "c",
      "c'mon",
      "c's",
      "came",
      "can",
      "can't",
      "cannot",
      "cant",
      "cause",
      "causes",
      "certain",
      "certainly",
      "changes",
      "clearly",
      "co",
      "com",
      "come",
      "comes",
      "concerning",
      "consequently",
      "consider",
      "considering",
      "contain",
      "containing",
      "contains",
      "corresponding",
      "could",
      "couldn't",
      "course",
      "currently",
      "d",
      "definitely",
      "described",
      "despite",
      "did",
      "didn't",
      "different",
      "do",
      "does",
      "doesn't",
      "doing",
      "don't",
      "done",
      "down",
      "downwards",
      "during",
      "e",
      "each",
      "edu",
      "eg",
      "eight",
      "either",
      "else",
      "elsewhere",
      "enough",
      "entirely",
      "especially",
      "et",
      "etc",
      "even",
      "ever",
      "every",
      "everybody",
      "everyone",
      "everything",
      "everywhere",
      "ex",
      "exactly",
      "example",
      "except",
      "f",
      "far",
      "few",
      "fifth",
      "first",
      "five",
      "followed",
      "following",
      "follows",
      "for",
      "former",
      "formerly",
      "forth",
      "four",
      "from",
      "further",
      "furthermore",
      "g",
      "get",
      "gets",
      "getting",
      "given",
      "gives",
      "go",
      "goes",
      "going",
      "gone",
      "got",
      "gotten",
      "greetings",
      "h",
      "had",
      "hadn't",
      "happens",
      "hardly",
      "has",
      "hasn't",
      "have",
      "haven't",
      "having",
      "he",
      "he's",
      "hello",
      "help",
      "hence",
      "her",
      "here",
      "here's",
      "hereafter",
      "hereby",
      "herein",
      "hereupon",
      "hers",
      "herself",
      "hi",
      "him",
      "himself",
      "his",
      "hither",
      "hopefully",
      "how",
      "howbeit",
      "however",
      "i",
      "i'd",
      "i'll",
      "i'm",
      "i've",
      "ie",
      "if",
      "ignored",
      "immediate",
      "in",
      "inasmuch",
      "inc",
      "indeed",
      "indicate",
      "indicated",
      "indicates",
      "inner",
      "insofar",
      "instead",
      "into",
      "inward",
      "is",
      "isn't",
      "it",
      "it'd",
      "it'll",
      "it's",
      "its",
      "itself",
      "j",
      "just",
      "k",
      "keep",
      "keeps",
      "kept",
      "know",
      "knows",
      "known",
      "l",
      "last",
      "lately",
      "later",
      "latter",
      "latterly",
      "least",
      "less",
      "lest",
      "let",
      "let's",
      "like",
      "liked",
      "likely",
      "little",
      "look",
      "looking",
      "looks",
      "ltd",
      "m",
      "mainly",
      "many",
      "may",
      "maybe",
      "me",
      "mean",
      "meanwhile",
      "merely",
      "might",
      "more",
      "moreover",
      "most",
      "mostly",
      "much",
      "must",
      "my",
      "myself",
      "n",
      "name",
      "namely",
      "nd",
      "near",
      "nearly",
      "necessary",
      "need",
      "needs",
      "neither",
      "never",
      "nevertheless",
      "new",
      "next",
      "nine",
      "no",
      "nobody",
      "non",
      "none",
      "noone",
      "nor",
      "normally",
      "not",
      "nothing",
      "novel",
      "now",
      "nowhere",
      "o",
      "obviously",
      "of",
      "off",
      "often",
      "oh",
      "ok",
      "okay",
      "old",
      "on",
      "once",
      "one",
      "ones",
      "only",
      "onto",
      "or",
      "other",
      "others",
      "otherwise",
      "ought",
      "our",
      "ours",
      "ourselves",
      "out",
      "outside",
      "over",
      "overall",
      "own",
      "p",
      "particular",
      "particularly",
      "per",
      "perhaps",
      "placed",
      "please",
      "plus",
      "possible",
      "presumably",
      "probably",
      "provides",
      "q",
      "que",
      "quite",
      "qv",
      "r",
      "rather",
      "rd",
      "re",
      "really",
      "reasonably",
      "regarding",
      "regardless",
      "regards",
      "relatively",
      "respectively",
      "right",
      "s",
      "said",
      "same",
      "saw",
      "say",
      "saying",
      "says",
      "second",
      "secondly",
      "see",
      "seeing",
      "seem",
      "seemed",
      "seeming",
      "seems",
      "seen",
      "self",
      "selves",
      "sensible",
      "sent",
      "serious",
      "seriously",
      "seven",
      "several",
      "shall",
      "she",
      "should",
      "shouldn't",
      "since",
      "six",
      "so",
      "some",
      "somebody",
      "somehow",
      "someone",
      "something",
      "sometime",
      "sometimes",
      "somewhat",
      "somewhere",
      "soon",
      "sorry",
      "specified",
      "specify",
      "specifying",
      "still",
      "sub",
      "such",
      "sup",
      "sure",
      "t",
      "t's",
      "take",
      "taken",
      "tell",
      "tends",
      "th",
      "than",
      "thank",
      "thanks",
      "thanx",
      "that",
      "that's",
      "thats",
      "the",
      "their",
      "theirs",
      "them",
      "themselves",
      "then",
      "thence",
      "there",
      "there's",
      "thereafter",
      "thereby",
      "therefore",
      "therein",
      "theres",
      "thereupon",
      "these",
      "they",
      "they'd",
      "they'll",
      "they're",
      "they've",
      "think",
      "third",
      "this",
      "thorough",
      "thoroughly",
      "those",
      "though",
      "three",
      "through",
      "throughout",
      "thru",
      "thus",
      "to",
      "together",
      "too",
      "took",
      "toward",
      "towards",
      "tried",
      "tries",
      "truly",
      "try",
      "trying",
      "twice",
      "two",
      "u",
      "un",
      "under",
      "unfortunately",
      "unless",
      "unlikely",
      "until",
      "unto",
      "up",
      "upon",
      "us",
      "use",
      "used",
      "useful",
      "uses",
      "using",
      "usually",
      "uucp",
      "v",
      "value",
      "various",
      "very",
      "via",
      "viz",
      "vs",
      "w",
      "want",
      "wants",
      "was",
      "wasn't",
      "way",
      "we",
      "we'd",
      "we'll",
      "we're",
      "we've",
      "welcome",
      "well",
      "went",
      "were",
      "weren't",
      "what",
      "what's",
      "whatever",
      "when",
      "whence",
      "whenever",
      "where",
      "where's",
      "whereafter",
      "whereas",
      "whereby",
      "wherein",
      "whereupon",
      "wherever",
      "whether",
      "which",
      "while",
      "whither",
      "who",
      "who's",
      "whoever",
      "whole",
      "whom",
      "whose",
      "why",
      "will",
      "willing",
      "wish",
      "with",
      "within",
      "without",
      "won't",
      "wonder",
      "would",
      "wouldn't",
      "x",
      "y",
      "yes",
      "yet",
      "you",
      "you'd",
      "you'll",
      "you're",
      "you've",
      "your",
      "yours",
      "yourself",
      "yourselves",
      "z",
      "zero"
    };
  }
}

class Esperanto implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "adiaŭ",
      "ajn",
      "al",
      "ankoraŭ",
      "antaŭ",
      "aŭ",
      "bonan",
      "bonvole",
      "bonvolu",
      "bv",
      "ci",
      "cia",
      "cian",
      "cin",
      "d-ro",
      "da",
      "de",
      "dek",
      "deka",
      "do",
      "doktor'",
      "doktoro",
      "du",
      "dua",
      "dum",
      "eble",
      "ekz",
      "ekzemple",
      "en",
      "estas",
      "estis",
      "estos",
      "estu",
      "estus",
      "eĉ",
      "f-no",
      "feliĉan",
      "for",
      "fraŭlino",
      "ha",
      "havas",
      "havis",
      "havos",
      "havu",
      "havus",
      "he",
      "ho",
      "hu",
      "ili",
      "ilia",
      "ilian",
      "ilin",
      "inter",
      "io",
      "ion",
      "iu",
      "iujn",
      "iun",
      "ja",
      "jam",
      "je",
      "jes",
      "k",
      "kaj",
      "ke",
      "kio",
      "kion",
      "kiu",
      "kiujn",
      "kiun",
      "kvankam",
      "kvar",
      "kvara",
      "kvazaŭ",
      "kvin",
      "kvina",
      "la",
      "li",
      "lia",
      "lian",
      "lin",
      "malantaŭ",
      "male",
      "malgraŭ",
      "mem",
      "mi",
      "mia",
      "mian",
      "min",
      "minus",
      "naŭ",
      "naŭa",
      "ne",
      "nek",
      "nenio",
      "nenion",
      "neniu",
      "neniun",
      "nepre",
      "ni",
      "nia",
      "nian",
      "nin",
      "nu",
      "nun",
      "nur",
      "ok",
      "oka",
      "oni",
      "onia",
      "onian",
      "onin",
      "plej",
      "pli",
      "plu",
      "plus",
      "por",
      "post",
      "preter",
      "s-no",
      "s-ro",
      "se",
      "sed",
      "sep",
      "sepa",
      "ses",
      "sesa",
      "si",
      "sia",
      "sian",
      "sin",
      "sinjor'",
      "sinjorino",
      "sinjoro",
      "sub",
      "super",
      "supren",
      "sur",
      "tamen",
      "tio",
      "tion",
      "tiu",
      "tiujn",
      "tiun",
      "tra",
      "tri",
      "tria",
      "tuj",
      "tute",
      "unu",
      "unua",
      "ve",
      "verŝajne",
      "vi",
      "via",
      "vian",
      "vin",
      "ĉi",
      "ĉio",
      "ĉion",
      "ĉiu",
      "ĉiujn",
      "ĉiun",
      "ĉu",
      "ĝi",
      "ĝia",
      "ĝian",
      "ĝin",
      "ĝis",
      "ĵus",
      "ŝi",
      "ŝia",
      "ŝin"
    };
  }
}

class Estonian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "aga",
      "ei",
      "et",
      "ja",
      "jah",
      "kas",
      "kui",
      "kõik",
      "ma",
      "me",
      "mida",
      "midagi",
      "mind",
      "minu",
      "mis",
      "mu",
      "mul",
      "mulle",
      "nad",
      "nii",
      "oled",
      "olen",
      "oli",
      "oma",
      "on",
      "pole",
      "sa",
      "seda",
      "see",
      "selle",
      "siin",
      "siis",
      "ta",
      "te",
      "ära"
    };
  }
}

class Finnish implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "aiemmin",
      "aika",
      "aikaa",
      "aikaan",
      "aikaisemmin",
      "aikaisin",
      "aikajen",
      "aikana",
      "aikoina",
      "aikoo",
      "aikovat",
      "aina",
      "ainakaan",
      "ainakin",
      "ainoa",
      "ainoat",
      "aiomme",
      "aion",
      "aiotte",
      "aist",
      "aivan",
      "ajan",
      "alas",
      "alemmas",
      "alkuisin",
      "alkuun",
      "alla",
      "alle",
      "aloitamme",
      "aloitan",
      "aloitat",
      "aloitatte",
      "aloitattivat",
      "aloitettava",
      "aloitettevaksi",
      "aloitettu",
      "aloitimme",
      "aloitin",
      "aloitit",
      "aloititte",
      "aloittaa",
      "aloittamatta",
      "aloitti",
      "aloittivat",
      "alta",
      "aluksi",
      "alussa",
      "alusta",
      "annettavaksi",
      "annetteva",
      "annettu",
      "ansiosta",
      "antaa",
      "antamatta",
      "antoi",
      "aoua",
      "apu",
      "asia",
      "asiaa",
      "asian",
      "asiasta",
      "asiat",
      "asioiden",
      "asioihin",
      "asioita",
      "asti",
      "avuksi",
      "avulla",
      "avun",
      "avutta",
      "edelle",
      "edelleen",
      "edellä",
      "edeltä",
      "edemmäs",
      "edes",
      "edessä",
      "edestä",
      "ehkä",
      "ei",
      "eikä",
      "eilen",
      "eivät",
      "eli",
      "ellei",
      "elleivät",
      "ellemme",
      "ellen",
      "ellet",
      "ellette",
      "emme",
      "en",
      "enemmän",
      "eniten",
      "ennen",
      "ensi",
      "ensimmäinen",
      "ensimmäiseksi",
      "ensimmäisen",
      "ensimmäisenä",
      "ensimmäiset",
      "ensimmäisiksi",
      "ensimmäisinä",
      "ensimmäisiä",
      "ensimmäistä",
      "ensin",
      "entinen",
      "entisen",
      "entisiä",
      "entisten",
      "entistä",
      "enää",
      "eri",
      "erittäin",
      "erityisesti",
      "eräiden",
      "eräs",
      "eräät",
      "esi",
      "esiin",
      "esillä",
      "esimerkiksi",
      "et",
      "eteen",
      "etenkin",
      "etessa",
      "ette",
      "ettei",
      "että",
      "haikki",
      "halua",
      "haluaa",
      "haluamatta",
      "haluamme",
      "haluan",
      "haluat",
      "haluatte",
      "haluavat",
      "halunnut",
      "halusi",
      "halusimme",
      "halusin",
      "halusit",
      "halusitte",
      "halusivat",
      "halutessa",
      "haluton",
      "he",
      "hei",
      "heidän",
      "heidät",
      "heihin",
      "heille",
      "heillä",
      "heiltä",
      "heissä",
      "heistä",
      "heitä",
      "helposti",
      "heti",
      "hetkellä",
      "hieman",
      "hitaasti",
      "hoikein",
      "huolimatta",
      "huomenna",
      "hyvien",
      "hyviin",
      "hyviksi",
      "hyville",
      "hyviltä",
      "hyvin",
      "hyvinä",
      "hyvissä",
      "hyvistä",
      "hyviä",
      "hyvä",
      "hyvät",
      "hyvää",
      "hän",
      "häneen",
      "hänelle",
      "hänellä",
      "häneltä",
      "hänen",
      "hänessä",
      "hänestä",
      "hänet",
      "häntä",
      "ihan",
      "ilman",
      "ilmeisesti",
      "itse",
      "itsensä",
      "itseään",
      "ja",
      "jo",
      "johon",
      "joiden",
      "joihin",
      "joiksi",
      "joilla",
      "joille",
      "joilta",
      "joina",
      "joissa",
      "joista",
      "joita",
      "joka",
      "jokainen",
      "jokin",
      "joko",
      "joksi",
      "joku",
      "jolla",
      "jolle",
      "jolloin",
      "jolta",
      "jompikumpi",
      "jona",
      "jonka",
      "jonkin",
      "jonne",
      "joo",
      "jopa",
      "jos",
      "joskus",
      "jossa",
      "josta",
      "jota",
      "jotain",
      "joten",
      "jotenkin",
      "jotenkuten",
      "jotka",
      "jotta",
      "jouduimme",
      "jouduin",
      "jouduit",
      "jouduitte",
      "joudumme",
      "joudun",
      "joudutte",
      "joukkoon",
      "joukossa",
      "joukosta",
      "joutua",
      "joutui",
      "joutuivat",
      "joutumaan",
      "joutuu",
      "joutuvat",
      "juuri",
      "jälkeen",
      "jälleen",
      "jää",
      "kahdeksan",
      "kahdeksannen",
      "kahdella",
      "kahdelle",
      "kahdelta",
      "kahden",
      "kahdessa",
      "kahdesta",
      "kahta",
      "kahteen",
      "kai",
      "kaiken",
      "kaikille",
      "kaikilta",
      "kaikkea",
      "kaikki",
      "kaikkia",
      "kaikkiaan",
      "kaikkialla",
      "kaikkialle",
      "kaikkialta",
      "kaikkien",
      "kaikkin",
      "kaksi",
      "kannalta",
      "kannattaa",
      "kanssa",
      "kanssaan",
      "kanssamme",
      "kanssani",
      "kanssanne",
      "kanssasi",
      "kauan",
      "kauemmas",
      "kaukana",
      "kautta",
      "kehen",
      "keiden",
      "keihin",
      "keiksi",
      "keille",
      "keillä",
      "keiltä",
      "keinä",
      "keissä",
      "keistä",
      "keitten",
      "keittä",
      "keitä",
      "keneen",
      "keneksi",
      "kenelle",
      "kenellä",
      "keneltä",
      "kenen",
      "kenenä",
      "kenessä",
      "kenestä",
      "kenet",
      "kenettä",
      "kennessästä",
      "kenties",
      "kerran",
      "kerta",
      "kertaa",
      "keskellä",
      "kesken",
      "keskimäärin",
      "ketkä",
      "ketä",
      "kiitos",
      "kohti",
      "koko",
      "kokonaan",
      "kolmas",
      "kolme",
      "kolmen",
      "kolmesti",
      "koska",
      "koskaan",
      "kovin",
      "kuin",
      "kuinka",
      "kuinkan",
      "kuitenkaan",
      "kuitenkin",
      "kuka",
      "kukaan",
      "kukin",
      "kukka",
      "kumpainen",
      "kumpainenkaan",
      "kumpi",
      "kumpikaan",
      "kumpikin",
      "kun",
      "kuten",
      "kuuden",
      "kuusi",
      "kuutta",
      "kylliksi",
      "kyllä",
      "kymmenen",
      "kyse",
      "liian",
      "liki",
      "lisäksi",
      "lisää",
      "lla",
      "luo",
      "luona",
      "lähekkäin",
      "lähelle",
      "lähellä",
      "läheltä",
      "lähemmäs",
      "lähes",
      "lähinnä",
      "lähtien",
      "läpi",
      "mahdollisimman",
      "mahdollista",
      "me",
      "meidän",
      "meidät",
      "meihin",
      "meille",
      "meillä",
      "meiltä",
      "meissä",
      "meistä",
      "meitä",
      "melkein",
      "melko",
      "menee",
      "meneet",
      "menemme",
      "menen",
      "menet",
      "menette",
      "menevät",
      "meni",
      "menimme",
      "menin",
      "menit",
      "menivät",
      "mennessä",
      "mennyt",
      "menossa",
      "mihin",
      "mikin",
      "miksi",
      "mikä",
      "mikäli",
      "mikään",
      "mille",
      "milloin",
      "milloinkan",
      "millä",
      "miltä",
      "minkä",
      "minne",
      "minua",
      "minulla",
      "minulle",
      "minulta",
      "minun",
      "minussa",
      "minusta",
      "minut",
      "minuun",
      "minä",
      "missä",
      "mistä",
      "miten",
      "mitkä",
      "mitä",
      "mitään",
      "moi",
      "molemmat",
      "mones",
      "monesti",
      "monet",
      "moni",
      "moniaalla",
      "moniaalle",
      "moniaalta",
      "monta",
      "muassa",
      "muiden",
      "muita",
      "muka",
      "mukaan",
      "mukaansa",
      "mukana",
      "mutta",
      "muu",
      "muualla",
      "muualle",
      "muualta",
      "muuanne",
      "muulloin",
      "muun",
      "muut",
      "muuta",
      "muutama",
      "muutaman",
      "muuten",
      "myöhemmin",
      "myös",
      "myöskin",
      "myöskään",
      "myötä",
      "ne",
      "neljä",
      "neljän",
      "neljää",
      "niiden",
      "niihin",
      "niiksi",
      "niille",
      "niillä",
      "niiltä",
      "niin",
      "niinä",
      "niissä",
      "niistä",
      "niitä",
      "noiden",
      "noihin",
      "noiksi",
      "noilla",
      "noille",
      "noilta",
      "noin",
      "noina",
      "noissa",
      "noista",
      "noita",
      "nopeammin",
      "nopeasti",
      "nopeiten",
      "nro",
      "nuo",
      "nyt",
      "näiden",
      "näihin",
      "näiksi",
      "näille",
      "näillä",
      "näiltä",
      "näin",
      "näinä",
      "näissä",
      "näissähin",
      "näissälle",
      "näissältä",
      "näissästä",
      "näistä",
      "näitä",
      "nämä",
      "ohi",
      "oikea",
      "oikealla",
      "oikein",
      "ole",
      "olemme",
      "olen",
      "olet",
      "olette",
      "oleva",
      "olevan",
      "olevat",
      "oli",
      "olimme",
      "olin",
      "olisi",
      "olisimme",
      "olisin",
      "olisit",
      "olisitte",
      "olisivat",
      "olit",
      "olitte",
      "olivat",
      "olla",
      "olleet",
      "olli",
      "ollut",
      "oma",
      "omaa",
      "omaan",
      "omaksi",
      "omalle",
      "omalta",
      "oman",
      "omassa",
      "omat",
      "omia",
      "omien",
      "omiin",
      "omiksi",
      "omille",
      "omilta",
      "omissa",
      "omista",
      "on",
      "onkin",
      "onko",
      "ovat",
      "paikoittain",
      "paitsi",
      "pakosti",
      "paljon",
      "paremmin",
      "parempi",
      "parhaillaan",
      "parhaiten",
      "perusteella",
      "peräti",
      "pian",
      "pieneen",
      "pieneksi",
      "pienelle",
      "pienellä",
      "pieneltä",
      "pienempi",
      "pienestä",
      "pieni",
      "pienin",
      "poikki",
      "puolesta",
      "puolestaan",
      "päälle",
      "runsaasti",
      "saakka",
      "sadam",
      "sama",
      "samaa",
      "samaan",
      "samalla",
      "samallalta",
      "samallassa",
      "samallasta",
      "saman",
      "samat",
      "samoin",
      "sata",
      "sataa",
      "satojen",
      "se",
      "seitsemän",
      "sekä",
      "sen",
      "seuraavat",
      "siellä",
      "sieltä",
      "siihen",
      "siinä",
      "siis",
      "siitä",
      "sijaan",
      "siksi",
      "sille",
      "silloin",
      "sillä",
      "silti",
      "siltä",
      "sinne",
      "sinua",
      "sinulla",
      "sinulle",
      "sinulta",
      "sinun",
      "sinussa",
      "sinusta",
      "sinut",
      "sinuun",
      "sinä",
      "sisäkkäin",
      "sisällä",
      "siten",
      "sitten",
      "sitä",
      "ssa",
      "sta",
      "suoraan",
      "suuntaan",
      "suuren",
      "suuret",
      "suuri",
      "suuria",
      "suurin",
      "suurten",
      "taa",
      "taas",
      "taemmas",
      "tahansa",
      "tai",
      "takaa",
      "takaisin",
      "takana",
      "takia",
      "tallä",
      "tapauksessa",
      "tarpeeksi",
      "tavalla",
      "tavoitteena",
      "te",
      "teidän",
      "teidät",
      "teihin",
      "teille",
      "teillä",
      "teiltä",
      "teissä",
      "teistä",
      "teitä",
      "tietysti",
      "todella",
      "toinen",
      "toisaalla",
      "toisaalle",
      "toisaalta",
      "toiseen",
      "toiseksi",
      "toisella",
      "toiselle",
      "toiselta",
      "toisemme",
      "toisen",
      "toisensa",
      "toisessa",
      "toisesta",
      "toista",
      "toistaiseksi",
      "toki",
      "tosin",
      "tuhannen",
      "tuhat",
      "tule",
      "tulee",
      "tulemme",
      "tulen",
      "tulet",
      "tulette",
      "tulevat",
      "tulimme",
      "tulin",
      "tulisi",
      "tulisimme",
      "tulisin",
      "tulisit",
      "tulisitte",
      "tulisivat",
      "tulit",
      "tulitte",
      "tulivat",
      "tulla",
      "tulleet",
      "tullut",
      "tuntuu",
      "tuo",
      "tuohon",
      "tuoksi",
      "tuolla",
      "tuolle",
      "tuolloin",
      "tuolta",
      "tuon",
      "tuona",
      "tuonne",
      "tuossa",
      "tuosta",
      "tuota",
      "tuotä",
      "tuskin",
      "tykö",
      "tähän",
      "täksi",
      "tälle",
      "tällä",
      "tällöin",
      "tältä",
      "tämä",
      "tämän",
      "tänne",
      "tänä",
      "tänään",
      "tässä",
      "tästä",
      "täten",
      "tätä",
      "täysin",
      "täytyvät",
      "täytyy",
      "täällä",
      "täältä",
      "ulkopuolella",
      "usea",
      "useasti",
      "useimmiten",
      "usein",
      "useita",
      "uudeksi",
      "uudelleen",
      "uuden",
      "uudet",
      "uusi",
      "uusia",
      "uusien",
      "uusinta",
      "uuteen",
      "uutta",
      "vaan",
      "vahemmän",
      "vai",
      "vaiheessa",
      "vaikea",
      "vaikean",
      "vaikeat",
      "vaikeilla",
      "vaikeille",
      "vaikeilta",
      "vaikeissa",
      "vaikeista",
      "vaikka",
      "vain",
      "varmasti",
      "varsin",
      "varsinkin",
      "varten",
      "vasen",
      "vasenmalla",
      "vasta",
      "vastaan",
      "vastakkain",
      "vastan",
      "verran",
      "vielä",
      "vierekkäin",
      "vieressä",
      "vieri",
      "viiden",
      "viime",
      "viimeinen",
      "viimeisen",
      "viimeksi",
      "viisi",
      "voi",
      "voidaan",
      "voimme",
      "voin",
      "voisi",
      "voit",
      "voitte",
      "voivat",
      "vuoden",
      "vuoksi",
      "vuosi",
      "vuosien",
      "vuosina",
      "vuotta",
      "vähemmän",
      "vähintään",
      "vähiten",
      "vähän",
      "välillä",
      "yhdeksän",
      "yhden",
      "yhdessä",
      "yhteen",
      "yhteensä",
      "yhteydessä",
      "yhteyteen",
      "yhtä",
      "yhtäälle",
      "yhtäällä",
      "yhtäältä",
      "yhtään",
      "yhä",
      "yksi",
      "yksin",
      "yksittäin",
      "yleensä",
      "ylemmäs",
      "yli",
      "ylös",
      "ympäri",
      "älköön",
      "älä"
    };
  }
}

class French implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "abord",
      "absolument",
      "afin",
      "ah",
      "ai",
      "aie",
      "aient",
      "aies",
      "ailleurs",
      "ainsi",
      "ait",
      "allaient",
      "allo",
      "allons",
      "allô",
      "alors",
      "anterieur",
      "anterieure",
      "anterieures",
      "apres",
      "après",
      "as",
      "assez",
      "attendu",
      "au",
      "aucun",
      "aucune",
      "aucuns",
      "aujourd",
      "aujourd'hui",
      "aupres",
      "auquel",
      "aura",
      "aurai",
      "auraient",
      "aurais",
      "aurait",
      "auras",
      "aurez",
      "auriez",
      "aurions",
      "aurons",
      "auront",
      "aussi",
      "autre",
      "autrefois",
      "autrement",
      "autres",
      "autrui",
      "aux",
      "auxquelles",
      "auxquels",
      "avaient",
      "avais",
      "avait",
      "avant",
      "avec",
      "avez",
      "aviez",
      "avions",
      "avoir",
      "avons",
      "ayant",
      "ayez",
      "ayons",
      "b",
      "bah",
      "bas",
      "basee",
      "bat",
      "beau",
      "beaucoup",
      "bien",
      "bigre",
      "bon",
      "boum",
      "bravo",
      "brrr",
      "c",
      "car",
      "ce",
      "ceci",
      "cela",
      "celle",
      "celle-ci",
      "celle-là",
      "celles",
      "celles-ci",
      "celles-là",
      "celui",
      "celui-ci",
      "celui-là",
      "celà",
      "cent",
      "cependant",
      "certain",
      "certaine",
      "certaines",
      "certains",
      "certes",
      "ces",
      "cet",
      "cette",
      "ceux",
      "ceux-ci",
      "ceux-là",
      "chacun",
      "chacune",
      "chaque",
      "cher",
      "chers",
      "chez",
      "chiche",
      "chut",
      "chère",
      "chères",
      "ci",
      "cinq",
      "cinquantaine",
      "cinquante",
      "cinquantième",
      "cinquième",
      "clac",
      "clic",
      "combien",
      "comme",
      "comment",
      "comparable",
      "comparables",
      "compris",
      "concernant",
      "contre",
      "couic",
      "crac",
      "d",
      "da",
      "dans",
      "de",
      "debout",
      "dedans",
      "dehors",
      "deja",
      "delà",
      "depuis",
      "dernier",
      "derniere",
      "derriere",
      "derrière",
      "des",
      "desormais",
      "desquelles",
      "desquels",
      "dessous",
      "dessus",
      "deux",
      "deuxième",
      "deuxièmement",
      "devant",
      "devers",
      "devra",
      "devrait",
      "different",
      "differentes",
      "differents",
      "différent",
      "différente",
      "différentes",
      "différents",
      "dire",
      "directe",
      "directement",
      "dit",
      "dite",
      "dits",
      "divers",
      "diverse",
      "diverses",
      "dix",
      "dix-huit",
      "dix-neuf",
      "dix-sept",
      "dixième",
      "doit",
      "doivent",
      "donc",
      "dont",
      "dos",
      "douze",
      "douzième",
      "dring",
      "droite",
      "du",
      "duquel",
      "durant",
      "dès",
      "début",
      "désormais",
      "e",
      "effet",
      "egale",
      "egalement",
      "egales",
      "eh",
      "elle",
      "elle-même",
      "elles",
      "elles-mêmes",
      "en",
      "encore",
      "enfin",
      "entre",
      "envers",
      "environ",
      "es",
      "essai",
      "est",
      "et",
      "etant",
      "etc",
      "etre",
      "eu",
      "eue",
      "eues",
      "euh",
      "eurent",
      "eus",
      "eusse",
      "eussent",
      "eusses",
      "eussiez",
      "eussions",
      "eut",
      "eux",
      "eux-mêmes",
      "exactement",
      "excepté",
      "extenso",
      "exterieur",
      "eûmes",
      "eût",
      "eûtes",
      "f",
      "fais",
      "faisaient",
      "faisant",
      "fait",
      "faites",
      "façon",
      "feront",
      "fi",
      "flac",
      "floc",
      "fois",
      "font",
      "force",
      "furent",
      "fus",
      "fusse",
      "fussent",
      "fusses",
      "fussiez",
      "fussions",
      "fut",
      "fûmes",
      "fût",
      "fûtes",
      "g",
      "gens",
      "h",
      "ha",
      "haut",
      "hein",
      "hem",
      "hep",
      "hi",
      "ho",
      "holà",
      "hop",
      "hormis",
      "hors",
      "hou",
      "houp",
      "hue",
      "hui",
      "huit",
      "huitième",
      "hum",
      "hurrah",
      "hé",
      "hélas",
      "i",
      "ici",
      "il",
      "ils",
      "importe",
      "j",
      "je",
      "jusqu",
      "jusque",
      "juste",
      "k",
      "l",
      "la",
      "laisser",
      "laquelle",
      "las",
      "le",
      "lequel",
      "les",
      "lesquelles",
      "lesquels",
      "leur",
      "leurs",
      "longtemps",
      "lors",
      "lorsque",
      "lui",
      "lui-meme",
      "lui-même",
      "là",
      "lès",
      "m",
      "ma",
      "maint",
      "maintenant",
      "mais",
      "malgre",
      "malgré",
      "maximale",
      "me",
      "meme",
      "memes",
      "merci",
      "mes",
      "mien",
      "mienne",
      "miennes",
      "miens",
      "mille",
      "mince",
      "mine",
      "minimale",
      "moi",
      "moi-meme",
      "moi-même",
      "moindres",
      "moins",
      "mon",
      "mot",
      "moyennant",
      "multiple",
      "multiples",
      "même",
      "mêmes",
      "n",
      "na",
      "naturel",
      "naturelle",
      "naturelles",
      "ne",
      "neanmoins",
      "necessaire",
      "necessairement",
      "neuf",
      "neuvième",
      "ni",
      "nombreuses",
      "nombreux",
      "nommés",
      "non",
      "nos",
      "notamment",
      "notre",
      "nous",
      "nous-mêmes",
      "nouveau",
      "nouveaux",
      "nul",
      "néanmoins",
      "nôtre",
      "nôtres",
      "o",
      "oh",
      "ohé",
      "ollé",
      "olé",
      "on",
      "ont",
      "onze",
      "onzième",
      "ore",
      "ou",
      "ouf",
      "ouias",
      "oust",
      "ouste",
      "outre",
      "ouvert",
      "ouverte",
      "ouverts",
      "o|",
      "où",
      "p",
      "paf",
      "pan",
      "par",
      "parce",
      "parfois",
      "parle",
      "parlent",
      "parler",
      "parmi",
      "parole",
      "parseme",
      "partant",
      "particulier",
      "particulière",
      "particulièrement",
      "pas",
      "passé",
      "pendant",
      "pense",
      "permet",
      "personne",
      "personnes",
      "peu",
      "peut",
      "peuvent",
      "peux",
      "pff",
      "pfft",
      "pfut",
      "pif",
      "pire",
      "pièce",
      "plein",
      "plouf",
      "plupart",
      "plus",
      "plusieurs",
      "plutôt",
      "possessif",
      "possessifs",
      "possible",
      "possibles",
      "pouah",
      "pour",
      "pourquoi",
      "pourrais",
      "pourrait",
      "pouvait",
      "prealable",
      "precisement",
      "premier",
      "première",
      "premièrement",
      "pres",
      "probable",
      "probante",
      "procedant",
      "proche",
      "près",
      "psitt",
      "pu",
      "puis",
      "puisque",
      "pur",
      "pure",
      "q",
      "qu",
      "quand",
      "quant",
      "quant-à-soi",
      "quanta",
      "quarante",
      "quatorze",
      "quatre",
      "quatre-vingt",
      "quatrième",
      "quatrièmement",
      "que",
      "quel",
      "quelconque",
      "quelle",
      "quelles",
      "quelqu'un",
      "quelque",
      "quelques",
      "quels",
      "qui",
      "quiconque",
      "quinze",
      "quoi",
      "quoique",
      "r",
      "rare",
      "rarement",
      "rares",
      "relative",
      "relativement",
      "remarquable",
      "rend",
      "rendre",
      "restant",
      "reste",
      "restent",
      "restrictif",
      "retour",
      "revoici",
      "revoilà",
      "rien",
      "s",
      "sa",
      "sacrebleu",
      "sait",
      "sans",
      "sapristi",
      "sauf",
      "se",
      "sein",
      "seize",
      "selon",
      "semblable",
      "semblaient",
      "semble",
      "semblent",
      "sent",
      "sept",
      "septième",
      "sera",
      "serai",
      "seraient",
      "serais",
      "serait",
      "seras",
      "serez",
      "seriez",
      "serions",
      "serons",
      "seront",
      "ses",
      "seul",
      "seule",
      "seulement",
      "si",
      "sien",
      "sienne",
      "siennes",
      "siens",
      "sinon",
      "six",
      "sixième",
      "soi",
      "soi-même",
      "soient",
      "sois",
      "soit",
      "soixante",
      "sommes",
      "son",
      "sont",
      "sous",
      "souvent",
      "soyez",
      "soyons",
      "specifique",
      "specifiques",
      "speculatif",
      "stop",
      "strictement",
      "subtiles",
      "suffisant",
      "suffisante",
      "suffit",
      "suis",
      "suit",
      "suivant",
      "suivante",
      "suivantes",
      "suivants",
      "suivre",
      "sujet",
      "superpose",
      "sur",
      "surtout",
      "t",
      "ta",
      "tac",
      "tandis",
      "tant",
      "tardive",
      "te",
      "tel",
      "telle",
      "tellement",
      "telles",
      "tels",
      "tenant",
      "tend",
      "tenir",
      "tente",
      "tes",
      "tic",
      "tien",
      "tienne",
      "tiennes",
      "tiens",
      "toc",
      "toi",
      "toi-même",
      "ton",
      "touchant",
      "toujours",
      "tous",
      "tout",
      "toute",
      "toutefois",
      "toutes",
      "treize",
      "trente",
      "tres",
      "trois",
      "troisième",
      "troisièmement",
      "trop",
      "très",
      "tsoin",
      "tsouin",
      "tu",
      "té",
      "u",
      "un",
      "une",
      "unes",
      "uniformement",
      "unique",
      "uniques",
      "uns",
      "v",
      "va",
      "vais",
      "valeur",
      "vas",
      "vers",
      "via",
      "vif",
      "vifs",
      "vingt",
      "vivat",
      "vive",
      "vives",
      "vlan",
      "voici",
      "voie",
      "voient",
      "voilà",
      "vont",
      "vos",
      "votre",
      "vous",
      "vous-mêmes",
      "vu",
      "vé",
      "vôtre",
      "vôtres",
      "w",
      "x",
      "y",
      "z",
      "zut",
      "à",
      "â",
      "ça",
      "ès",
      "étaient",
      "étais",
      "était",
      "étant",
      "état",
      "étiez",
      "étions",
      "été",
      "étée",
      "étées",
      "étés",
      "êtes",
      "être",
      "ô"
    };
  }
}

class Galician implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "alí",
      "ao",
      "aos",
      "aquel",
      "aquela",
      "aquelas",
      "aqueles",
      "aquilo",
      "aquí",
      "as",
      "así",
      "aínda",
      "ben",
      "cando",
      "che",
      "co",
      "coa",
      "coas",
      "comigo",
      "con",
      "connosco",
      "contigo",
      "convosco",
      "cos",
      "cun",
      "cunha",
      "cunhas",
      "cuns",
      "da",
      "dalgunha",
      "dalgunhas",
      "dalgún",
      "dalgúns",
      "das",
      "de",
      "del",
      "dela",
      "delas",
      "deles",
      "desde",
      "deste",
      "do",
      "dos",
      "dun",
      "dunha",
      "dunhas",
      "duns",
      "e",
      "el",
      "ela",
      "elas",
      "eles",
      "en",
      "era",
      "eran",
      "esa",
      "esas",
      "ese",
      "eses",
      "esta",
      "estaba",
      "estar",
      "este",
      "estes",
      "estiven",
      "estou",
      "está",
      "están",
      "eu",
      "facer",
      "foi",
      "foron",
      "fun",
      "había",
      "hai",
      "iso",
      "isto",
      "la",
      "las",
      "lle",
      "lles",
      "lo",
      "los",
      "mais",
      "me",
      "meu",
      "meus",
      "min",
      "miña",
      "miñas",
      "moi",
      "na",
      "nas",
      "neste",
      "nin",
      "no",
      "non",
      "nos",
      "nosa",
      "nosas",
      "noso",
      "nosos",
      "nun",
      "nunha",
      "nunhas",
      "nuns",
      "nós",
      "o",
      "os",
      "ou",
      "para",
      "pero",
      "pode",
      "pois",
      "pola",
      "polas",
      "polo",
      "polos",
      "por",
      "que",
      "se",
      "senón",
      "ser",
      "seu",
      "seus",
      "sexa",
      "sido",
      "sobre",
      "súa",
      "súas",
      "tamén",
      "tan",
      "te",
      "ten",
      "ter",
      "teu",
      "teus",
      "teñen",
      "teño",
      "ti",
      "tido",
      "tiven",
      "tiña",
      "túa",
      "túas",
      "un",
      "unha",
      "unhas",
      "uns",
      "vos",
      "vosa",
      "vosas",
      "voso",
      "vosos",
      "vós",
      "á",
      "é",
      "ó",
      "ós"
    };
  }
}

class German implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "ab",
      "aber",
      "ach",
      "acht",
      "achte",
      "achten",
      "achter",
      "achtes",
      "ag",
      "alle",
      "allein",
      "allem",
      "allen",
      "aller",
      "allerdings",
      "alles",
      "allgemeinen",
      "als",
      "also",
      "am",
      "an",
      "ander",
      "andere",
      "anderem",
      "anderen",
      "anderer",
      "anderes",
      "anderm",
      "andern",
      "anderr",
      "anders",
      "au",
      "auch",
      "auf",
      "aus",
      "ausser",
      "ausserdem",
      "außer",
      "außerdem",
      "b",
      "bald",
      "bei",
      "beide",
      "beiden",
      "beim",
      "beispiel",
      "bekannt",
      "bereits",
      "besonders",
      "besser",
      "besten",
      "bin",
      "bis",
      "bisher",
      "bist",
      "c",
      "d",
      "d.h",
      "da",
      "dabei",
      "dadurch",
      "dafür",
      "dagegen",
      "daher",
      "dahin",
      "dahinter",
      "damals",
      "damit",
      "danach",
      "daneben",
      "dank",
      "dann",
      "daran",
      "darauf",
      "daraus",
      "darf",
      "darfst",
      "darin",
      "darum",
      "darunter",
      "darüber",
      "das",
      "dasein",
      "daselbst",
      "dass",
      "dasselbe",
      "davon",
      "davor",
      "dazu",
      "dazwischen",
      "daß",
      "dein",
      "deine",
      "deinem",
      "deinen",
      "deiner",
      "deines",
      "dem",
      "dementsprechend",
      "demgegenüber",
      "demgemäss",
      "demgemäß",
      "demselben",
      "demzufolge",
      "den",
      "denen",
      "denn",
      "denselben",
      "der",
      "deren",
      "derer",
      "derjenige",
      "derjenigen",
      "dermassen",
      "dermaßen",
      "derselbe",
      "derselben",
      "des",
      "deshalb",
      "desselben",
      "dessen",
      "deswegen",
      "dich",
      "die",
      "diejenige",
      "diejenigen",
      "dies",
      "diese",
      "dieselbe",
      "dieselben",
      "diesem",
      "diesen",
      "dieser",
      "dieses",
      "dir",
      "doch",
      "dort",
      "drei",
      "drin",
      "dritte",
      "dritten",
      "dritter",
      "drittes",
      "du",
      "durch",
      "durchaus",
      "durfte",
      "durften",
      "dürfen",
      "dürft",
      "e",
      "eben",
      "ebenso",
      "ehrlich",
      "ei",
      "ei,",
      "eigen",
      "eigene",
      "eigenen",
      "eigener",
      "eigenes",
      "ein",
      "einander",
      "eine",
      "einem",
      "einen",
      "einer",
      "eines",
      "einig",
      "einige",
      "einigem",
      "einigen",
      "einiger",
      "einiges",
      "einmal",
      "eins",
      "elf",
      "en",
      "ende",
      "endlich",
      "entweder",
      "er",
      "ernst",
      "erst",
      "erste",
      "ersten",
      "erster",
      "erstes",
      "es",
      "etwa",
      "etwas",
      "euch",
      "euer",
      "eure",
      "eurem",
      "euren",
      "eurer",
      "eures",
      "f",
      "folgende",
      "früher",
      "fünf",
      "fünfte",
      "fünften",
      "fünfter",
      "fünftes",
      "für",
      "g",
      "gab",
      "ganz",
      "ganze",
      "ganzen",
      "ganzer",
      "ganzes",
      "gar",
      "gedurft",
      "gegen",
      "gegenüber",
      "gehabt",
      "gehen",
      "geht",
      "gekannt",
      "gekonnt",
      "gemacht",
      "gemocht",
      "gemusst",
      "genug",
      "gerade",
      "gern",
      "gesagt",
      "geschweige",
      "gewesen",
      "gewollt",
      "geworden",
      "gibt",
      "ging",
      "gleich",
      "gott",
      "gross",
      "grosse",
      "grossen",
      "grosser",
      "grosses",
      "groß",
      "große",
      "großen",
      "großer",
      "großes",
      "gut",
      "gute",
      "guter",
      "gutes",
      "h",
      "hab",
      "habe",
      "haben",
      "habt",
      "hast",
      "hat",
      "hatte",
      "hatten",
      "hattest",
      "hattet",
      "heisst",
      "her",
      "heute",
      "hier",
      "hin",
      "hinter",
      "hoch",
      "hätte",
      "hätten",
      "i",
      "ich",
      "ihm",
      "ihn",
      "ihnen",
      "ihr",
      "ihre",
      "ihrem",
      "ihren",
      "ihrer",
      "ihres",
      "im",
      "immer",
      "in",
      "indem",
      "infolgedessen",
      "ins",
      "irgend",
      "ist",
      "j",
      "ja",
      "jahr",
      "jahre",
      "jahren",
      "je",
      "jede",
      "jedem",
      "jeden",
      "jeder",
      "jedermann",
      "jedermanns",
      "jedes",
      "jedoch",
      "jemand",
      "jemandem",
      "jemanden",
      "jene",
      "jenem",
      "jenen",
      "jener",
      "jenes",
      "jetzt",
      "k",
      "kam",
      "kann",
      "kannst",
      "kaum",
      "kein",
      "keine",
      "keinem",
      "keinen",
      "keiner",
      "keines",
      "kleine",
      "kleinen",
      "kleiner",
      "kleines",
      "kommen",
      "kommt",
      "konnte",
      "konnten",
      "kurz",
      "können",
      "könnt",
      "könnte",
      "l",
      "lang",
      "lange",
      "leicht",
      "leide",
      "lieber",
      "los",
      "m",
      "machen",
      "macht",
      "machte",
      "mag",
      "magst",
      "mahn",
      "mal",
      "man",
      "manche",
      "manchem",
      "manchen",
      "mancher",
      "manches",
      "mann",
      "mehr",
      "mein",
      "meine",
      "meinem",
      "meinen",
      "meiner",
      "meines",
      "mensch",
      "menschen",
      "mich",
      "mir",
      "mit",
      "mittel",
      "mochte",
      "mochten",
      "morgen",
      "muss",
      "musst",
      "musste",
      "mussten",
      "muß",
      "mußt",
      "möchte",
      "mögen",
      "möglich",
      "mögt",
      "müssen",
      "müsst",
      "müßt",
      "n",
      "na",
      "nach",
      "nachdem",
      "nahm",
      "natürlich",
      "neben",
      "nein",
      "neue",
      "neuen",
      "neun",
      "neunte",
      "neunten",
      "neunter",
      "neuntes",
      "nicht",
      "nichts",
      "nie",
      "niemand",
      "niemandem",
      "niemanden",
      "noch",
      "nun",
      "nur",
      "o",
      "ob",
      "oben",
      "oder",
      "offen",
      "oft",
      "ohne",
      "ordnung",
      "p",
      "q",
      "r",
      "recht",
      "rechte",
      "rechten",
      "rechter",
      "rechtes",
      "richtig",
      "rund",
      "s",
      "sa",
      "sache",
      "sagt",
      "sagte",
      "sah",
      "satt",
      "schlecht",
      "schluss",
      "schon",
      "sechs",
      "sechste",
      "sechsten",
      "sechster",
      "sechstes",
      "sehr",
      "sei",
      "seid",
      "seien",
      "sein",
      "seine",
      "seinem",
      "seinen",
      "seiner",
      "seines",
      "seit",
      "seitdem",
      "selbst",
      "sich",
      "sie",
      "sieben",
      "siebente",
      "siebenten",
      "siebenter",
      "siebentes",
      "sind",
      "so",
      "solang",
      "solche",
      "solchem",
      "solchen",
      "solcher",
      "solches",
      "soll",
      "sollen",
      "sollst",
      "sollt",
      "sollte",
      "sollten",
      "sondern",
      "sonst",
      "soweit",
      "sowie",
      "später",
      "startseite",
      "statt",
      "steht",
      "suche",
      "t",
      "tag",
      "tage",
      "tagen",
      "tat",
      "teil",
      "tel",
      "tritt",
      "trotzdem",
      "tun",
      "u",
      "uhr",
      "um",
      "und",
      "und?",
      "uns",
      "unse",
      "unsem",
      "unsen",
      "unser",
      "unsere",
      "unserer",
      "unses",
      "unter",
      "v",
      "vergangenen",
      "viel",
      "viele",
      "vielem",
      "vielen",
      "vielleicht",
      "vier",
      "vierte",
      "vierten",
      "vierter",
      "viertes",
      "vom",
      "von",
      "vor",
      "w",
      "wahr?",
      "wann",
      "war",
      "waren",
      "warst",
      "wart",
      "warum",
      "was",
      "weg",
      "wegen",
      "weil",
      "weit",
      "weiter",
      "weitere",
      "weiteren",
      "weiteres",
      "welche",
      "welchem",
      "welchen",
      "welcher",
      "welches",
      "wem",
      "wen",
      "wenig",
      "wenige",
      "weniger",
      "weniges",
      "wenigstens",
      "wenn",
      "wer",
      "werde",
      "werden",
      "werdet",
      "weshalb",
      "wessen",
      "wie",
      "wieder",
      "wieso",
      "will",
      "willst",
      "wir",
      "wird",
      "wirklich",
      "wirst",
      "wissen",
      "wo",
      "woher",
      "wohin",
      "wohl",
      "wollen",
      "wollt",
      "wollte",
      "wollten",
      "worden",
      "wurde",
      "wurden",
      "während",
      "währenddem",
      "währenddessen",
      "wäre",
      "würde",
      "würden",
      "x",
      "y",
      "z",
      "z.b",
      "zehn",
      "zehnte",
      "zehnten",
      "zehnter",
      "zehntes",
      "zeit",
      "zu",
      "zuerst",
      "zugleich",
      "zum",
      "zunächst",
      "zur",
      "zurück",
      "zusammen",
      "zwanzig",
      "zwar",
      "zwei",
      "zweite",
      "zweiten",
      "zweiter",
      "zweites",
      "zwischen",
      "zwölf",
      "über",
      "überhaupt",
      "übrigens"
    };
  }
}

class Greek implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "αλλα",
      "αν",
      "αντι",
      "απο",
      "αυτα",
      "αυτεσ",
      "αυτη",
      "αυτο",
      "αυτοι",
      "αυτοσ",
      "αυτουσ",
      "αυτων",
      "αἱ",
      "αἳ",
      "αἵ",
      "αὐτόσ",
      "αὐτὸς",
      "αὖ",
      "γάρ",
      "γα",
      "γα^",
      "γε",
      "για",
      "γοῦν",
      "γὰρ",
      "δ'",
      "δέ",
      "δή",
      "δαί",
      "δαίσ",
      "δαὶ",
      "δαὶς",
      "δε",
      "δεν",
      "δι'",
      "διά",
      "διὰ",
      "δὲ",
      "δὴ",
      "δ’",
      "εαν",
      "ειμαι",
      "ειμαστε",
      "ειναι",
      "εισαι",
      "ειστε",
      "εκεινα",
      "εκεινεσ",
      "εκεινη",
      "εκεινο",
      "εκεινοι",
      "εκεινοσ",
      "εκεινουσ",
      "εκεινων",
      "ενω",
      "επ",
      "επι",
      "εἰ",
      "εἰμί",
      "εἰμὶ",
      "εἰς",
      "εἰσ",
      "εἴ",
      "εἴμι",
      "εἴτε",
      "η",
      "θα",
      "ισωσ",
      "κ",
      "καί",
      "καίτοι",
      "καθ",
      "και",
      "κατ",
      "κατά",
      "κατα",
      "κατὰ",
      "καὶ",
      "κι",
      "κἀν",
      "κἂν",
      "μέν",
      "μή",
      "μήτε",
      "μα",
      "με",
      "μεθ",
      "μετ",
      "μετά",
      "μετα",
      "μετὰ",
      "μη",
      "μην",
      "μἐν",
      "μὲν",
      "μὴ",
      "μὴν",
      "να",
      "ο",
      "οι",
      "ομωσ",
      "οπωσ",
      "οσο",
      "οτι",
      "οἱ",
      "οἳ",
      "οἷς",
      "οὐ",
      "οὐδ",
      "οὐδέ",
      "οὐδείσ",
      "οὐδεὶς",
      "οὐδὲ",
      "οὐδὲν",
      "οὐκ",
      "οὐχ",
      "οὐχὶ",
      "οὓς",
      "οὔτε",
      "οὕτω",
      "οὕτως",
      "οὕτωσ",
      "οὖν",
      "οὗ",
      "οὗτος",
      "οὗτοσ",
      "παρ",
      "παρά",
      "παρα",
      "παρὰ",
      "περί",
      "περὶ",
      "ποια",
      "ποιεσ",
      "ποιο",
      "ποιοι",
      "ποιοσ",
      "ποιουσ",
      "ποιων",
      "ποτε",
      "που",
      "ποῦ",
      "προ",
      "προσ",
      "πρόσ",
      "πρὸ",
      "πρὸς",
      "πως",
      "πωσ",
      "σε",
      "στη",
      "στην",
      "στο",
      "στον",
      "σόσ",
      "σύ",
      "σύν",
      "σὸς",
      "σὺ",
      "σὺν",
      "τά",
      "τήν",
      "τί",
      "τίς",
      "τίσ",
      "τα",
      "ταῖς",
      "τε",
      "την",
      "τησ",
      "τι",
      "τινα",
      "τις",
      "τισ",
      "το",
      "τοί",
      "τοι",
      "τοιοῦτος",
      "τοιοῦτοσ",
      "τον",
      "τοτε",
      "του",
      "τούσ",
      "τοὺς",
      "τοῖς",
      "τοῦ",
      "των",
      "τό",
      "τόν",
      "τότε",
      "τὰ",
      "τὰς",
      "τὴν",
      "τὸ",
      "τὸν",
      "τῆς",
      "τῆσ",
      "τῇ",
      "τῶν",
      "τῷ",
      "ωσ",
      "ἀλλ'",
      "ἀλλά",
      "ἀλλὰ",
      "ἀλλ’",
      "ἀπ",
      "ἀπό",
      "ἀπὸ",
      "ἀφ",
      "ἂν",
      "ἃ",
      "ἄλλος",
      "ἄλλοσ",
      "ἄν",
      "ἄρα",
      "ἅμα",
      "ἐάν",
      "ἐγώ",
      "ἐγὼ",
      "ἐκ",
      "ἐμόσ",
      "ἐμὸς",
      "ἐν",
      "ἐξ",
      "ἐπί",
      "ἐπεὶ",
      "ἐπὶ",
      "ἐστι",
      "ἐφ",
      "ἐὰν",
      "ἑαυτοῦ",
      "ἔτι",
      "ἡ",
      "ἢ",
      "ἣ",
      "ἤ",
      "ἥ",
      "ἧς",
      "ἵνα",
      "ὁ",
      "ὃ",
      "ὃν",
      "ὃς",
      "ὅ",
      "ὅδε",
      "ὅθεν",
      "ὅπερ",
      "ὅς",
      "ὅσ",
      "ὅστις",
      "ὅστισ",
      "ὅτε",
      "ὅτι",
      "ὑμόσ",
      "ὑπ",
      "ὑπέρ",
      "ὑπό",
      "ὑπὲρ",
      "ὑπὸ",
      "ὡς",
      "ὡσ",
      "ὥς",
      "ὥστε",
      "ὦ",
      "ᾧ"
    };
  }
}

class Hausa implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "amma",
      "ba",
      "ban",
      "ce",
      "cikin",
      "da",
      "don",
      "ga",
      "in",
      "ina",
      "ita",
      "ji",
      "ka",
      "ko",
      "kuma",
      "lokacin",
      "ma",
      "mai",
      "na",
      "ne",
      "ni",
      "sai",
      "shi",
      "su",
      "suka",
      "sun",
      "ta",
      "tafi",
      "take",
      "tana",
      "wani",
      "wannan",
      "wata",
      "ya",
      "yake",
      "yana",
      "yi",
      "za"
    };
  }
}

class Hebrew implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "אבל",
      "או",
      "אולי",
      "אותה",
      "אותו",
      "אותי",
      "אותך",
      "אותם",
      "אותן",
      "אותנו",
      "אז",
      "אחר",
      "אחרות",
      "אחרי",
      "אחריכן",
      "אחרים",
      "אחרת",
      "אי",
      "איזה",
      "איך",
      "אין",
      "איפה",
      "איתה",
      "איתו",
      "איתי",
      "איתך",
      "איתכם",
      "איתכן",
      "איתם",
      "איתן",
      "איתנו",
      "אך",
      "אל",
      "אלה",
      "אלו",
      "אם",
      "אנחנו",
      "אני",
      "אס",
      "אף",
      "אצל",
      "אשר",
      "את",
      "אתה",
      "אתכם",
      "אתכן",
      "אתם",
      "אתן",
      "באיזומידה",
      "באמצע",
      "באמצעות",
      "בגלל",
      "בין",
      "בלי",
      "במידה",
      "במקוםשבו",
      "ברם",
      "בשביל",
      "בשעהש",
      "בתוך",
      "גם",
      "דרך",
      "הוא",
      "היא",
      "היה",
      "היכן",
      "היתה",
      "היתי",
      "הם",
      "הן",
      "הנה",
      "הסיבהשבגללה",
      "הרי",
      "ואילו",
      "ואת",
      "זאת",
      "זה",
      "זות",
      "יהיה",
      "יוכל",
      "יוכלו",
      "יותרמדי",
      "יכול",
      "יכולה",
      "יכולות",
      "יכולים",
      "יכל",
      "יכלה",
      "יכלו",
      "יש",
      "כאן",
      "כאשר",
      "כולם",
      "כולן",
      "כזה",
      "כי",
      "כיצד",
      "כך",
      "ככה",
      "כל",
      "כלל",
      "כמו",
      "כן",
      "כפי",
      "כש",
      "לא",
      "לאו",
      "לאיזותכלית",
      "לאן",
      "לבין",
      "לה",
      "להיות",
      "להם",
      "להן",
      "לו",
      "לי",
      "לכם",
      "לכן",
      "למה",
      "למטה",
      "למעלה",
      "למקוםשבו",
      "למרות",
      "לנו",
      "לעבר",
      "לעיכן",
      "לפיכך",
      "לפני",
      "מאד",
      "מאחורי",
      "מאיזוסיבה",
      "מאין",
      "מאיפה",
      "מבלי",
      "מבעד",
      "מדוע",
      "מה",
      "מהיכן",
      "מול",
      "מחוץ",
      "מי",
      "מכאן",
      "מכיוון",
      "מלבד",
      "מן",
      "מנין",
      "מסוגל",
      "מעט",
      "מעטים",
      "מעל",
      "מצד",
      "מקוםבו",
      "מתחת",
      "מתי",
      "נגד",
      "נגר",
      "נו",
      "עד",
      "עז",
      "על",
      "עלי",
      "עליה",
      "עליהם",
      "עליהן",
      "עליו",
      "עליך",
      "עליכם",
      "עלינו",
      "עם",
      "עצמה",
      "עצמהם",
      "עצמהן",
      "עצמו",
      "עצמי",
      "עצמם",
      "עצמן",
      "עצמנו",
      "פה",
      "רק",
      "שוב",
      "של",
      "שלה",
      "שלהם",
      "שלהן",
      "שלו",
      "שלי",
      "שלך",
      "שלכה",
      "שלכם",
      "שלכן",
      "שלנו",
      "שם",
      "תהיה",
      "תחת"
    };
  }
}

class Hindi implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "अंदर",
      "अत",
      "अदि",
      "अप",
      "अपना",
      "अपनि",
      "अपनी",
      "अपने",
      "अभि",
      "अभी",
      "आदि",
      "आप",
      "इंहिं",
      "इंहें",
      "इंहों",
      "इतयादि",
      "इत्यादि",
      "इन",
      "इनका",
      "इन्हीं",
      "इन्हें",
      "इन्हों",
      "इस",
      "इसका",
      "इसकि",
      "इसकी",
      "इसके",
      "इसमें",
      "इसि",
      "इसी",
      "इसे",
      "उंहिं",
      "उंहें",
      "उंहों",
      "उन",
      "उनका",
      "उनकि",
      "उनकी",
      "उनके",
      "उनको",
      "उन्हीं",
      "उन्हें",
      "उन्हों",
      "उस",
      "उसके",
      "उसि",
      "उसी",
      "उसे",
      "एक",
      "एवं",
      "एस",
      "एसे",
      "ऐसे",
      "ओर",
      "और",
      "कइ",
      "कई",
      "कर",
      "करता",
      "करते",
      "करना",
      "करने",
      "करें",
      "कहते",
      "कहा",
      "का",
      "काफि",
      "काफ़ी",
      "कि",
      "किंहें",
      "किंहों",
      "कितना",
      "किन्हें",
      "किन्हों",
      "किया",
      "किर",
      "किस",
      "किसि",
      "किसी",
      "किसे",
      "की",
      "कुछ",
      "कुल",
      "के",
      "को",
      "कोइ",
      "कोई",
      "कोन",
      "कोनसा",
      "कौन",
      "कौनसा",
      "गया",
      "घर",
      "जब",
      "जहाँ",
      "जहां",
      "जा",
      "जिंहें",
      "जिंहों",
      "जितना",
      "जिधर",
      "जिन",
      "जिन्हें",
      "जिन्हों",
      "जिस",
      "जिसे",
      "जीधर",
      "जेसा",
      "जेसे",
      "जैसा",
      "जैसे",
      "जो",
      "तक",
      "तब",
      "तरह",
      "तिंहें",
      "तिंहों",
      "तिन",
      "तिन्हें",
      "तिन्हों",
      "तिस",
      "तिसे",
      "तो",
      "था",
      "थि",
      "थी",
      "थे",
      "दबारा",
      "दवारा",
      "दिया",
      "दुसरा",
      "दुसरे",
      "दूसरे",
      "दो",
      "द्वारा",
      "न",
      "नहिं",
      "नहीं",
      "ना",
      "निचे",
      "निहायत",
      "नीचे",
      "ने",
      "पर",
      "पहले",
      "पुरा",
      "पूरा",
      "पे",
      "फिर",
      "बनि",
      "बनी",
      "बहि",
      "बही",
      "बहुत",
      "बाद",
      "बाला",
      "बिलकुल",
      "भि",
      "भितर",
      "भी",
      "भीतर",
      "मगर",
      "मानो",
      "मे",
      "में",
      "यदि",
      "यह",
      "यहाँ",
      "यहां",
      "यहि",
      "यही",
      "या",
      "यिह",
      "ये",
      "रखें",
      "रवासा",
      "रहा",
      "रहे",
      "ऱ्वासा",
      "लिए",
      "लिये",
      "लेकिन",
      "व",
      "वगेरह",
      "वरग",
      "वर्ग",
      "वह",
      "वहाँ",
      "वहां",
      "वहिं",
      "वहीं",
      "वाले",
      "वुह",
      "वे",
      "वग़ैरह",
      "संग",
      "सकता",
      "सकते",
      "सबसे",
      "सभि",
      "सभी",
      "साथ",
      "साबुत",
      "साभ",
      "सारा",
      "से",
      "सो",
      "हि",
      "ही",
      "हुअ",
      "हुआ",
      "हुइ",
      "हुई",
      "हुए",
      "हे",
      "हें",
      "है",
      "हैं",
      "हो",
      "होता",
      "होति",
      "होती",
      "होते",
      "होना",
      "होने"
    };
  }
}

class Hungarian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "abba",
      "abban",
      "abbã³l",
      "abból",
      "addig",
      "ahhoz",
      "ahogy",
      "ahol",
      "aki",
      "akik",
      "akkor",
      "akár",
      "akã¡r",
      "alapján",
      "alapjã¡n",
      "alatt",
      "alatta",
      "alattad",
      "alattam",
      "alattatok",
      "alattuk",
      "alattunk",
      "alá",
      "alád",
      "alájuk",
      "alám",
      "alánk",
      "alátok",
      "alã¡",
      "alã¡d",
      "alã¡juk",
      "alã¡m",
      "alã¡nk",
      "alã¡tok",
      "alã³l",
      "alã³la",
      "alã³lad",
      "alã³lam",
      "alã³latok",
      "alã³luk",
      "alã³lunk",
      "alól",
      "alóla",
      "alólad",
      "alólam",
      "alólatok",
      "alóluk",
      "alólunk",
      "amely",
      "amelybol",
      "amelyek",
      "amelyekben",
      "amelyeket",
      "amelyet",
      "amelyik",
      "amelynek",
      "ami",
      "amikor",
      "amit",
      "amolyan",
      "amott",
      "amã­g",
      "amíg",
      "annak",
      "annál",
      "annã¡l",
      "arra",
      "arrã³l",
      "arról",
      "attã³l",
      "attól",
      "az",
      "aznap",
      "azok",
      "azokat",
      "azokba",
      "azokban",
      "azokbã³l",
      "azokból",
      "azokhoz",
      "azokig",
      "azokkal",
      "azokká",
      "azokkã¡",
      "azoknak",
      "azoknál",
      "azoknã¡l",
      "azokon",
      "azokra",
      "azokrã³l",
      "azokról",
      "azoktã³l",
      "azoktól",
      "azokã©rt",
      "azokért",
      "azon",
      "azonban",
      "azonnal",
      "azt",
      "aztán",
      "aztã¡n",
      "azután",
      "azzal",
      "azzá",
      "azzã¡",
      "azã©rt",
      "azért",
      "bal",
      "balra",
      "ban",
      "be",
      "belã©",
      "belã©d",
      "belã©jã¼k",
      "belã©m",
      "belã©nk",
      "belã©tek",
      "belã¼l",
      "belå‘le",
      "belå‘led",
      "belå‘lem",
      "belå‘letek",
      "belå‘lã¼k",
      "belå‘lã¼nk",
      "belé",
      "beléd",
      "beléjük",
      "belém",
      "belénk",
      "belétek",
      "belül",
      "belőle",
      "belőled",
      "belőlem",
      "belőletek",
      "belőlük",
      "belőlünk",
      "ben",
      "benne",
      "benned",
      "bennem",
      "bennetek",
      "bennã¼k",
      "bennã¼nk",
      "bennük",
      "bennünk",
      "bár",
      "bárcsak",
      "bármilyen",
      "bã¡r",
      "bã¡rcsak",
      "bã¡rmilyen",
      "bãºcsãº",
      "búcsú",
      "cikk",
      "cikkek",
      "cikkeket",
      "csak",
      "csakhogy",
      "csupán",
      "csupã¡n",
      "de",
      "dehogy",
      "e",
      "ebbe",
      "ebben",
      "ebbå‘l",
      "ebből",
      "eddig",
      "egy",
      "egyebek",
      "egyebet",
      "egyedã¼l",
      "egyedül",
      "egyelå‘re",
      "egyelőre",
      "egyes",
      "egyet",
      "egyetlen",
      "egyik",
      "egymás",
      "egymã¡s",
      "egyre",
      "egyszerre",
      "egyã©b",
      "egyã¼tt",
      "egyéb",
      "együtt",
      "egã©sz",
      "egã©szen",
      "egész",
      "egészen",
      "ehhez",
      "ekkor",
      "el",
      "eleinte",
      "ellen",
      "ellenes",
      "elleni",
      "ellenã©re",
      "ellenére",
      "elmondta",
      "elså‘",
      "elså‘k",
      "elså‘sorban",
      "elså‘t",
      "elsõ",
      "első",
      "elsők",
      "elsősorban",
      "elsőt",
      "elã©",
      "elã©d",
      "elã©g",
      "elã©jã¼k",
      "elã©m",
      "elã©nk",
      "elã©tek",
      "elå‘bb",
      "elå‘l",
      "elå‘le",
      "elå‘led",
      "elå‘lem",
      "elå‘letek",
      "elå‘lã¼k",
      "elå‘lã¼nk",
      "elå‘szã¶r",
      "elå‘tt",
      "elå‘tte",
      "elå‘tted",
      "elå‘ttem",
      "elå‘ttetek",
      "elå‘ttã¼k",
      "elå‘ttã¼nk",
      "elå‘zå‘",
      "elé",
      "eléd",
      "elég",
      "eléjük",
      "elém",
      "elénk",
      "elétek",
      "elõ",
      "elõször",
      "elõtt",
      "elő",
      "előbb",
      "elől",
      "előle",
      "előled",
      "előlem",
      "előletek",
      "előlük",
      "előlünk",
      "először",
      "előtt",
      "előtte",
      "előtted",
      "előttem",
      "előttetek",
      "előttük",
      "előttünk",
      "előző",
      "emilyen",
      "engem",
      "ennek",
      "ennyi",
      "ennã©l",
      "ennél",
      "enyã©m",
      "enyém",
      "erre",
      "errå‘l",
      "erről",
      "esetben",
      "ettå‘l",
      "ettől",
      "ez",
      "ezek",
      "ezekbe",
      "ezekben",
      "ezekbå‘l",
      "ezekből",
      "ezeken",
      "ezeket",
      "ezekhez",
      "ezekig",
      "ezekkel",
      "ezekkã©",
      "ezekké",
      "ezeknek",
      "ezeknã©l",
      "ezeknél",
      "ezekre",
      "ezekrå‘l",
      "ezekről",
      "ezektå‘l",
      "ezektől",
      "ezekã©rt",
      "ezekért",
      "ezen",
      "ezentãºl",
      "ezentúl",
      "ezer",
      "ezret",
      "ezt",
      "ezután",
      "ezutã¡n",
      "ezzel",
      "ezzã©",
      "ezzé",
      "ezã©rt",
      "ezért",
      "fel",
      "fele",
      "felek",
      "felet",
      "felett",
      "felã©",
      "felé",
      "fent",
      "fenti",
      "fã©l",
      "fã¶lã©",
      "fél",
      "fölé",
      "gyakran",
      "ha",
      "hallã³",
      "halló",
      "hamar",
      "hanem",
      "harmadik",
      "harmadikat",
      "harminc",
      "hat",
      "hatodik",
      "hatodikat",
      "hatot",
      "hatvan",
      "helyett",
      "hetedik",
      "hetediket",
      "hetet",
      "hetven",
      "hirtelen",
      "hiszen",
      "hiába",
      "hiã¡ba",
      "hogy",
      "hogyan",
      "hol",
      "holnap",
      "holnapot",
      "honnan",
      "hova",
      "hozzá",
      "hozzád",
      "hozzájuk",
      "hozzám",
      "hozzánk",
      "hozzátok",
      "hozzã¡",
      "hozzã¡d",
      "hozzã¡juk",
      "hozzã¡m",
      "hozzã¡nk",
      "hozzã¡tok",
      "hurrá",
      "hurrã¡",
      "huszadik",
      "hány",
      "hányszor",
      "hármat",
      "három",
      "hát",
      "hátha",
      "hátulsó",
      "hã¡ny",
      "hã¡nyszor",
      "hã¡rmat",
      "hã¡rom",
      "hã¡t",
      "hã¡tha",
      "hã¡tulsã³",
      "hã©t",
      "hãºsz",
      "hét",
      "húsz",
      "ide",
      "ide-ð¾da",
      "ide-оda",
      "idã©n",
      "idén",
      "igazán",
      "igazã¡n",
      "igen",
      "ill",
      "ill.",
      "illetve",
      "ilyen",
      "ilyenkor",
      "immár",
      "immã¡r",
      "inkább",
      "inkã¡bb",
      "is",
      "ismã©t",
      "ismét",
      "ison",
      "itt",
      "jelenleg",
      "jobban",
      "jobbra",
      "jã³",
      "jã³l",
      "jã³lesik",
      "jã³val",
      "jã¶vå‘re",
      "jó",
      "jól",
      "jólesik",
      "jóval",
      "jövőre",
      "kell",
      "kellene",
      "kellett",
      "kelljen",
      "keressünk",
      "keresztül",
      "ketten",
      "kettå‘",
      "kettå‘t",
      "kettő",
      "kettőt",
      "kevã©s",
      "kevés",
      "ki",
      "kiben",
      "kibå‘l",
      "kiből",
      "kicsit",
      "kicsoda",
      "kihez",
      "kik",
      "kikbe",
      "kikben",
      "kikbå‘l",
      "kikből",
      "kiken",
      "kiket",
      "kikhez",
      "kikkel",
      "kikkã©",
      "kikké",
      "kiknek",
      "kiknã©l",
      "kiknél",
      "kikre",
      "kikrå‘l",
      "kikről",
      "kiktå‘l",
      "kiktől",
      "kikã©rt",
      "kikért",
      "kilenc",
      "kilencedik",
      "kilencediket",
      "kilencet",
      "kilencven",
      "kin",
      "kinek",
      "kinã©l",
      "kinél",
      "kire",
      "kirå‘l",
      "kiről",
      "kit",
      "kitå‘l",
      "kitől",
      "kivel",
      "kivã©",
      "kivé",
      "kiã©",
      "kiã©rt",
      "kié",
      "kiért",
      "korábban",
      "korã¡bban",
      "kã©pest",
      "kã©rem",
      "kã©rlek",
      "kã©sz",
      "kã©så‘",
      "kã©så‘bb",
      "kã©så‘n",
      "kã©t",
      "kã©tszer",
      "kã¶rã¼l",
      "kã¶szã¶nhetå‘en",
      "kã¶szã¶nã¶m",
      "kã¶zben",
      "kã¶zel",
      "kã¶zepesen",
      "kã¶zepã©n",
      "kã¶zã©",
      "kã¶zã¶tt",
      "kã¶zã¼l",
      "kã¼lã¶n",
      "kã¼lã¶nben",
      "kã¼lã¶nbã¶zå‘",
      "kã¼lã¶nbã¶zå‘bb",
      "kã¼lã¶nbã¶zå‘ek",
      "képest",
      "kérem",
      "kérlek",
      "kész",
      "késő",
      "később",
      "későn",
      "két",
      "kétszer",
      "kívül",
      "körül",
      "köszönhetően",
      "köszönöm",
      "közben",
      "közel",
      "közepesen",
      "közepén",
      "közé",
      "között",
      "közül",
      "külön",
      "különben",
      "különböző",
      "különbözőbb",
      "különbözőek",
      "lassan",
      "le",
      "legalább",
      "legalã¡bb",
      "legyen",
      "lehet",
      "lehetetlen",
      "lehetett",
      "lehetå‘leg",
      "lehetå‘sã©g",
      "lehetőleg",
      "lehetőség",
      "lenne",
      "lenni",
      "lennã©k",
      "lennã©nek",
      "lennék",
      "lennének",
      "lesz",
      "leszek",
      "lesznek",
      "leszã¼nk",
      "leszünk",
      "lett",
      "lettek",
      "lettem",
      "lettã¼nk",
      "lettünk",
      "lã©vå‘",
      "lévő",
      "ma",
      "maga",
      "magad",
      "magam",
      "magatokat",
      "magukat",
      "magunkat",
      "magát",
      "magã¡t",
      "mai",
      "majd",
      "majdnem",
      "manapság",
      "manapsã¡g",
      "meg",
      "megcsinál",
      "megcsinálnak",
      "megcsinã¡l",
      "megcsinã¡lnak",
      "megint",
      "megvan",
      "mellett",
      "mellette",
      "melletted",
      "mellettem",
      "mellettetek",
      "mellettã¼k",
      "mellettã¼nk",
      "mellettük",
      "mellettünk",
      "mellã©",
      "mellã©d",
      "mellã©jã¼k",
      "mellã©m",
      "mellã©nk",
      "mellã©tek",
      "mellå‘l",
      "mellå‘le",
      "mellå‘led",
      "mellå‘lem",
      "mellå‘letek",
      "mellå‘lã¼k",
      "mellå‘lã¼nk",
      "mellé",
      "melléd",
      "melléjük",
      "mellém",
      "mellénk",
      "mellétek",
      "mellől",
      "mellőle",
      "mellőled",
      "mellőlem",
      "mellőletek",
      "mellőlük",
      "mellőlünk",
      "mely",
      "melyek",
      "melyik",
      "mennyi",
      "mert",
      "mi",
      "miatt",
      "miatta",
      "miattad",
      "miattam",
      "miattatok",
      "miattuk",
      "miattunk",
      "mibe",
      "miben",
      "mibå‘l",
      "miből",
      "mihez",
      "mik",
      "mikbe",
      "mikben",
      "mikbå‘l",
      "mikből",
      "miken",
      "miket",
      "mikhez",
      "mikkel",
      "mikkã©",
      "mikké",
      "miknek",
      "miknã©l",
      "miknél",
      "mikor",
      "mikre",
      "mikrå‘l",
      "mikről",
      "miktå‘l",
      "miktől",
      "mikã©rt",
      "mikért",
      "milyen",
      "min",
      "mind",
      "mindegyik",
      "mindegyiket",
      "minden",
      "mindenesetre",
      "mindenki",
      "mindent",
      "mindenã¼tt",
      "mindenütt",
      "mindig",
      "mindketten",
      "minek",
      "minket",
      "mint",
      "mintha",
      "minã©l",
      "minél",
      "mire",
      "mirå‘l",
      "miről",
      "mit",
      "mitå‘l",
      "mitől",
      "mivel",
      "mivã©",
      "mivé",
      "miã©rt",
      "miért",
      "mondta",
      "most",
      "mostanáig",
      "mostanã¡ig",
      "már",
      "más",
      "másik",
      "másikat",
      "másnap",
      "második",
      "másodszor",
      "mások",
      "másokat",
      "mást",
      "mã¡r",
      "mã¡s",
      "mã¡sik",
      "mã¡sikat",
      "mã¡snap",
      "mã¡sodik",
      "mã¡sodszor",
      "mã¡sok",
      "mã¡sokat",
      "mã¡st",
      "mã©g",
      "mã©gis",
      "mã­g",
      "mã¶gã©",
      "mã¶gã©d",
      "mã¶gã©jã¼k",
      "mã¶gã©m",
      "mã¶gã©nk",
      "mã¶gã©tek",
      "mã¶gã¶tt",
      "mã¶gã¶tte",
      "mã¶gã¶tted",
      "mã¶gã¶ttem",
      "mã¶gã¶ttetek",
      "mã¶gã¶ttã¼k",
      "mã¶gã¶ttã¼nk",
      "mã¶gã¼l",
      "mã¶gã¼le",
      "mã¶gã¼led",
      "mã¶gã¼lem",
      "mã¶gã¼letek",
      "mã¶gã¼lã¼k",
      "mã¶gã¼lã¼nk",
      "mãºltkor",
      "mãºlva",
      "még",
      "mégis",
      "míg",
      "mögé",
      "mögéd",
      "mögéjük",
      "mögém",
      "mögénk",
      "mögétek",
      "mögött",
      "mögötte",
      "mögötted",
      "mögöttem",
      "mögöttetek",
      "mögöttük",
      "mögöttünk",
      "mögül",
      "mögüle",
      "mögüled",
      "mögülem",
      "mögületek",
      "mögülük",
      "mögülünk",
      "múltkor",
      "múlva",
      "na",
      "nagy",
      "nagyobb",
      "nagyon",
      "naponta",
      "napot",
      "ne",
      "negyedik",
      "negyediket",
      "negyven",
      "neked",
      "nekem",
      "neki",
      "nekik",
      "nektek",
      "nekã¼nk",
      "nekünk",
      "nem",
      "nemcsak",
      "nemrã©g",
      "nemrég",
      "nincs",
      "nyolc",
      "nyolcadik",
      "nyolcadikat",
      "nyolcat",
      "nyolcvan",
      "nála",
      "nálad",
      "nálam",
      "nálatok",
      "náluk",
      "nálunk",
      "nã¡la",
      "nã¡lad",
      "nã¡lam",
      "nã¡latok",
      "nã¡luk",
      "nã¡lunk",
      "nã©gy",
      "nã©gyet",
      "nã©ha",
      "nã©hã¡ny",
      "nã©lkã¼l",
      "négy",
      "négyet",
      "néha",
      "néhány",
      "nélkül",
      "o",
      "oda",
      "ok",
      "olyan",
      "onnan",
      "ott",
      "pedig",
      "persze",
      "pár",
      "pã¡r",
      "pã©ldã¡ul",
      "például",
      "rajta",
      "rajtad",
      "rajtam",
      "rajtatok",
      "rajtuk",
      "rajtunk",
      "rendben",
      "rosszul",
      "rá",
      "rád",
      "rájuk",
      "rám",
      "ránk",
      "rátok",
      "rã¡",
      "rã¡d",
      "rã¡juk",
      "rã¡m",
      "rã¡nk",
      "rã¡tok",
      "rã©gen",
      "rã©gã³ta",
      "rã©szã©re",
      "rã³la",
      "rã³lad",
      "rã³lam",
      "rã³latok",
      "rã³luk",
      "rã³lunk",
      "rã¶gtã¶n",
      "régen",
      "régóta",
      "részére",
      "róla",
      "rólad",
      "rólam",
      "rólatok",
      "róluk",
      "rólunk",
      "rögtön",
      "s",
      "saját",
      "se",
      "sem",
      "semmi",
      "semmilyen",
      "semmisã©g",
      "semmiség",
      "senki",
      "soha",
      "sok",
      "sokan",
      "sokat",
      "sokkal",
      "sokszor",
      "sokáig",
      "sokã¡ig",
      "során",
      "sorã¡n",
      "stb.",
      "szemben",
      "szerbusz",
      "szerint",
      "szerinte",
      "szerinted",
      "szerintem",
      "szerintetek",
      "szerintã¼k",
      "szerintã¼nk",
      "szerintük",
      "szerintünk",
      "szervusz",
      "szinte",
      "számára",
      "száz",
      "századik",
      "százat",
      "szã¡mã¡ra",
      "szã¡z",
      "szã¡zadik",
      "szã¡zat",
      "szã©pen",
      "szã­ves",
      "szã­vesen",
      "szã­veskedjã©k",
      "szépen",
      "szét",
      "szíves",
      "szívesen",
      "szíveskedjék",
      "så‘t",
      "sőt",
      "talán",
      "talã¡n",
      "tavaly",
      "te",
      "tegnap",
      "tegnapelå‘tt",
      "tegnapelőtt",
      "tehát",
      "tehã¡t",
      "tele",
      "teljes",
      "tessã©k",
      "tessék",
      "ti",
      "tied",
      "titeket",
      "tizedik",
      "tizediket",
      "tizenegy",
      "tizenegyedik",
      "tizenhat",
      "tizenhárom",
      "tizenhã¡rom",
      "tizenhã©t",
      "tizenhét",
      "tizenkettedik",
      "tizenkettå‘",
      "tizenkettő",
      "tizenkilenc",
      "tizenkã©t",
      "tizenkét",
      "tizennyolc",
      "tizennã©gy",
      "tizennégy",
      "tizenã¶t",
      "tizenöt",
      "tizet",
      "tovább",
      "további",
      "továbbá",
      "tovã¡bb",
      "tovã¡bbi",
      "távol",
      "tã¡vol",
      "tã©ged",
      "tã©nyleg",
      "tã­z",
      "tã¶bb",
      "tã¶bbi",
      "tã¶bbszã¶r",
      "tãºl",
      "tå‘le",
      "tå‘led",
      "tå‘lem",
      "tå‘letek",
      "tå‘lã¼k",
      "tå‘lã¼nk",
      "téged",
      "tényleg",
      "tíz",
      "több",
      "többi",
      "többször",
      "túl",
      "tőle",
      "tőled",
      "tőlem",
      "tőletek",
      "tőlük",
      "tőlünk",
      "ugyanakkor",
      "ugyanez",
      "ugyanis",
      "ugye",
      "urak",
      "uram",
      "urat",
      "utoljára",
      "utoljã¡ra",
      "utolsã³",
      "utolsó",
      "után",
      "utána",
      "utã¡n",
      "vagy",
      "vagyis",
      "vagyok",
      "vagytok",
      "vagyunk",
      "vajon",
      "valahol",
      "valaki",
      "valakit",
      "valamelyik",
      "valami",
      "valamint",
      "való",
      "van",
      "vannak",
      "vele",
      "veled",
      "velem",
      "veletek",
      "velã¼k",
      "velã¼nk",
      "velük",
      "velünk",
      "vissza",
      "viszlát",
      "viszlã¡t",
      "viszont",
      "viszontlátásra",
      "viszontlã¡tã¡sra",
      "volna",
      "volnának",
      "volnã¡nak",
      "volnã©k",
      "volnék",
      "volt",
      "voltak",
      "voltam",
      "voltunk",
      "vã©gre",
      "vã©gã©n",
      "vã©gã¼l",
      "végre",
      "végén",
      "végül",
      "által",
      "általában",
      "ám",
      "át",
      "ã¡ltal",
      "ã¡ltalã¡ban",
      "ã¡m",
      "ã¡t",
      "ã©ljen",
      "ã©n",
      "ã©rte",
      "ã©rted",
      "ã©rtem",
      "ã©rtetek",
      "ã©rtã¼k",
      "ã©rtã¼nk",
      "ã©s",
      "ã©v",
      "ã©vben",
      "ã©ve",
      "ã©vek",
      "ã©ves",
      "ã©vi",
      "ã©vvel",
      "ã­gy",
      "ã³ta",
      "ã¶n",
      "ã¶nbe",
      "ã¶nben",
      "ã¶nbå‘l",
      "ã¶nhã¶z",
      "ã¶nnek",
      "ã¶nnel",
      "ã¶nnã©l",
      "ã¶nre",
      "ã¶nrå‘l",
      "ã¶nt",
      "ã¶ntå‘l",
      "ã¶nã©rt",
      "ã¶nã¶k",
      "ã¶nã¶kbe",
      "ã¶nã¶kben",
      "ã¶nã¶kbå‘l",
      "ã¶nã¶ket",
      "ã¶nã¶khã¶z",
      "ã¶nã¶kkel",
      "ã¶nã¶knek",
      "ã¶nã¶knã©l",
      "ã¶nã¶kre",
      "ã¶nã¶krå‘l",
      "ã¶nã¶ktå‘l",
      "ã¶nã¶kã©rt",
      "ã¶nã¶kã¶n",
      "ã¶nã¶n",
      "ã¶t",
      "ã¶tven",
      "ã¶tã¶dik",
      "ã¶tã¶diket",
      "ã¶tã¶t",
      "ãºgy",
      "ãºgyis",
      "ãºgynevezett",
      "ãºjra",
      "ãºr",
      "å‘",
      "å‘k",
      "å‘ket",
      "å‘t",
      "éljen",
      "én",
      "éppen",
      "érte",
      "érted",
      "értem",
      "értetek",
      "értük",
      "értünk",
      "és",
      "év",
      "évben",
      "éve",
      "évek",
      "éves",
      "évi",
      "évvel",
      "így",
      "óta",
      "õ",
      "õk",
      "õket",
      "ön",
      "önbe",
      "önben",
      "önből",
      "önhöz",
      "önnek",
      "önnel",
      "önnél",
      "önre",
      "önről",
      "önt",
      "öntől",
      "önért",
      "önök",
      "önökbe",
      "önökben",
      "önökből",
      "önöket",
      "önökhöz",
      "önökkel",
      "önöknek",
      "önöknél",
      "önökre",
      "önökről",
      "önöktől",
      "önökért",
      "önökön",
      "önön",
      "össze",
      "öt",
      "ötven",
      "ötödik",
      "ötödiket",
      "ötöt",
      "úgy",
      "úgyis",
      "úgynevezett",
      "új",
      "újabb",
      "újra",
      "úr",
      "ő",
      "ők",
      "őket",
      "őt"
    };
  }
}

class Indonesian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "ada",
      "adalah",
      "adanya",
      "adapun",
      "agak",
      "agaknya",
      "agar",
      "akan",
      "akankah",
      "akhir",
      "akhiri",
      "akhirnya",
      "aku",
      "akulah",
      "amat",
      "amatlah",
      "anda",
      "andalah",
      "antar",
      "antara",
      "antaranya",
      "apa",
      "apaan",
      "apabila",
      "apakah",
      "apalagi",
      "apatah",
      "artinya",
      "asal",
      "asalkan",
      "atas",
      "atau",
      "ataukah",
      "ataupun",
      "awal",
      "awalnya",
      "bagai",
      "bagaikan",
      "bagaimana",
      "bagaimanakah",
      "bagaimanapun",
      "bagi",
      "bagian",
      "bahkan",
      "bahwa",
      "bahwasanya",
      "baik",
      "bakal",
      "bakalan",
      "balik",
      "banyak",
      "bapak",
      "baru",
      "bawah",
      "beberapa",
      "begini",
      "beginian",
      "beginikah",
      "beginilah",
      "begitu",
      "begitukah",
      "begitulah",
      "begitupun",
      "bekerja",
      "belakang",
      "belakangan",
      "belum",
      "belumlah",
      "benar",
      "benarkah",
      "benarlah",
      "berada",
      "berakhir",
      "berakhirlah",
      "berakhirnya",
      "berapa",
      "berapakah",
      "berapalah",
      "berapapun",
      "berarti",
      "berawal",
      "berbagai",
      "berdatangan",
      "beri",
      "berikan",
      "berikut",
      "berikutnya",
      "berjumlah",
      "berkali-kali",
      "berkata",
      "berkehendak",
      "berkeinginan",
      "berkenaan",
      "berlainan",
      "berlalu",
      "berlangsung",
      "berlebihan",
      "bermacam",
      "bermacam-macam",
      "bermaksud",
      "bermula",
      "bersama",
      "bersama-sama",
      "bersiap",
      "bersiap-siap",
      "bertanya",
      "bertanya-tanya",
      "berturut",
      "berturut-turut",
      "bertutur",
      "berujar",
      "berupa",
      "besar",
      "betul",
      "betulkah",
      "biasa",
      "biasanya",
      "bila",
      "bilakah",
      "bisa",
      "bisakah",
      "boleh",
      "bolehkah",
      "bolehlah",
      "buat",
      "bukan",
      "bukankah",
      "bukanlah",
      "bukannya",
      "bulan",
      "bung",
      "cara",
      "caranya",
      "cukup",
      "cukupkah",
      "cukuplah",
      "cuma",
      "dahulu",
      "dalam",
      "dan",
      "dapat",
      "dari",
      "daripada",
      "datang",
      "dekat",
      "demi",
      "demikian",
      "demikianlah",
      "dengan",
      "depan",
      "di",
      "dia",
      "diakhiri",
      "diakhirinya",
      "dialah",
      "diantara",
      "diantaranya",
      "diberi",
      "diberikan",
      "diberikannya",
      "dibuat",
      "dibuatnya",
      "didapat",
      "didatangkan",
      "digunakan",
      "diibaratkan",
      "diibaratkannya",
      "diingat",
      "diingatkan",
      "diinginkan",
      "dijawab",
      "dijelaskan",
      "dijelaskannya",
      "dikarenakan",
      "dikatakan",
      "dikatakannya",
      "dikerjakan",
      "diketahui",
      "diketahuinya",
      "dikira",
      "dilakukan",
      "dilalui",
      "dilihat",
      "dimaksud",
      "dimaksudkan",
      "dimaksudkannya",
      "dimaksudnya",
      "diminta",
      "dimintai",
      "dimisalkan",
      "dimulai",
      "dimulailah",
      "dimulainya",
      "dimungkinkan",
      "dini",
      "dipastikan",
      "diperbuat",
      "diperbuatnya",
      "dipergunakan",
      "diperkirakan",
      "diperlihatkan",
      "diperlukan",
      "diperlukannya",
      "dipersoalkan",
      "dipertanyakan",
      "dipunyai",
      "diri",
      "dirinya",
      "disampaikan",
      "disebut",
      "disebutkan",
      "disebutkannya",
      "disini",
      "disinilah",
      "ditambahkan",
      "ditandaskan",
      "ditanya",
      "ditanyai",
      "ditanyakan",
      "ditegaskan",
      "ditujukan",
      "ditunjuk",
      "ditunjuki",
      "ditunjukkan",
      "ditunjukkannya",
      "ditunjuknya",
      "dituturkan",
      "dituturkannya",
      "diucapkan",
      "diucapkannya",
      "diungkapkan",
      "dong",
      "dua",
      "dulu",
      "empat",
      "enggak",
      "enggaknya",
      "entah",
      "entahlah",
      "guna",
      "gunakan",
      "hal",
      "hampir",
      "hanya",
      "hanyalah",
      "hari",
      "harus",
      "haruslah",
      "harusnya",
      "hendak",
      "hendaklah",
      "hendaknya",
      "hingga",
      "ia",
      "ialah",
      "ibarat",
      "ibaratkan",
      "ibaratnya",
      "ibu",
      "ikut",
      "ingat",
      "ingat-ingat",
      "ingin",
      "inginkah",
      "inginkan",
      "ini",
      "inikah",
      "inilah",
      "itu",
      "itukah",
      "itulah",
      "jadi",
      "jadilah",
      "jadinya",
      "jangan",
      "jangankan",
      "janganlah",
      "jauh",
      "jawab",
      "jawaban",
      "jawabnya",
      "jelas",
      "jelaskan",
      "jelaslah",
      "jelasnya",
      "jika",
      "jikalau",
      "juga",
      "jumlah",
      "jumlahnya",
      "justru",
      "kala",
      "kalau",
      "kalaulah",
      "kalaupun",
      "kalian",
      "kami",
      "kamilah",
      "kamu",
      "kamulah",
      "kan",
      "kapan",
      "kapankah",
      "kapanpun",
      "karena",
      "karenanya",
      "kasus",
      "kata",
      "katakan",
      "katakanlah",
      "katanya",
      "ke",
      "keadaan",
      "kebetulan",
      "kecil",
      "kedua",
      "keduanya",
      "keinginan",
      "kelamaan",
      "kelihatan",
      "kelihatannya",
      "kelima",
      "keluar",
      "kembali",
      "kemudian",
      "kemungkinan",
      "kemungkinannya",
      "kenapa",
      "kepada",
      "kepadanya",
      "kesampaian",
      "keseluruhan",
      "keseluruhannya",
      "keterlaluan",
      "ketika",
      "khususnya",
      "kini",
      "kinilah",
      "kira",
      "kira-kira",
      "kiranya",
      "kita",
      "kitalah",
      "kok",
      "kurang",
      "lagi",
      "lagian",
      "lah",
      "lain",
      "lainnya",
      "lalu",
      "lama",
      "lamanya",
      "lanjut",
      "lanjutnya",
      "lebih",
      "lewat",
      "lima",
      "luar",
      "macam",
      "maka",
      "makanya",
      "makin",
      "malah",
      "malahan",
      "mampu",
      "mampukah",
      "mana",
      "manakala",
      "manalagi",
      "masa",
      "masalah",
      "masalahnya",
      "masih",
      "masihkah",
      "masing",
      "masing-masing",
      "mau",
      "maupun",
      "melainkan",
      "melakukan",
      "melalui",
      "melihat",
      "melihatnya",
      "memang",
      "memastikan",
      "memberi",
      "memberikan",
      "membuat",
      "memerlukan",
      "memihak",
      "meminta",
      "memintakan",
      "memisalkan",
      "memperbuat",
      "mempergunakan",
      "memperkirakan",
      "memperlihatkan",
      "mempersiapkan",
      "mempersoalkan",
      "mempertanyakan",
      "mempunyai",
      "memulai",
      "memungkinkan",
      "menaiki",
      "menambahkan",
      "menandaskan",
      "menanti",
      "menanti-nanti",
      "menantikan",
      "menanya",
      "menanyai",
      "menanyakan",
      "mendapat",
      "mendapatkan",
      "mendatang",
      "mendatangi",
      "mendatangkan",
      "menegaskan",
      "mengakhiri",
      "mengapa",
      "mengatakan",
      "mengatakannya",
      "mengenai",
      "mengerjakan",
      "mengetahui",
      "menggunakan",
      "menghendaki",
      "mengibaratkan",
      "mengibaratkannya",
      "mengingat",
      "mengingatkan",
      "menginginkan",
      "mengira",
      "mengucapkan",
      "mengucapkannya",
      "mengungkapkan",
      "menjadi",
      "menjawab",
      "menjelaskan",
      "menuju",
      "menunjuk",
      "menunjuki",
      "menunjukkan",
      "menunjuknya",
      "menurut",
      "menuturkan",
      "menyampaikan",
      "menyangkut",
      "menyatakan",
      "menyebutkan",
      "menyeluruh",
      "menyiapkan",
      "merasa",
      "mereka",
      "merekalah",
      "merupakan",
      "meski",
      "meskipun",
      "meyakini",
      "meyakinkan",
      "minta",
      "mirip",
      "misal",
      "misalkan",
      "misalnya",
      "mula",
      "mulai",
      "mulailah",
      "mulanya",
      "mungkin",
      "mungkinkah",
      "nah",
      "naik",
      "namun",
      "nanti",
      "nantinya",
      "nyaris",
      "nyatanya",
      "oleh",
      "olehnya",
      "pada",
      "padahal",
      "padanya",
      "pak",
      "paling",
      "panjang",
      "pantas",
      "para",
      "pasti",
      "pastilah",
      "penting",
      "pentingnya",
      "per",
      "percuma",
      "perlu",
      "perlukah",
      "perlunya",
      "pernah",
      "persoalan",
      "pertama",
      "pertama-tama",
      "pertanyaan",
      "pertanyakan",
      "pihak",
      "pihaknya",
      "pukul",
      "pula",
      "pun",
      "punya",
      "rasa",
      "rasanya",
      "rata",
      "rupanya",
      "saat",
      "saatnya",
      "saja",
      "sajalah",
      "saling",
      "sama",
      "sama-sama",
      "sambil",
      "sampai",
      "sampai-sampai",
      "sampaikan",
      "sana",
      "sangat",
      "sangatlah",
      "satu",
      "saya",
      "sayalah",
      "se",
      "sebab",
      "sebabnya",
      "sebagai",
      "sebagaimana",
      "sebagainya",
      "sebagian",
      "sebaik",
      "sebaik-baiknya",
      "sebaiknya",
      "sebaliknya",
      "sebanyak",
      "sebegini",
      "sebegitu",
      "sebelum",
      "sebelumnya",
      "sebenarnya",
      "seberapa",
      "sebesar",
      "sebetulnya",
      "sebisanya",
      "sebuah",
      "sebut",
      "sebutlah",
      "sebutnya",
      "secara",
      "secukupnya",
      "sedang",
      "sedangkan",
      "sedemikian",
      "sedikit",
      "sedikitnya",
      "seenaknya",
      "segala",
      "segalanya",
      "segera",
      "seharusnya",
      "sehingga",
      "seingat",
      "sejak",
      "sejauh",
      "sejenak",
      "sejumlah",
      "sekadar",
      "sekadarnya",
      "sekali",
      "sekali-kali",
      "sekalian",
      "sekaligus",
      "sekalipun",
      "sekarang",
      "sekecil",
      "seketika",
      "sekiranya",
      "sekitar",
      "sekitarnya",
      "sekurang-kurangnya",
      "sekurangnya",
      "sela",
      "selagi",
      "selain",
      "selaku",
      "selalu",
      "selama",
      "selama-lamanya",
      "selamanya",
      "selanjutnya",
      "seluruh",
      "seluruhnya",
      "semacam",
      "semakin",
      "semampu",
      "semampunya",
      "semasa",
      "semasih",
      "semata",
      "semata-mata",
      "semaunya",
      "sementara",
      "semisal",
      "semisalnya",
      "sempat",
      "semua",
      "semuanya",
      "semula",
      "sendiri",
      "sendirian",
      "sendirinya",
      "seolah",
      "seolah-olah",
      "seorang",
      "sepanjang",
      "sepantasnya",
      "sepantasnyalah",
      "seperlunya",
      "seperti",
      "sepertinya",
      "sepihak",
      "sering",
      "seringnya",
      "serta",
      "serupa",
      "sesaat",
      "sesama",
      "sesampai",
      "sesegera",
      "sesekali",
      "seseorang",
      "sesuatu",
      "sesuatunya",
      "sesudah",
      "sesudahnya",
      "setelah",
      "setempat",
      "setengah",
      "seterusnya",
      "setiap",
      "setiba",
      "setibanya",
      "setidak-tidaknya",
      "setidaknya",
      "setinggi",
      "seusai",
      "sewaktu",
      "siap",
      "siapa",
      "siapakah",
      "siapapun",
      "sini",
      "sinilah",
      "soal",
      "soalnya",
      "suatu",
      "sudah",
      "sudahkah",
      "sudahlah",
      "supaya",
      "tadi",
      "tadinya",
      "tahu",
      "tahun",
      "tak",
      "tambah",
      "tambahnya",
      "tampak",
      "tampaknya",
      "tandas",
      "tandasnya",
      "tanpa",
      "tanya",
      "tanyakan",
      "tanyanya",
      "tapi",
      "tegas",
      "tegasnya",
      "telah",
      "tempat",
      "tengah",
      "tentang",
      "tentu",
      "tentulah",
      "tentunya",
      "tepat",
      "terakhir",
      "terasa",
      "terbanyak",
      "terdahulu",
      "terdapat",
      "terdiri",
      "terhadap",
      "terhadapnya",
      "teringat",
      "teringat-ingat",
      "terjadi",
      "terjadilah",
      "terjadinya",
      "terkira",
      "terlalu",
      "terlebih",
      "terlihat",
      "termasuk",
      "ternyata",
      "tersampaikan",
      "tersebut",
      "tersebutlah",
      "tertentu",
      "tertuju",
      "terus",
      "terutama",
      "tetap",
      "tetapi",
      "tiap",
      "tiba",
      "tiba-tiba",
      "tidak",
      "tidakkah",
      "tidaklah",
      "tiga",
      "tinggi",
      "toh",
      "tunjuk",
      "turut",
      "tutur",
      "tuturnya",
      "ucap",
      "ucapnya",
      "ujar",
      "ujarnya",
      "umum",
      "umumnya",
      "ungkap",
      "ungkapnya",
      "untuk",
      "usah",
      "usai",
      "waduh",
      "wah",
      "wahai",
      "waktu",
      "waktunya",
      "walau",
      "walaupun",
      "wong",
      "yaitu",
      "yakin",
      "yakni",
      "yang"
    };
  }
}

class Irish implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "ach",
      "ag",
      "agus",
      "an",
      "aon",
      "ar",
      "arna",
      "as",
      "b'",
      "ba",
      "beirt",
      "bhúr",
      "caoga",
      "ceathair",
      "ceathrar",
      "chomh",
      "chtó",
      "chuig",
      "chun",
      "cois",
      "céad",
      "cúig",
      "cúigear",
      "d'",
      "daichead",
      "dar",
      "de",
      "deich",
      "deichniúr",
      "den",
      "dhá",
      "do",
      "don",
      "dtí",
      "dá",
      "dár",
      "dó",
      "faoi",
      "faoin",
      "faoina",
      "faoinár",
      "fara",
      "fiche",
      "gach",
      "gan",
      "go",
      "gur",
      "haon",
      "hocht",
      "i",
      "iad",
      "idir",
      "in",
      "ina",
      "ins",
      "inár",
      "is",
      "le",
      "leis",
      "lena",
      "lenár",
      "m'",
      "mar",
      "mo",
      "mé",
      "na",
      "nach",
      "naoi",
      "naonúr",
      "ná",
      "ní",
      "níor",
      "nó",
      "nócha",
      "ocht",
      "ochtar",
      "os",
      "roimh",
      "sa",
      "seacht",
      "seachtar",
      "seachtó",
      "seasca",
      "seisear",
      "siad",
      "sibh",
      "sinn",
      "sna",
      "sé",
      "sí",
      "tar",
      "thar",
      "thú",
      "triúr",
      "trí",
      "trína",
      "trínár",
      "tríocha",
      "tú",
      "um",
      "ár",
      "é",
      "éis",
      "í",
      "ó",
      "ón",
      "óna",
      "ónár"
    };
  }
}

class Italian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "abbastanza",
      "abbia",
      "abbiamo",
      "abbiano",
      "abbiate",
      "accidenti",
      "ad",
      "adesso",
      "affinche",
      "agl",
      "agli",
      "ahime",
      "ahimã¨",
      "ahimè",
      "ai",
      "al",
      "alcuna",
      "alcuni",
      "alcuno",
      "all",
      "alla",
      "alle",
      "allo",
      "allora",
      "altre",
      "altri",
      "altrimenti",
      "altro",
      "altrove",
      "altrui",
      "anche",
      "ancora",
      "anni",
      "anno",
      "ansa",
      "anticipo",
      "assai",
      "attesa",
      "attraverso",
      "avanti",
      "avemmo",
      "avendo",
      "avente",
      "aver",
      "avere",
      "averlo",
      "avesse",
      "avessero",
      "avessi",
      "avessimo",
      "aveste",
      "avesti",
      "avete",
      "aveva",
      "avevamo",
      "avevano",
      "avevate",
      "avevi",
      "avevo",
      "avrai",
      "avranno",
      "avrebbe",
      "avrebbero",
      "avrei",
      "avremmo",
      "avremo",
      "avreste",
      "avresti",
      "avrete",
      "avrà",
      "avrò",
      "avuta",
      "avute",
      "avuti",
      "avuto",
      "basta",
      "ben",
      "bene",
      "benissimo",
      "berlusconi",
      "brava",
      "bravo",
      "buono",
      "c",
      "casa",
      "caso",
      "cento",
      "certa",
      "certe",
      "certi",
      "certo",
      "che",
      "chi",
      "chicchessia",
      "chiunque",
      "ci",
      "ciascuna",
      "ciascuno",
      "cima",
      "cinque",
      "cio",
      "cioe",
      "cioã¨",
      "cioè",
      "circa",
      "citta",
      "città",
      "cittã",
      "ciã²",
      "ciò",
      "co",
      "codesta",
      "codesti",
      "codesto",
      "cogli",
      "coi",
      "col",
      "colei",
      "coll",
      "coloro",
      "colui",
      "come",
      "cominci",
      "comprare",
      "comunque",
      "con",
      "concernente",
      "conciliarsi",
      "conclusione",
      "consecutivi",
      "consecutivo",
      "consiglio",
      "contro",
      "cortesia",
      "cos",
      "cosa",
      "cosi",
      "cosã¬",
      "così",
      "cui",
      "d",
      "da",
      "dagl",
      "dagli",
      "dai",
      "dal",
      "dall",
      "dalla",
      "dalle",
      "dallo",
      "dappertutto",
      "davanti",
      "degl",
      "degli",
      "dei",
      "del",
      "dell",
      "della",
      "delle",
      "dello",
      "dentro",
      "detto",
      "deve",
      "devo",
      "di",
      "dice",
      "dietro",
      "dire",
      "dirimpetto",
      "diventa",
      "diventare",
      "diventato",
      "dopo",
      "doppio",
      "dov",
      "dove",
      "dovra",
      "dovrà",
      "dovrã",
      "dovunque",
      "due",
      "dunque",
      "durante",
      "e",
      "ebbe",
      "ebbero",
      "ebbi",
      "ecc",
      "ecco",
      "ed",
      "effettivamente",
      "egli",
      "ella",
      "entrambi",
      "eppure",
      "era",
      "erano",
      "eravamo",
      "eravate",
      "eri",
      "ero",
      "esempio",
      "esse",
      "essendo",
      "esser",
      "essere",
      "essi",
      "ex",
      "fa",
      "faccia",
      "facciamo",
      "facciano",
      "facciate",
      "faccio",
      "facemmo",
      "facendo",
      "facesse",
      "facessero",
      "facessi",
      "facessimo",
      "faceste",
      "facesti",
      "faceva",
      "facevamo",
      "facevano",
      "facevate",
      "facevi",
      "facevo",
      "fai",
      "fanno",
      "farai",
      "faranno",
      "fare",
      "farebbe",
      "farebbero",
      "farei",
      "faremmo",
      "faremo",
      "fareste",
      "faresti",
      "farete",
      "farà",
      "farò",
      "fatto",
      "favore",
      "fece",
      "fecero",
      "feci",
      "fin",
      "finalmente",
      "finche",
      "fine",
      "fino",
      "forse",
      "forza",
      "fosse",
      "fossero",
      "fossi",
      "fossimo",
      "foste",
      "fosti",
      "fra",
      "frattempo",
      "fu",
      "fui",
      "fummo",
      "fuori",
      "furono",
      "futuro",
      "generale",
      "gente",
      "gia",
      "giacche",
      "giorni",
      "giorno",
      "giu",
      "già",
      "giã",
      "gli",
      "gliela",
      "gliele",
      "glieli",
      "glielo",
      "gliene",
      "governo",
      "grande",
      "grazie",
      "gruppo",
      "ha",
      "haha",
      "hai",
      "hanno",
      "ho",
      "i",
      "ie",
      "ieri",
      "il",
      "improvviso",
      "in",
      "inc",
      "indietro",
      "infatti",
      "inoltre",
      "insieme",
      "intanto",
      "intorno",
      "invece",
      "io",
      "l",
      "la",
      "lasciato",
      "lato",
      "lavoro",
      "le",
      "lei",
      "li",
      "lo",
      "lontano",
      "loro",
      "lui",
      "lungo",
      "luogo",
      "là",
      "lã",
      "ma",
      "macche",
      "magari",
      "maggior",
      "mai",
      "male",
      "malgrado",
      "malissimo",
      "mancanza",
      "marche",
      "me",
      "medesimo",
      "mediante",
      "meglio",
      "meno",
      "mentre",
      "mesi",
      "mezzo",
      "mi",
      "mia",
      "mie",
      "miei",
      "mila",
      "miliardi",
      "milioni",
      "minimi",
      "ministro",
      "mio",
      "modo",
      "molta",
      "molti",
      "moltissimo",
      "molto",
      "momento",
      "mondo",
      "mosto",
      "nazionale",
      "ne",
      "negl",
      "negli",
      "nei",
      "nel",
      "nell",
      "nella",
      "nelle",
      "nello",
      "nemmeno",
      "neppure",
      "nessun",
      "nessuna",
      "nessuno",
      "niente",
      "no",
      "noi",
      "nome",
      "non",
      "nondimeno",
      "nonostante",
      "nonsia",
      "nostra",
      "nostre",
      "nostri",
      "nostro",
      "novanta",
      "nove",
      "nulla",
      "nuovi",
      "nuovo",
      "o",
      "od",
      "oggi",
      "ogni",
      "ognuna",
      "ognuno",
      "oltre",
      "oppure",
      "ora",
      "ore",
      "osi",
      "ossia",
      "ottanta",
      "otto",
      "paese",
      "parecchi",
      "parecchie",
      "parecchio",
      "parte",
      "partendo",
      "peccato",
      "peggio",
      "per",
      "perche",
      "perchã¨",
      "perchè",
      "perché",
      "percio",
      "perciã²",
      "perciò",
      "perfino",
      "pero",
      "persino",
      "persone",
      "perã²",
      "però",
      "piedi",
      "pieno",
      "piglia",
      "piu",
      "piuttosto",
      "piã¹",
      "più",
      "po",
      "pochissimo",
      "poco",
      "poi",
      "poiche",
      "possa",
      "possedere",
      "posteriore",
      "posto",
      "potrebbe",
      "preferibilmente",
      "presa",
      "press",
      "prima",
      "primo",
      "principalmente",
      "probabilmente",
      "promesso",
      "proprio",
      "puo",
      "pure",
      "purtroppo",
      "puã²",
      "può",
      "qua",
      "qualche",
      "qualcosa",
      "qualcuna",
      "qualcuno",
      "quale",
      "quali",
      "qualunque",
      "quando",
      "quanta",
      "quante",
      "quanti",
      "quanto",
      "quantunque",
      "quarto",
      "quasi",
      "quattro",
      "quel",
      "quella",
      "quelle",
      "quelli",
      "quello",
      "quest",
      "questa",
      "queste",
      "questi",
      "questo",
      "qui",
      "quindi",
      "quinto",
      "realmente",
      "recente",
      "recentemente",
      "registrazione",
      "relativo",
      "riecco",
      "rispetto",
      "salvo",
      "sara",
      "sarai",
      "saranno",
      "sarebbe",
      "sarebbero",
      "sarei",
      "saremmo",
      "saremo",
      "sareste",
      "saresti",
      "sarete",
      "sarà",
      "sarã",
      "sarò",
      "scola",
      "scopo",
      "scorso",
      "se",
      "secondo",
      "seguente",
      "seguito",
      "sei",
      "sembra",
      "sembrare",
      "sembrato",
      "sembrava",
      "sembri",
      "sempre",
      "senza",
      "sette",
      "si",
      "sia",
      "siamo",
      "siano",
      "siate",
      "siete",
      "sig",
      "solito",
      "solo",
      "soltanto",
      "sono",
      "sopra",
      "soprattutto",
      "sotto",
      "spesso",
      "srl",
      "sta",
      "stai",
      "stando",
      "stanno",
      "starai",
      "staranno",
      "starebbe",
      "starebbero",
      "starei",
      "staremmo",
      "staremo",
      "stareste",
      "staresti",
      "starete",
      "starà",
      "starò",
      "stata",
      "state",
      "stati",
      "stato",
      "stava",
      "stavamo",
      "stavano",
      "stavate",
      "stavi",
      "stavo",
      "stemmo",
      "stessa",
      "stesse",
      "stessero",
      "stessi",
      "stessimo",
      "stesso",
      "steste",
      "stesti",
      "stette",
      "stettero",
      "stetti",
      "stia",
      "stiamo",
      "stiano",
      "stiate",
      "sto",
      "su",
      "sua",
      "subito",
      "successivamente",
      "successivo",
      "sue",
      "sugl",
      "sugli",
      "sui",
      "sul",
      "sull",
      "sulla",
      "sulle",
      "sullo",
      "suo",
      "suoi",
      "tale",
      "tali",
      "talvolta",
      "tanto",
      "te",
      "tempo",
      "terzo",
      "th",
      "ti",
      "titolo",
      "torino",
      "tra",
      "tranne",
      "tre",
      "trenta",
      "triplo",
      "troppo",
      "trovato",
      "tu",
      "tua",
      "tue",
      "tuo",
      "tuoi",
      "tutta",
      "tuttavia",
      "tutte",
      "tutti",
      "tutto",
      "uguali",
      "ulteriore",
      "ultimo",
      "un",
      "una",
      "uno",
      "uomo",
      "va",
      "vai",
      "vale",
      "vari",
      "varia",
      "varie",
      "vario",
      "verso",
      "vi",
      "via",
      "vicino",
      "visto",
      "vita",
      "voi",
      "volta",
      "volte",
      "vostra",
      "vostre",
      "vostri",
      "vostro",
      "ã¨",
      "è"
    };
  }
}

class Japanese implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "あそこ",
      "あっ",
      "あの",
      "あのかた",
      "あの人",
      "あり",
      "あります",
      "ある",
      "あれ",
      "い",
      "いう",
      "います",
      "いる",
      "う",
      "うち",
      "え",
      "お",
      "および",
      "おり",
      "おります",
      "か",
      "かつて",
      "から",
      "が",
      "き",
      "ここ",
      "こちら",
      "こと",
      "この",
      "これ",
      "これら",
      "さ",
      "さらに",
      "し",
      "しかし",
      "する",
      "ず",
      "せ",
      "せる",
      "そこ",
      "そして",
      "その",
      "その他",
      "その後",
      "それ",
      "それぞれ",
      "それで",
      "た",
      "ただし",
      "たち",
      "ため",
      "たり",
      "だ",
      "だっ",
      "だれ",
      "つ",
      "て",
      "で",
      "でき",
      "できる",
      "です",
      "では",
      "でも",
      "と",
      "という",
      "といった",
      "とき",
      "ところ",
      "として",
      "とともに",
      "とも",
      "と共に",
      "どこ",
      "どの",
      "な",
      "ない",
      "なお",
      "なかっ",
      "ながら",
      "なく",
      "なっ",
      "など",
      "なに",
      "なら",
      "なり",
      "なる",
      "なん",
      "に",
      "において",
      "における",
      "について",
      "にて",
      "によって",
      "により",
      "による",
      "に対して",
      "に対する",
      "に関する",
      "の",
      "ので",
      "のみ",
      "は",
      "ば",
      "へ",
      "ほか",
      "ほとんど",
      "ほど",
      "ます",
      "また",
      "または",
      "まで",
      "も",
      "もの",
      "ものの",
      "や",
      "よう",
      "より",
      "ら",
      "られ",
      "られる",
      "れ",
      "れる",
      "を",
      "ん",
      "何",
      "及び",
      "彼",
      "彼女",
      "我々",
      "特に",
      "私",
      "私達",
      "貴方",
      "貴方方"
    };
  }
}

class Korean implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "!",
      "\"",
      "\$",
      "%",
      "&",
      "'",
      "(",
      ")",
      "*",
      "+",
      ",",
      "-",
      ".",
      "...",
      "0",
      "1",
      "2",
      "3",
      "4",
      "5",
      "6",
      "7",
      "8",
      "9",
      ";",
      "<",
      "=",
      ">",
      "?",
      "@",
      "\\",
      "^",
      "_",
      "`",
      "|",
      "~",
      "·",
      "—",
      "——",
      "‘",
      "’",
      "“",
      "”",
      "…",
      "、",
      "。",
      "〈",
      "〉",
      "《",
      "》",
      "가",
      "가까스로",
      "가령",
      "각",
      "각각",
      "각자",
      "각종",
      "갖고말하자면",
      "같다",
      "같이",
      "개의치않고",
      "거니와",
      "거바",
      "거의",
      "것",
      "것과 같이",
      "것들",
      "게다가",
      "게우다",
      "겨우",
      "견지에서",
      "결과에 이르다",
      "결국",
      "결론을 낼 수 있다",
      "겸사겸사",
      "고려하면",
      "고로",
      "곧",
      "공동으로",
      "과",
      "과연",
      "관계가 있다",
      "관계없이",
      "관련이 있다",
      "관하여",
      "관한",
      "관해서는",
      "구",
      "구체적으로",
      "구토하다",
      "그",
      "그들",
      "그때",
      "그래",
      "그래도",
      "그래서",
      "그러나",
      "그러니",
      "그러니까",
      "그러면",
      "그러므로",
      "그러한즉",
      "그런 까닭에",
      "그런데",
      "그런즉",
      "그럼",
      "그럼에도 불구하고",
      "그렇게 함으로써",
      "그렇지",
      "그렇지 않다면",
      "그렇지 않으면",
      "그렇지만",
      "그렇지않으면",
      "그리고",
      "그리하여",
      "그만이다",
      "그에 따르는",
      "그위에",
      "그저",
      "그중에서",
      "그치지 않다",
      "근거로",
      "근거하여",
      "기대여",
      "기점으로",
      "기준으로",
      "기타",
      "까닭으로",
      "까악",
      "까지",
      "까지 미치다",
      "까지도",
      "꽈당",
      "끙끙",
      "끼익",
      "나",
      "나머지는",
      "남들",
      "남짓",
      "너",
      "너희",
      "너희들",
      "네",
      "넷",
      "년",
      "논하지 않다",
      "놀라다",
      "누가 알겠는가",
      "누구",
      "다른",
      "다른 방면으로",
      "다만",
      "다섯",
      "다소",
      "다수",
      "다시 말하자면",
      "다시말하면",
      "다음",
      "다음에",
      "다음으로",
      "단지",
      "답다",
      "당신",
      "당장",
      "대로 하다",
      "대하면",
      "대하여",
      "대해 말하자면",
      "대해서",
      "댕그",
      "더구나",
      "더군다나",
      "더라도",
      "더불어",
      "더욱더",
      "더욱이는",
      "도달하다",
      "도착하다",
      "동시에",
      "동안",
      "된바에야",
      "된이상",
      "두번째로",
      "둘",
      "둥둥",
      "뒤따라",
      "뒤이어",
      "든간에",
      "들",
      "등",
      "등등",
      "딩동",
      "따라",
      "따라서",
      "따위",
      "따지지 않다",
      "딱",
      "때",
      "때가 되어",
      "때문에",
      "또",
      "또한",
      "뚝뚝",
      "라 해도",
      "령",
      "로",
      "로 인하여",
      "로부터",
      "로써",
      "륙",
      "를",
      "마음대로",
      "마저",
      "마저도",
      "마치",
      "막론하고",
      "만 못하다",
      "만약",
      "만약에",
      "만은 아니다",
      "만이 아니다",
      "만일",
      "만큼",
      "말하자면",
      "말할것도 없고",
      "매",
      "매번",
      "메쓰겁다",
      "몇",
      "모",
      "모두",
      "무렵",
      "무릎쓰고",
      "무슨",
      "무엇",
      "무엇때문에",
      "물론",
      "및",
      "바꾸어말하면",
      "바꾸어말하자면",
      "바꾸어서 말하면",
      "바꾸어서 한다면",
      "바꿔 말하면",
      "바로",
      "바와같이",
      "밖에 안된다",
      "반대로",
      "반대로 말하자면",
      "반드시",
      "버금",
      "보는데서",
      "보다더",
      "보드득",
      "본대로",
      "봐",
      "봐라",
      "부류의 사람들",
      "부터",
      "불구하고",
      "불문하고",
      "붕붕",
      "비걱거리다",
      "비교적",
      "비길수 없다",
      "비로소",
      "비록",
      "비슷하다",
      "비추어 보아",
      "비하면",
      "뿐만 아니라",
      "뿐만아니라",
      "뿐이다",
      "삐걱",
      "삐걱거리다",
      "사",
      "삼",
      "상대적으로 말하자면",
      "생각한대로",
      "설령",
      "설마",
      "설사",
      "셋",
      "소생",
      "소인",
      "솨",
      "쉿",
      "습니까",
      "습니다",
      "시각",
      "시간",
      "시작하여",
      "시초에",
      "시키다",
      "실로",
      "심지어",
      "아",
      "아니",
      "아니나다를가",
      "아니라면",
      "아니면",
      "아니었다면",
      "아래윗",
      "아무거나",
      "아무도",
      "아야",
      "아울러",
      "아이",
      "아이고",
      "아이구",
      "아이야",
      "아이쿠",
      "아하",
      "아홉",
      "안 그러면",
      "않기 위하여",
      "않기 위해서",
      "알 수 있다",
      "알았어",
      "앗",
      "앞에서",
      "앞의것",
      "야",
      "약간",
      "양자",
      "어",
      "어기여차",
      "어느",
      "어느 년도",
      "어느것",
      "어느곳",
      "어느때",
      "어느쪽",
      "어느해",
      "어디",
      "어때",
      "어떠한",
      "어떤",
      "어떤것",
      "어떤것들",
      "어떻게",
      "어떻해",
      "어이",
      "어째서",
      "어쨋든",
      "어쩔수 없다",
      "어찌",
      "어찌됏든",
      "어찌됏어",
      "어찌하든지",
      "어찌하여",
      "언제",
      "언젠가",
      "얼마",
      "얼마 안 되는 것",
      "얼마간",
      "얼마나",
      "얼마든지",
      "얼마만큼",
      "얼마큼",
      "엉엉",
      "에",
      "에 가서",
      "에 달려 있다",
      "에 대해",
      "에 있다",
      "에 한하다",
      "에게",
      "에서",
      "여",
      "여기",
      "여덟",
      "여러분",
      "여보시오",
      "여부",
      "여섯",
      "여전히",
      "여차",
      "연관되다",
      "연이서",
      "영",
      "영차",
      "옆사람",
      "예",
      "예를 들면",
      "예를 들자면",
      "예컨대",
      "예하면",
      "오",
      "오로지",
      "오르다",
      "오자마자",
      "오직",
      "오호",
      "오히려",
      "와",
      "와 같은 사람들",
      "와르르",
      "와아",
      "왜",
      "왜냐하면",
      "외에도",
      "요만큼",
      "요만한 것",
      "요만한걸",
      "요컨대",
      "우르르",
      "우리",
      "우리들",
      "우선",
      "우에 종합한것과같이",
      "운운",
      "월",
      "위에서 서술한바와같이",
      "위하여",
      "위해서",
      "윙윙",
      "육",
      "으로",
      "으로 인하여",
      "으로서",
      "으로써",
      "을",
      "응",
      "응당",
      "의",
      "의거하여",
      "의지하여",
      "의해",
      "의해되다",
      "의해서",
      "이",
      "이 되다",
      "이 때문에",
      "이 밖에",
      "이 외에",
      "이 정도의",
      "이것",
      "이곳",
      "이때",
      "이라면",
      "이래",
      "이러이러하다",
      "이러한",
      "이런",
      "이럴정도로",
      "이렇게 많은 것",
      "이렇게되면",
      "이렇게말하자면",
      "이렇구나",
      "이로 인하여",
      "이르기까지",
      "이리하여",
      "이만큼",
      "이번",
      "이봐",
      "이상",
      "이어서",
      "이었다",
      "이와 같다",
      "이와 같은",
      "이와 반대로",
      "이와같다면",
      "이외에도",
      "이용하여",
      "이유만으로",
      "이젠",
      "이지만",
      "이쪽",
      "이천구",
      "이천육",
      "이천칠",
      "이천팔",
      "인 듯하다",
      "인젠",
      "일",
      "일것이다",
      "일곱",
      "일단",
      "일때",
      "일반적으로",
      "일지라도",
      "임에 틀림없다",
      "입각하여",
      "입장에서",
      "잇따라",
      "있다",
      "자",
      "자기",
      "자기집",
      "자마자",
      "자신",
      "잠깐",
      "잠시",
      "저",
      "저것",
      "저것만큼",
      "저기",
      "저쪽",
      "저희",
      "전부",
      "전자",
      "전후",
      "점에서 보아",
      "정도에 이르다",
      "제",
      "제각기",
      "제외하고",
      "조금",
      "조차",
      "조차도",
      "졸졸",
      "좀",
      "좋아",
      "좍좍",
      "주룩주룩",
      "주저하지 않고",
      "줄은 몰랏다",
      "줄은모른다",
      "중에서",
      "중의하나",
      "즈음하여",
      "즉",
      "즉시",
      "지든지",
      "지만",
      "지말고",
      "진짜로",
      "쪽으로",
      "차라리",
      "참",
      "참나",
      "첫번째로",
      "쳇",
      "총적으로",
      "총적으로 말하면",
      "총적으로 보면",
      "칠",
      "콸콸",
      "쾅쾅",
      "쿵",
      "타다",
      "타인",
      "탕탕",
      "토하다",
      "통하여",
      "툭",
      "퉤",
      "틈타",
      "팍",
      "팔",
      "퍽",
      "펄렁",
      "하",
      "하게될것이다",
      "하게하다",
      "하겠는가",
      "하고 있다",
      "하고있었다",
      "하곤하였다",
      "하구나",
      "하기 때문에",
      "하기 위하여",
      "하기는한데",
      "하기만 하면",
      "하기보다는",
      "하기에",
      "하나",
      "하느니",
      "하는 김에",
      "하는 편이 낫다",
      "하는것도",
      "하는것만 못하다",
      "하는것이 낫다",
      "하는바",
      "하더라도",
      "하도다",
      "하도록시키다",
      "하도록하다",
      "하든지",
      "하려고하다",
      "하마터면",
      "하면 할수록",
      "하면된다",
      "하면서",
      "하물며",
      "하여금",
      "하여야",
      "하자마자",
      "하지 않는다면",
      "하지 않도록",
      "하지마",
      "하지마라",
      "하지만",
      "하하",
      "한 까닭에",
      "한 이유는",
      "한 후",
      "한다면",
      "한다면 몰라도",
      "한데",
      "한마디",
      "한적이있다",
      "한켠으로는",
      "한항목",
      "할 따름이다",
      "할 생각이다",
      "할 줄 안다",
      "할 지경이다",
      "할 힘이 있다",
      "할때",
      "할만하다",
      "할망정",
      "할뿐",
      "할수있다",
      "할수있어",
      "할줄알다",
      "할지라도",
      "할지언정",
      "함께",
      "해도된다",
      "해도좋다",
      "해봐요",
      "해서는 안된다",
      "해야한다",
      "해요",
      "했어요",
      "향하다",
      "향하여",
      "향해서",
      "허",
      "허걱",
      "허허",
      "헉",
      "헉헉",
      "헐떡헐떡",
      "형식으로 쓰여",
      "혹시",
      "혹은",
      "혼자",
      "훨씬",
      "휘익",
      "휴",
      "흐흐",
      "흥",
      "힘입어",
      "︿",
      "！",
      "＃",
      "＄",
      "％",
      "＆",
      "（",
      "）",
      "＊",
      "＋",
      "，",
      "０",
      "１",
      "２",
      "３",
      "４",
      "５",
      "６",
      "７",
      "８",
      "９",
      "：",
      "；",
      "＜",
      "＞",
      "？",
      "＠",
      "［",
      "］",
      "｛",
      "｜",
      "｝",
      "～",
      "￥"
    };
  }
}

class Kurdish implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "ئێمە",
      "ئێوە",
      "ئەم",
      "ئەو",
      "ئەوان",
      "ئەوەی",
      "بۆ",
      "بێ",
      "بێجگە",
      "بە",
      "بەبێ",
      "بەدەم",
      "بەردەم",
      "بەرلە",
      "بەرەوی",
      "بەرەوە",
      "بەلای",
      "بەپێی",
      "تۆ",
      "تێ",
      "جگە",
      "دوای",
      "دوو",
      "دە",
      "دەکات",
      "دەگەڵ",
      "سەر",
      "لێ",
      "لە",
      "لەبابەت",
      "لەباتی",
      "لەبارەی",
      "لەبرێتی",
      "لەبن",
      "لەبەر",
      "لەبەینی",
      "لەدەم",
      "لەرێ",
      "لەرێگا",
      "لەرەوی",
      "لەسەر",
      "لەلایەن",
      "لەناو",
      "لەنێو",
      "لەو",
      "لەپێناوی",
      "لەژێر",
      "لەگەڵ",
      "من",
      "ناو",
      "نێوان",
      "هەر",
      "هەروەها",
      "و",
      "وەک",
      "پاش",
      "پێ",
      "پێش",
      "چەند",
      "کرد",
      "کە",
      "ی"
    };
  }
}

class Latin implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "ab",
      "ac",
      "ad",
      "at",
      "atque",
      "aut",
      "autem",
      "cum",
      "de",
      "dum",
      "e",
      "erant",
      "erat",
      "est",
      "et",
      "etiam",
      "ex",
      "haec",
      "hic",
      "hoc",
      "in",
      "ita",
      "me",
      "nec",
      "neque",
      "non",
      "per",
      "qua",
      "quae",
      "quam",
      "qui",
      "quibus",
      "quidem",
      "quo",
      "quod",
      "re",
      "rebus",
      "rem",
      "res",
      "sed",
      "si",
      "sic",
      "sunt",
      "tamen",
      "tandem",
      "te",
      "ut",
      "vel"
    };
  }
}

class Latvian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "aiz",
      "ap",
      "apakš",
      "apakšpus",
      "ar",
      "arī",
      "augšpus",
      "bet",
      "bez",
      "bija",
      "biji",
      "biju",
      "bijām",
      "bijāt",
      "būs",
      "būsi",
      "būsiet",
      "būsim",
      "būt",
      "būšu",
      "caur",
      "diemžēl",
      "diezin",
      "droši",
      "dēļ",
      "esam",
      "esat",
      "esi",
      "esmu",
      "gan",
      "gar",
      "iekam",
      "iekams",
      "iekām",
      "iekāms",
      "iekš",
      "iekšpus",
      "ik",
      "ir",
      "it",
      "itin",
      "iz",
      "ja",
      "jau",
      "jeb",
      "jebšu",
      "jel",
      "jo",
      "jā",
      "ka",
      "kamēr",
      "kaut",
      "kolīdz",
      "kopš",
      "kā",
      "kļuva",
      "kļuvi",
      "kļuvu",
      "kļuvām",
      "kļuvāt",
      "kļūs",
      "kļūsi",
      "kļūsiet",
      "kļūsim",
      "kļūst",
      "kļūstam",
      "kļūstat",
      "kļūsti",
      "kļūstu",
      "kļūt",
      "kļūšu",
      "labad",
      "lai",
      "lejpus",
      "līdz",
      "līdzko",
      "ne",
      "nebūt",
      "nedz",
      "nekā",
      "nevis",
      "nezin",
      "no",
      "nu",
      "nē",
      "otrpus",
      "pa",
      "par",
      "pat",
      "pie",
      "pirms",
      "pret",
      "priekš",
      "pār",
      "pēc",
      "starp",
      "tad",
      "tak",
      "tapi",
      "taps",
      "tapsi",
      "tapsiet",
      "tapsim",
      "tapt",
      "tapāt",
      "tapšu",
      "taču",
      "te",
      "tiec",
      "tiek",
      "tiekam",
      "tiekat",
      "tieku",
      "tik",
      "tika",
      "tikai",
      "tiki",
      "tikko",
      "tiklab",
      "tiklīdz",
      "tiks",
      "tiksiet",
      "tiksim",
      "tikt",
      "tiku",
      "tikvien",
      "tikām",
      "tikāt",
      "tikšu",
      "tomēr",
      "topat",
      "turpretim",
      "turpretī",
      "tā",
      "tādēļ",
      "tālab",
      "tāpēc",
      "un",
      "uz",
      "vai",
      "var",
      "varat",
      "varēja",
      "varēji",
      "varēju",
      "varējām",
      "varējāt",
      "varēs",
      "varēsi",
      "varēsiet",
      "varēsim",
      "varēt",
      "varēšu",
      "vien",
      "virs",
      "virspus",
      "vis",
      "viņpus",
      "zem",
      "ārpus",
      "šaipus"
    };
  }
}

class Lithuanian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "abi",
      "abidvi",
      "abiejose",
      "abiejuose",
      "abiejø",
      "abiem",
      "abigaliai",
      "abipus",
      "abu",
      "abudu",
      "ai",
      "ana",
      "anaiptol",
      "anaisiais",
      "anajai",
      "anajam",
      "anajame",
      "anapus",
      "anas",
      "anasai",
      "anasis",
      "anei",
      "aniedvi",
      "anieji",
      "aniesiems",
      "anoji",
      "anojo",
      "anojoje",
      "anokia",
      "anoks",
      "anosiomis",
      "anosioms",
      "anosios",
      "anosiose",
      "anot",
      "ant",
      "antai",
      "anuodu",
      "anuoju",
      "anuosiuose",
      "anuosius",
      "anàja",
      "anàjà",
      "anàjá",
      "anàsias",
      "anøjø",
      "apie",
      "aplink",
      "ar",
      "arba",
      "argi",
      "arti",
      "aukðèiau",
      "að",
      "be",
      "bei",
      "beje",
      "bemaþ",
      "bent",
      "bet",
      "betgi",
      "beveik",
      "dar",
      "dargi",
      "daugmaþ",
      "deja",
      "dëka",
      "dël",
      "dëlei",
      "dëlto",
      "ech",
      "et",
      "gal",
      "galbût",
      "galgi",
      "gan",
      "gana",
      "gi",
      "greta",
      "idant",
      "iki",
      "ir",
      "irgi",
      "it",
      "itin",
      "ið",
      "iðilgai",
      "iðvis",
      "jaisiais",
      "jajai",
      "jajam",
      "jajame",
      "jei",
      "jeigu",
      "ji",
      "jiedu",
      "jiedvi",
      "jieji",
      "jiesiems",
      "jinai",
      "jis",
      "jisai",
      "jog",
      "joji",
      "jojo",
      "jojoje",
      "jokia",
      "joks",
      "josiomis",
      "josioms",
      "josios",
      "josiose",
      "judu",
      "judvi",
      "juk",
      "jumis",
      "jums",
      "jumyse",
      "juodu",
      "juoju",
      "juosiuose",
      "juosius",
      "jus",
      "jàja",
      "jàjà",
      "jàsias",
      "jájá",
      "jøjø",
      "jûs",
      "jûsiðkis",
      "jûsiðkë",
      "jûsø",
      "kad",
      "kada",
      "kadangi",
      "kai",
      "kaip",
      "kaipgi",
      "kas",
      "katra",
      "katras",
      "katriedvi",
      "katruodu",
      "kaþin",
      "kaþkas",
      "kaþkatra",
      "kaþkatras",
      "kaþkokia",
      "kaþkoks",
      "kaþkuri",
      "kaþkuris",
      "kiaurai",
      "kiek",
      "kiekvienas",
      "kieno",
      "kita",
      "kitas",
      "kitokia",
      "kitoks",
      "kodël",
      "kokia",
      "koks",
      "kol",
      "kolei",
      "kone",
      "kuomet",
      "kur",
      "kurgi",
      "kuri",
      "kuriedvi",
      "kuris",
      "kuriuodu",
      "lai",
      "lig",
      "ligi",
      "link",
      "lyg",
      "man",
      "manaisiais",
      "manajai",
      "manajam",
      "manajame",
      "manas",
      "manasai",
      "manasis",
      "mane",
      "manieji",
      "maniesiems",
      "manim",
      "manimi",
      "maniðkis",
      "maniðkë",
      "mano",
      "manoji",
      "manojo",
      "manojoje",
      "manosiomis",
      "manosioms",
      "manosios",
      "manosiose",
      "manuoju",
      "manuosiuose",
      "manuosius",
      "manyje",
      "manàja",
      "manàjà",
      "manàjá",
      "manàsias",
      "manæs",
      "manøjø",
      "mat",
      "maþdaug",
      "maþne",
      "mes",
      "mudu",
      "mudvi",
      "mumis",
      "mums",
      "mumyse",
      "mus",
      "mûsiðkis",
      "mûsiðkë",
      "mûsø",
      "na",
      "nagi",
      "ne",
      "nebe",
      "nebent",
      "negi",
      "negu",
      "nei",
      "nejau",
      "nejaugi",
      "nekaip",
      "nelyginant",
      "nes",
      "net",
      "netgi",
      "netoli",
      "neva",
      "nors",
      "nuo",
      "në",
      "o",
      "ogi",
      "oi",
      "paeiliui",
      "pagal",
      "pakeliui",
      "palaipsniui",
      "palei",
      "pas",
      "pasak",
      "paskos",
      "paskui",
      "paskum",
      "pat",
      "pati",
      "patiems",
      "paties",
      "pats",
      "patys",
      "patá",
      "paèiais",
      "paèiam",
      "paèiame",
      "paèiu",
      "paèiuose",
      "paèius",
      "paèiø",
      "per",
      "pernelyg",
      "pirm",
      "pirma",
      "pirmiau",
      "po",
      "prie",
      "prieð",
      "prieðais",
      "pro",
      "pusiau",
      "rasi",
      "rodos",
      "sau",
      "savaisiais",
      "savajai",
      "savajam",
      "savajame",
      "savas",
      "savasai",
      "savasis",
      "save",
      "savieji",
      "saviesiems",
      "savimi",
      "saviðkis",
      "saviðkë",
      "savo",
      "savoji",
      "savojo",
      "savojoje",
      "savosiomis",
      "savosioms",
      "savosios",
      "savosiose",
      "savuoju",
      "savuosiuose",
      "savuosius",
      "savyje",
      "savàja",
      "savàjà",
      "savàjá",
      "savàsias",
      "savæs",
      "savøjø",
      "skersai",
      "skradþiai",
      "staèiai",
      "su",
      "sulig",
      "ta",
      "tad",
      "tai",
      "taigi",
      "taip",
      "taipogi",
      "taisiais",
      "tajai",
      "tajam",
      "tajame",
      "tamsta",
      "tarp",
      "tarsi",
      "tartum",
      "tarytum",
      "tas",
      "tasai",
      "tau",
      "tavaisiais",
      "tavajai",
      "tavajam",
      "tavajame",
      "tavas",
      "tavasai",
      "tavasis",
      "tave",
      "tavieji",
      "taviesiems",
      "tavimi",
      "taviðkis",
      "taviðkë",
      "tavo",
      "tavoji",
      "tavojo",
      "tavojoje",
      "tavosiomis",
      "tavosioms",
      "tavosios",
      "tavosiose",
      "tavuoju",
      "tavuosiuose",
      "tavuosius",
      "tavyje",
      "tavàja",
      "tavàjà",
      "tavàjá",
      "tavàsias",
      "tavæs",
      "tavøjø",
      "taèiau",
      "te",
      "tegu",
      "tegul",
      "tiedvi",
      "tieji",
      "ties",
      "tiesiems",
      "tiesiog",
      "tik",
      "tikriausiai",
      "tiktai",
      "toji",
      "tojo",
      "tojoje",
      "tokia",
      "toks",
      "tol",
      "tolei",
      "toliau",
      "tosiomis",
      "tosioms",
      "tosios",
      "tosiose",
      "tu",
      "tuodu",
      "tuoju",
      "tuosiuose",
      "tuosius",
      "turbût",
      "tàja",
      "tàjà",
      "tàjá",
      "tàsias",
      "tøjø",
      "tûlas",
      "uþ",
      "uþtat",
      "uþvis",
      "va",
      "vai",
      "viduj",
      "vidury",
      "vien",
      "vienas",
      "vienokia",
      "vienoks",
      "vietoj",
      "virð",
      "virðuj",
      "virðum",
      "vis",
      "vis dëlto",
      "visa",
      "visas",
      "visgi",
      "visokia",
      "visoks",
      "vos",
      "vël",
      "vëlgi",
      "ypaè",
      "á",
      "ákypai",
      "ástriþai",
      "ðalia",
      "ðe",
      "ði",
      "ðiaisiais",
      "ðiajai",
      "ðiajam",
      "ðiajame",
      "ðiapus",
      "ðiedvi",
      "ðieji",
      "ðiesiems",
      "ðioji",
      "ðiojo",
      "ðiojoje",
      "ðiokia",
      "ðioks",
      "ðiosiomis",
      "ðiosioms",
      "ðiosios",
      "ðiosiose",
      "ðis",
      "ðisai",
      "ðit",
      "ðita",
      "ðitas",
      "ðitiedvi",
      "ðitokia",
      "ðitoks",
      "ðituodu",
      "ðiuodu",
      "ðiuoju",
      "ðiuosiuose",
      "ðiuosius",
      "ðiàja",
      "ðiàjà",
      "ðiàsias",
      "ðiøjø",
      "ðtai",
      "ðájá",
      "þemiau"
    };
  }
}

class Malay implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "abdul",
      "abdullah",
      "acara",
      "ada",
      "adalah",
      "ahmad",
      "air",
      "akan",
      "akhbar",
      "akhir",
      "aktiviti",
      "alam",
      "amat",
      "amerika",
      "anak",
      "anggota",
      "antara",
      "antarabangsa",
      "apa",
      "apabila",
      "april",
      "as",
      "asas",
      "asean",
      "asia",
      "asing",
      "atas",
      "atau",
      "australia",
      "awal",
      "awam",
      "bagaimanapun",
      "bagi",
      "bahagian",
      "bahan",
      "baharu",
      "bahawa",
      "baik",
      "bandar",
      "bank",
      "banyak",
      "barangan",
      "baru",
      "baru-baru",
      "bawah",
      "beberapa",
      "bekas",
      "beliau",
      "belum",
      "berada",
      "berakhir",
      "berbanding",
      "berdasarkan",
      "berharap",
      "berikutan",
      "berjaya",
      "berjumlah",
      "berkaitan",
      "berkata",
      "berkenaan",
      "berlaku",
      "bermula",
      "bernama",
      "bernilai",
      "bersama",
      "berubah",
      "besar",
      "bhd",
      "bidang",
      "bilion",
      "bn",
      "boleh",
      "bukan",
      "bulan",
      "bursa",
      "cadangan",
      "china",
      "dagangan",
      "dalam",
      "dan",
      "dana",
      "dapat",
      "dari",
      "daripada",
      "dasar",
      "datang",
      "datuk",
      "demikian",
      "dengan",
      "depan",
      "derivatives",
      "dewan",
      "di",
      "diadakan",
      "dibuka",
      "dicatatkan",
      "dijangka",
      "diniagakan",
      "dis",
      "disember",
      "ditutup",
      "dolar",
      "dr",
      "dua",
      "dunia",
      "ekonomi",
      "eksekutif",
      "eksport",
      "empat",
      "enam",
      "faedah",
      "feb",
      "global",
      "hadapan",
      "hanya",
      "harga",
      "hari",
      "hasil",
      "hingga",
      "hubungan",
      "ia",
      "iaitu",
      "ialah",
      "indeks",
      "india",
      "indonesia",
      "industri",
      "ini",
      "islam",
      "isnin",
      "isu",
      "itu",
      "jabatan",
      "jalan",
      "jan",
      "jawatan",
      "jawatankuasa",
      "jepun",
      "jika",
      "jualan",
      "juga",
      "julai",
      "jumaat",
      "jumlah",
      "jun",
      "juta",
      "kadar",
      "kalangan",
      "kali",
      "kami",
      "kata",
      "katanya",
      "kaunter",
      "kawasan",
      "ke",
      "keadaan",
      "kecil",
      "kedua",
      "kedua-dua",
      "kedudukan",
      "kekal",
      "kementerian",
      "kemudahan",
      "kenaikan",
      "kenyataan",
      "kepada",
      "kepentingan",
      "keputusan",
      "kerajaan",
      "kerana",
      "kereta",
      "kerja",
      "kerjasama",
      "kes",
      "keselamatan",
      "keseluruhan",
      "kesihatan",
      "ketika",
      "ketua",
      "keuntungan",
      "kewangan",
      "khamis",
      "kini",
      "kira-kira",
      "kita",
      "klci",
      "klibor",
      "komposit",
      "kontrak",
      "kos",
      "kuala",
      "kuasa",
      "kukuh",
      "kumpulan",
      "lagi",
      "lain",
      "langkah",
      "laporan",
      "lebih",
      "lepas",
      "lima",
      "lot",
      "luar",
      "lumpur",
      "mac",
      "mahkamah",
      "mahu",
      "majlis",
      "makanan",
      "maklumat",
      "malam",
      "malaysia",
      "mana",
      "manakala",
      "masa",
      "masalah",
      "masih",
      "masing-masing",
      "masyarakat",
      "mata",
      "media",
      "mei",
      "melalui",
      "melihat",
      "memandangkan",
      "memastikan",
      "membantu",
      "membawa",
      "memberi",
      "memberikan",
      "membolehkan",
      "membuat",
      "mempunyai",
      "menambah",
      "menarik",
      "menawarkan",
      "mencapai",
      "mencatatkan",
      "mendapat",
      "mendapatkan",
      "menerima",
      "menerusi",
      "mengadakan",
      "mengambil",
      "mengenai",
      "menggalakkan",
      "menggunakan",
      "mengikut",
      "mengumumkan",
      "mengurangkan",
      "meningkat",
      "meningkatkan",
      "menjadi",
      "menjelang",
      "menokok",
      "menteri",
      "menunjukkan",
      "menurut",
      "menyaksikan",
      "menyediakan",
      "mereka",
      "merosot",
      "merupakan",
      "mesyuarat",
      "minat",
      "minggu",
      "minyak",
      "modal",
      "mohd",
      "mudah",
      "mungkin",
      "naik",
      "najib",
      "nasional",
      "negara",
      "negara-negara",
      "negeri",
      "niaga",
      "nilai",
      "nov",
      "ogos",
      "okt",
      "oleh",
      "operasi",
      "orang",
      "pada",
      "pagi",
      "paling",
      "pameran",
      "papan",
      "para",
      "paras",
      "parlimen",
      "parti",
      "pasaran",
      "pasukan",
      "pegawai",
      "pejabat",
      "pekerja",
      "pelabur",
      "pelaburan",
      "pelancongan",
      "pelanggan",
      "pelbagai",
      "peluang",
      "pembangunan",
      "pemberita",
      "pembinaan",
      "pemimpin",
      "pendapatan",
      "pendidikan",
      "penduduk",
      "penerbangan",
      "pengarah",
      "pengeluaran",
      "pengerusi",
      "pengguna",
      "pengurusan",
      "peniaga",
      "peningkatan",
      "penting",
      "peratus",
      "perdagangan",
      "perdana",
      "peringkat",
      "perjanjian",
      "perkara",
      "perkhidmatan",
      "perladangan",
      "perlu",
      "permintaan",
      "perniagaan",
      "persekutuan",
      "persidangan",
      "pertama",
      "pertubuhan",
      "pertumbuhan",
      "perusahaan",
      "peserta",
      "petang",
      "pihak",
      "pilihan",
      "pinjaman",
      "polis",
      "politik",
      "presiden",
      "prestasi",
      "produk",
      "program",
      "projek",
      "proses",
      "proton",
      "pukul",
      "pula",
      "pusat",
      "rabu",
      "rakan",
      "rakyat",
      "ramai",
      "rantau",
      "raya",
      "rendah",
      "ringgit",
      "rumah",
      "sabah",
      "sahaja",
      "saham",
      "sama",
      "sarawak",
      "satu",
      "sawit",
      "saya",
      "sdn",
      "sebagai",
      "sebahagian",
      "sebanyak",
      "sebarang",
      "sebelum",
      "sebelumnya",
      "sebuah",
      "secara",
      "sedang",
      "segi",
      "sehingga",
      "sejak",
      "sekarang",
      "sektor",
      "sekuriti",
      "selain",
      "selama",
      "selasa",
      "selatan",
      "selepas",
      "seluruh",
      "semakin",
      "semalam",
      "semasa",
      "sementara",
      "semua",
      "semula",
      "sen",
      "sendiri",
      "seorang",
      "sepanjang",
      "seperti",
      "sept",
      "september",
      "serantau",
      "seri",
      "serta",
      "sesi",
      "setiap",
      "setiausaha",
      "sidang",
      "singapura",
      "sini",
      "sistem",
      "sokongan",
      "sri",
      "sudah",
      "sukan",
      "suku",
      "sumber",
      "supaya",
      "susut",
      "syarikat",
      "syed",
      "tahap",
      "tahun",
      "tan",
      "tanah",
      "tanpa",
      "tawaran",
      "teknologi",
      "telah",
      "tempat",
      "tempatan",
      "tempoh",
      "tenaga",
      "tengah",
      "tentang",
      "terbaik",
      "terbang",
      "terbesar",
      "terbuka",
      "terdapat",
      "terhadap",
      "termasuk",
      "tersebut",
      "terus",
      "tetapi",
      "thailand",
      "tiada",
      "tidak",
      "tiga",
      "timbalan",
      "timur",
      "tindakan",
      "tinggi",
      "tun",
      "tunai",
      "turun",
      "turut",
      "umno",
      "unit",
      "untuk",
      "untung",
      "urus",
      "usaha",
      "utama",
      "walaupun",
      "wang",
      "wanita",
      "wilayah",
      "yang"
    };
  }
}

class Marathi implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "अधिक",
      "अनेक",
      "अशी",
      "असलयाचे",
      "असलेल्या",
      "असा",
      "असून",
      "असे",
      "आज",
      "आणि",
      "आता",
      "आपल्या",
      "आला",
      "आली",
      "आले",
      "आहे",
      "आहेत",
      "एक",
      "एका",
      "कमी",
      "करणयात",
      "करून",
      "का",
      "काम",
      "काय",
      "काही",
      "किवा",
      "की",
      "केला",
      "केली",
      "केले",
      "कोटी",
      "गेल्या",
      "घेऊन",
      "जात",
      "झाला",
      "झाली",
      "झाले",
      "झालेल्या",
      "टा",
      "डॉ",
      "तर",
      "तरी",
      "तसेच",
      "ता",
      "ती",
      "तीन",
      "ते",
      "तो",
      "त्या",
      "त्याचा",
      "त्याची",
      "त्याच्या",
      "त्याना",
      "त्यानी",
      "त्यामुळे",
      "त्री",
      "दिली",
      "दोन",
      "न",
      "नाही",
      "निर्ण्य",
      "पण",
      "पम",
      "परयतन",
      "पाटील",
      "म",
      "मात्र",
      "माहिती",
      "मी",
      "मुबी",
      "म्हणजे",
      "म्हणाले",
      "म्हणून",
      "या",
      "याचा",
      "याची",
      "याच्या",
      "याना",
      "यानी",
      "येणार",
      "येत",
      "येथील",
      "येथे",
      "लाख",
      "व",
      "व्यकत",
      "सर्व",
      "सागित्ले",
      "सुरू",
      "हजार",
      "हा",
      "ही",
      "हे",
      "होणार",
      "होत",
      "होता",
      "होती",
      "होते"
    };
  }
}

class Norwegian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "alle",
      "andre",
      "arbeid",
      "at",
      "av",
      "bare",
      "begge",
      "ble",
      "blei",
      "bli",
      "blir",
      "blitt",
      "bort",
      "bra",
      "bruke",
      "både",
      "båe",
      "da",
      "de",
      "deg",
      "dei",
      "deim",
      "deira",
      "deires",
      "dem",
      "den",
      "denne",
      "der",
      "dere",
      "deres",
      "det",
      "dette",
      "di",
      "din",
      "disse",
      "ditt",
      "du",
      "dykk",
      "dykkar",
      "då",
      "eg",
      "ein",
      "eit",
      "eitt",
      "eller",
      "elles",
      "en",
      "ene",
      "eneste",
      "enhver",
      "enn",
      "er",
      "et",
      "ett",
      "etter",
      "folk",
      "for",
      "fordi",
      "forsûke",
      "fra",
      "få",
      "før",
      "fûr",
      "fûrst",
      "gjorde",
      "gjûre",
      "god",
      "gå",
      "ha",
      "hadde",
      "han",
      "hans",
      "har",
      "hennar",
      "henne",
      "hennes",
      "her",
      "hjå",
      "ho",
      "hoe",
      "honom",
      "hoss",
      "hossen",
      "hun",
      "hva",
      "hvem",
      "hver",
      "hvilke",
      "hvilken",
      "hvis",
      "hvor",
      "hvordan",
      "hvorfor",
      "i",
      "ikke",
      "ikkje",
      "ingen",
      "ingi",
      "inkje",
      "inn",
      "innen",
      "inni",
      "ja",
      "jeg",
      "kan",
      "kom",
      "korleis",
      "korso",
      "kun",
      "kunne",
      "kva",
      "kvar",
      "kvarhelst",
      "kven",
      "kvi",
      "kvifor",
      "lage",
      "lang",
      "lik",
      "like",
      "makt",
      "man",
      "mange",
      "me",
      "med",
      "medan",
      "meg",
      "meget",
      "mellom",
      "men",
      "mens",
      "mer",
      "mest",
      "mi",
      "min",
      "mine",
      "mitt",
      "mot",
      "mye",
      "mykje",
      "må",
      "måte",
      "navn",
      "ned",
      "nei",
      "no",
      "noe",
      "noen",
      "noka",
      "noko",
      "nokon",
      "nokor",
      "nokre",
      "ny",
      "nå",
      "når",
      "og",
      "også",
      "om",
      "opp",
      "oss",
      "over",
      "part",
      "punkt",
      "på",
      "rett",
      "riktig",
      "samme",
      "sant",
      "seg",
      "selv",
      "si",
      "sia",
      "sidan",
      "siden",
      "sin",
      "sine",
      "sist",
      "sitt",
      "sjøl",
      "skal",
      "skulle",
      "slik",
      "slutt",
      "so",
      "som",
      "somme",
      "somt",
      "start",
      "stille",
      "så",
      "sånn",
      "tid",
      "til",
      "tilbake",
      "tilstand",
      "um",
      "under",
      "upp",
      "ut",
      "uten",
      "var",
      "vart",
      "varte",
      "ved",
      "verdi",
      "vere",
      "verte",
      "vi",
      "vil",
      "ville",
      "vite",
      "vore",
      "vors",
      "vort",
      "vår",
      "være",
      "vært",
      "vöre",
      "vört",
      "å"
    };
  }
}

class Persian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "!",
      ",",
      ".",
      ":",
      ";",
      "،",
      "؛",
      "؟",
      "آباد",
      "آره",
      "آری",
      "آمد",
      "آمده",
      "آن",
      "آنان",
      "آنجا",
      "آنطور",
      "آنقدر",
      "آنكه",
      "آنها",
      "آنچه",
      "آنکه",
      "آورد",
      "آورده",
      "آيد",
      "آی",
      "آیا",
      "آیند",
      "اتفاقا",
      "اثرِ",
      "احتراما",
      "احتمالا",
      "اخیر",
      "اری",
      "از",
      "ازجمله",
      "اساسا",
      "است",
      "استفاد",
      "استفاده",
      "اش",
      "اشکارا",
      "اصلا",
      "اصولا",
      "اعلام",
      "اغلب",
      "اكنون",
      "الان",
      "البته",
      "البتّه",
      "ام",
      "اما",
      "امروز",
      "امروزه",
      "امسال",
      "امشب",
      "امور",
      "ان",
      "انجام",
      "اند",
      "انشاالله",
      "انصافا",
      "انطور",
      "انقدر",
      "انها",
      "انچنان",
      "انکه",
      "انگار",
      "او",
      "اول",
      "اولا",
      "اي",
      "ايشان",
      "ايم",
      "اين",
      "اينكه",
      "اکثرا",
      "اکنون",
      "اگر",
      "ای",
      "ایا",
      "اید",
      "ایشان",
      "ایم",
      "این",
      "اینجا",
      "ایند",
      "اینطور",
      "اینقدر",
      "اینها",
      "اینچنین",
      "اینک",
      "اینکه",
      "اینگونه",
      "با",
      "بار",
      "بارة",
      "باره",
      "بارها",
      "باز",
      "بازهم",
      "باش",
      "باشد",
      "باشم",
      "باشند",
      "باشيم",
      "باشی",
      "باشید",
      "باشیم",
      "بالا",
      "بالاخره",
      "بالایِ",
      "بالطبع",
      "بايد",
      "باید",
      "بتوان",
      "بتواند",
      "بتوانی",
      "بتوانیم",
      "بخش",
      "بخشی",
      "بخواه",
      "بخواهد",
      "بخواهم",
      "بخواهند",
      "بخواهی",
      "بخواهید",
      "بخواهیم",
      "بد",
      "بدون",
      "بر",
      "برابر",
      "برابرِ",
      "براحتی",
      "براساس",
      "براستی",
      "براي",
      "برای",
      "برایِ",
      "برخوردار",
      "برخي",
      "برخی",
      "برداري",
      "برعکس",
      "بروز",
      "بزرگ",
      "بزودی",
      "بسا",
      "بسيار",
      "بسياري",
      "بسیار",
      "بسیاری",
      "بطور",
      "بعد",
      "بعدا",
      "بعدها",
      "بعری",
      "بعضا",
      "بعضي",
      "بلافاصله",
      "بلكه",
      "بله",
      "بلکه",
      "بلی",
      "بنابراين",
      "بنابراین",
      "بندي",
      "به",
      "بهتر",
      "بهترين",
      "بود",
      "بودم",
      "بودن",
      "بودند",
      "بوده",
      "بودی",
      "بودید",
      "بودیم",
      "بویژه",
      "بي",
      "بيست",
      "بيش",
      "بيشتر",
      "بيشتري",
      "بين",
      "بکن",
      "بکند",
      "بکنم",
      "بکنند",
      "بکنی",
      "بکنید",
      "بکنیم",
      "بگو",
      "بگوید",
      "بگویم",
      "بگویند",
      "بگویی",
      "بگویید",
      "بگوییم",
      "بگیر",
      "بگیرد",
      "بگیرم",
      "بگیرند",
      "بگیری",
      "بگیرید",
      "بگیریم",
      "بی",
      "بیا",
      "بیاب",
      "بیابد",
      "بیابم",
      "بیابند",
      "بیابی",
      "بیابید",
      "بیابیم",
      "بیاور",
      "بیاورد",
      "بیاورم",
      "بیاورند",
      "بیاوری",
      "بیاورید",
      "بیاوریم",
      "بیاید",
      "بیایم",
      "بیایند",
      "بیایی",
      "بیایید",
      "بیاییم",
      "بیرون",
      "بیرونِ",
      "بیش",
      "بیشتر",
      "بیشتری",
      "بین",
      "ت",
      "تا",
      "تازه",
      "تاكنون",
      "تان",
      "تاکنون",
      "تحت",
      "تر",
      "تر  براساس",
      "ترين",
      "تقریبا",
      "تلویحا",
      "تمام",
      "تماما",
      "تمامي",
      "تنها",
      "تو",
      "تواند",
      "توانست",
      "توانستم",
      "توانستن",
      "توانستند",
      "توانسته",
      "توانستی",
      "توانستیم",
      "توانم",
      "توانند",
      "توانی",
      "توانید",
      "توانیم",
      "توسط",
      "تولِ",
      "تویِ",
      "ثانیا",
      "جا",
      "جاي",
      "جايي",
      "جای",
      "جدا",
      "جديد",
      "جدید",
      "جريان",
      "جریان",
      "جز",
      "جلوگيري",
      "جلویِ",
      "جمعا",
      "جناح",
      "جهت",
      "حاضر",
      "حال",
      "حالا",
      "حتما",
      "حتي",
      "حتی",
      "حداکثر",
      "حدودا",
      "حدودِ",
      "حق",
      "خارجِ",
      "خب",
      "خدمات",
      "خصوصا",
      "خلاصه",
      "خواست",
      "خواستم",
      "خواستن",
      "خواستند",
      "خواسته",
      "خواستی",
      "خواستید",
      "خواستیم",
      "خواهد",
      "خواهم",
      "خواهند",
      "خواهيم",
      "خواهی",
      "خواهید",
      "خواهیم",
      "خوب",
      "خود",
      "خودت",
      "خودتان",
      "خودش",
      "خودشان",
      "خودم",
      "خودمان",
      "خوشبختانه",
      "خويش",
      "خویش",
      "خویشتن",
      "خیاه",
      "خیر",
      "خیلی",
      "داد",
      "دادم",
      "دادن",
      "دادند",
      "داده",
      "دادی",
      "دادید",
      "دادیم",
      "دار",
      "دارد",
      "دارم",
      "دارند",
      "داريم",
      "داری",
      "دارید",
      "داریم",
      "داشت",
      "داشتم",
      "داشتن",
      "داشتند",
      "داشته",
      "داشتی",
      "داشتید",
      "داشتیم",
      "دانست",
      "دانند",
      "دایم",
      "دایما",
      "در",
      "درباره",
      "درمجموع",
      "درون",
      "دریغ",
      "دقیقا",
      "دنبالِ",
      "ده",
      "دهد",
      "دهم",
      "دهند",
      "دهی",
      "دهید",
      "دهیم",
      "دو",
      "دوباره",
      "دوم",
      "ديده",
      "ديروز",
      "ديگر",
      "ديگران",
      "ديگري",
      "دیر",
      "دیروز",
      "دیگر",
      "دیگران",
      "دیگری",
      "را",
      "راحت",
      "راسا",
      "راستی",
      "راه",
      "رسما",
      "رسید",
      "رفت",
      "رفته",
      "رو",
      "روب",
      "روز",
      "روزانه",
      "روزهاي",
      "روي",
      "روی",
      "رویِ",
      "ريزي",
      "زمان",
      "زمانی",
      "زمینه",
      "زود",
      "زياد",
      "زير",
      "زيرا",
      "زیر",
      "زیرِ",
      "سابق",
      "ساخته",
      "سازي",
      "سالانه",
      "سالیانه",
      "سایر",
      "سراسر",
      "سرانجام",
      "سریعا",
      "سریِ",
      "سعي",
      "سمتِ",
      "سوم",
      "سوي",
      "سوی",
      "سویِ",
      "سپس",
      "شان",
      "شايد",
      "شاید",
      "شخصا",
      "شد",
      "شدم",
      "شدن",
      "شدند",
      "شده",
      "شدی",
      "شدید",
      "شدیدا",
      "شدیم",
      "شش",
      "شش  نداشته",
      "شما",
      "شناسي",
      "شود",
      "شوم",
      "شوند",
      "شونده",
      "شوی",
      "شوید",
      "شویم",
      "صرفا",
      "صورت",
      "ضدِّ",
      "ضدِّ",
      "ضمن",
      "طبعا",
      "طبقِ",
      "طبیعتا",
      "طرف",
      "طريق",
      "طریق",
      "طور",
      "طي",
      "طی",
      "ظاهرا",
      "عدم",
      "عقبِ",
      "علّتِ",
      "علیه",
      "عمدا",
      "عمدتا",
      "عمل",
      "عملا",
      "عنوان",
      "عنوانِ",
      "غالبا",
      "غير",
      "غیر",
      "فردا",
      "فعلا",
      "فقط",
      "فكر",
      "فوق",
      "قابل",
      "قبل",
      "قبلا",
      "قدری",
      "قصدِ",
      "قطعا",
      "كرد",
      "كردم",
      "كردن",
      "كردند",
      "كرده",
      "كسي",
      "كل",
      "كمتر",
      "كند",
      "كنم",
      "كنند",
      "كنيد",
      "كنيم",
      "كه",
      "لااقل",
      "لطفا",
      "لطفاً",
      "ما",
      "مان",
      "مانند",
      "مانندِ",
      "مبادا",
      "متاسفانه",
      "متعاقبا",
      "مثل",
      "مثلا",
      "مثلِ",
      "مجانی",
      "مجددا",
      "مجموعا",
      "مختلف",
      "مدام",
      "مدت",
      "مدّتی",
      "مردم",
      "مرسی",
      "مستقیما",
      "مسلما",
      "مطمینا",
      "معمولا",
      "مقابل",
      "ممکن",
      "من",
      "موارد",
      "مورد",
      "موقتا",
      "مي",
      "ميليارد",
      "ميليون",
      "مگر",
      "می",
      "می شود",
      "میان",
      "می‌رسد",
      "می‌رود",
      "می‌شود",
      "می‌کنیم",
      "ناشي",
      "نام",
      "ناگاه",
      "ناگهان",
      "ناگهانی",
      "نبايد",
      "نباید",
      "نبود",
      "نخست",
      "نخستين",
      "نخواهد",
      "نخواهم",
      "نخواهند",
      "نخواهی",
      "نخواهید",
      "نخواهیم",
      "ندارد",
      "ندارم",
      "ندارند",
      "نداری",
      "ندارید",
      "نداریم",
      "نداشت",
      "نداشتم",
      "نداشتند",
      "نداشته",
      "نداشتی",
      "نداشتید",
      "نداشتیم",
      "نزديك",
      "نزدِ",
      "نزدیکِ",
      "نسبتا",
      "نشان",
      "نشده",
      "نظير",
      "نظیر",
      "نكرده",
      "نمايد",
      "نمي",
      "نمی",
      "نمی‌شود",
      "نه",
      "نهایتا",
      "نوع",
      "نوعي",
      "نوعی",
      "نيز",
      "نيست",
      "نگاه",
      "نیز",
      "نیست",
      "ها",
      "هاي",
      "هايي",
      "های",
      "هایی",
      "هبچ",
      "هر",
      "هرچه",
      "هرگز",
      "هزار",
      "هست",
      "هستم",
      "هستند",
      "هستيم",
      "هستی",
      "هستید",
      "هستیم",
      "هفت",
      "هم",
      "همان",
      "همه",
      "همواره",
      "همين",
      "همچنان",
      "همچنين",
      "همچنین",
      "همچون",
      "همیشه",
      "همین",
      "هنوز",
      "هنگام",
      "هنگامِ",
      "هنگامی",
      "هيچ",
      "هیچ",
      "هیچگاه",
      "و",
      "واقعا",
      "واقعی",
      "وجود",
      "وسطِ",
      "وضع",
      "وقتي",
      "وقتی",
      "وقتیکه",
      "ولی",
      "وي",
      "وگو",
      "وی",
      "ویژه",
      "يا",
      "يابد",
      "يك",
      "يكديگر",
      "يكي",
      "ّه",
      "٪",
      "پارسال",
      "پاعینِ",
      "پس",
      "پنج",
      "پيش",
      "پیدا",
      "پیش",
      "پیشاپیش",
      "پیشتر",
      "پیشِ",
      "چرا",
      "چطور",
      "چقدر",
      "چنان",
      "چنانچه",
      "چنانکه",
      "چند",
      "چندین",
      "چنين",
      "چنین",
      "چه",
      "چهار",
      "چو",
      "چون",
      "چيزي",
      "چگونه",
      "چیز",
      "چیزی",
      "چیست",
      "کاش",
      "کامل",
      "کاملا",
      "کتبا",
      "کجا",
      "کجاست",
      "کدام",
      "کرد",
      "کردم",
      "کردن",
      "کردند",
      "کرده",
      "کردی",
      "کردید",
      "کردیم",
      "کس",
      "کسانی",
      "کسی",
      "کل",
      "کلا",
      "کم",
      "کماکان",
      "کمتر",
      "کمتری",
      "کمی",
      "کن",
      "کنار",
      "کنارِ",
      "کند",
      "کنم",
      "کنند",
      "کننده",
      "کنون",
      "کنونی",
      "کنی",
      "کنید",
      "کنیم",
      "که",
      "کو",
      "کَی",
      "کی",
      "گاه",
      "گاهی",
      "گذاري",
      "گذاشته",
      "گذشته",
      "گردد",
      "گرفت",
      "گرفتم",
      "گرفتن",
      "گرفتند",
      "گرفته",
      "گرفتی",
      "گرفتید",
      "گرفتیم",
      "گروهي",
      "گفت",
      "گفتم",
      "گفتن",
      "گفتند",
      "گفته",
      "گفتی",
      "گفتید",
      "گفتیم",
      "گه",
      "گهگاه",
      "گو",
      "گويد",
      "گويند",
      "گویا",
      "گوید",
      "گویم",
      "گویند",
      "گویی",
      "گویید",
      "گوییم",
      "گيرد",
      "گيري",
      "گیرد",
      "گیرم",
      "گیرند",
      "گیری",
      "گیرید",
      "گیریم",
      "ی",
      "یا",
      "یابد",
      "یابم",
      "یابند",
      "یابی",
      "یابید",
      "یابیم",
      "یافت",
      "یافتم",
      "یافتن",
      "یافته",
      "یافتی",
      "یافتید",
      "یافتیم",
      "یعنی",
      "یقینا",
      "یه",
      "یک",
      "یکی",
      "۰",
      "۱",
      "۲",
      "۳",
      "۴",
      "۵",
      "۶",
      "۷",
      "۸",
      "۹"
    };
  }
}

class Polish implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "aby",
      "ach",
      "acz",
      "aczkolwiek",
      "aj",
      "albo",
      "ale",
      "ależ",
      "ani",
      "aż",
      "bardziej",
      "bardzo",
      "bez",
      "bo",
      "bowiem",
      "by",
      "byli",
      "bym",
      "bynajmniej",
      "byä‡",
      "być",
      "był",
      "była",
      "było",
      "były",
      "będzie",
      "będą",
      "cali",
      "cała",
      "cały",
      "chce",
      "choć",
      "ci",
      "ciebie",
      "ciä™",
      "cię",
      "co",
      "cokolwiek",
      "coraz",
      "coś",
      "czasami",
      "czasem",
      "czemu",
      "czy",
      "czyli",
      "często",
      "daleko",
      "dla",
      "dlaczego",
      "dlatego",
      "do",
      "dobrze",
      "dokä…d",
      "dokąd",
      "doå›ä‡",
      "dość",
      "dr",
      "duå¼o",
      "dużo",
      "dwa",
      "dwaj",
      "dwie",
      "dwoje",
      "dzisiaj",
      "dziå›",
      "dziś",
      "gdy",
      "gdyby",
      "gdyż",
      "gdzie",
      "gdziekolwiek",
      "gdzieś",
      "go",
      "godz",
      "hab",
      "i",
      "ich",
      "ii",
      "iii",
      "ile",
      "im",
      "inna",
      "inne",
      "inny",
      "innych",
      "inż",
      "iv",
      "ix",
      "iż",
      "ja",
      "jak",
      "jakaś",
      "jakby",
      "jaki",
      "jakichś",
      "jakie",
      "jakiś",
      "jakiż",
      "jakkolwiek",
      "jako",
      "jakoś",
      "je",
      "jeden",
      "jedna",
      "jednak",
      "jednakże",
      "jedno",
      "jednym",
      "jedynie",
      "jego",
      "jej",
      "jemu",
      "jest",
      "jestem",
      "jeszcze",
      "jeå¼eli",
      "jeå›li",
      "jeśli",
      "jeżeli",
      "juå¼",
      "już",
      "jä…",
      "ją",
      "kaå¼dy",
      "każdy",
      "kiedy",
      "kierunku",
      "kilka",
      "kilku",
      "kimś",
      "kto",
      "ktokolwiek",
      "ktoś",
      "która",
      "które",
      "którego",
      "której",
      "który",
      "których",
      "którym",
      "którzy",
      "ku",
      "lat",
      "lecz",
      "lub",
      "ma",
      "majä…",
      "mają",
      "mam",
      "mamy",
      "mało",
      "mgr",
      "mi",
      "miał",
      "mimo",
      "między",
      "mnie",
      "mnä…",
      "mną",
      "mogą",
      "moi",
      "moim",
      "moja",
      "moje",
      "moå¼e",
      "może",
      "możliwe",
      "można",
      "mu",
      "musi",
      "my",
      "mã³j",
      "mój",
      "na",
      "nad",
      "nam",
      "nami",
      "nas",
      "nasi",
      "nasz",
      "nasza",
      "nasze",
      "naszego",
      "naszych",
      "natomiast",
      "natychmiast",
      "nawet",
      "nic",
      "nich",
      "nie",
      "niech",
      "niego",
      "niej",
      "niemu",
      "nigdy",
      "nim",
      "nimi",
      "niä…",
      "niå¼",
      "nią",
      "niż",
      "no",
      "nowe",
      "np",
      "nr",
      "o",
      "o.o.",
      "obok",
      "od",
      "ok",
      "okoå‚o",
      "około",
      "on",
      "ona",
      "one",
      "oni",
      "ono",
      "oraz",
      "oto",
      "owszem",
      "pan",
      "pana",
      "pani",
      "pl",
      "po",
      "pod",
      "podczas",
      "pomimo",
      "ponad",
      "poniewaå¼",
      "ponieważ",
      "powinien",
      "powinna",
      "powinni",
      "powinno",
      "poza",
      "prawie",
      "prof",
      "przecież",
      "przed",
      "przede",
      "przedtem",
      "przez",
      "przy",
      "raz",
      "razie",
      "roku",
      "również",
      "sam",
      "sama",
      "siä™",
      "się",
      "skä…d",
      "skąd",
      "sobie",
      "sobą",
      "sposób",
      "swoje",
      "sä…",
      "są",
      "ta",
      "tak",
      "taka",
      "taki",
      "takich",
      "takie",
      "także",
      "tam",
      "te",
      "tego",
      "tej",
      "tel",
      "temu",
      "ten",
      "teraz",
      "też",
      "to",
      "tobie",
      "tobä…",
      "tobą",
      "toteż",
      "totobą",
      "trzeba",
      "tu",
      "tutaj",
      "twoi",
      "twoim",
      "twoja",
      "twoje",
      "twym",
      "twã³j",
      "twój",
      "ty",
      "tych",
      "tylko",
      "tym",
      "tys",
      "tzw",
      "tę",
      "u",
      "ul",
      "vi",
      "vii",
      "viii",
      "vol",
      "w",
      "wam",
      "wami",
      "was",
      "wasi",
      "wasz",
      "wasza",
      "wasze",
      "we",
      "według",
      "wie",
      "wiele",
      "wielu",
      "wiä™c",
      "więc",
      "więcej",
      "wszyscy",
      "wszystkich",
      "wszystkie",
      "wszystkim",
      "wszystko",
      "wtedy",
      "www",
      "wy",
      "właśnie",
      "wśród",
      "xi",
      "xii",
      "xiii",
      "xiv",
      "xv",
      "z",
      "za",
      "zapewne",
      "zawsze",
      "zaś",
      "ze",
      "zeznowu",
      "znowu",
      "znów",
      "został",
      "zł",
      "å¼aden",
      "å¼e",
      "żaden",
      "żadna",
      "żadne",
      "żadnych",
      "że",
      "żeby"
    };
  }
}

class Portuguese implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "acerca",
      "adeus",
      "agora",
      "ainda",
      "alem",
      "algmas",
      "algo",
      "algumas",
      "alguns",
      "ali",
      "além",
      "ambas",
      "ambos",
      "ano",
      "anos",
      "antes",
      "ao",
      "aonde",
      "aos",
      "apenas",
      "apoio",
      "apontar",
      "apos",
      "após",
      "aquela",
      "aquelas",
      "aquele",
      "aqueles",
      "aqui",
      "aquilo",
      "as",
      "assim",
      "através",
      "atrás",
      "até",
      "aí",
      "baixo",
      "bastante",
      "bem",
      "boa",
      "boas",
      "bom",
      "bons",
      "breve",
      "cada",
      "caminho",
      "catorze",
      "cedo",
      "cento",
      "certamente",
      "certeza",
      "cima",
      "cinco",
      "coisa",
      "com",
      "como",
      "comprido",
      "conhecido",
      "conselho",
      "contra",
      "contudo",
      "corrente",
      "cuja",
      "cujas",
      "cujo",
      "cujos",
      "custa",
      "cá",
      "da",
      "daquela",
      "daquelas",
      "daquele",
      "daqueles",
      "dar",
      "das",
      "de",
      "debaixo",
      "dela",
      "delas",
      "dele",
      "deles",
      "demais",
      "dentro",
      "depois",
      "desde",
      "desligado",
      "dessa",
      "dessas",
      "desse",
      "desses",
      "desta",
      "destas",
      "deste",
      "destes",
      "deve",
      "devem",
      "deverá",
      "dez",
      "dezanove",
      "dezasseis",
      "dezassete",
      "dezoito",
      "dia",
      "diante",
      "direita",
      "dispoe",
      "dispoem",
      "diversa",
      "diversas",
      "diversos",
      "diz",
      "dizem",
      "dizer",
      "do",
      "dois",
      "dos",
      "doze",
      "duas",
      "durante",
      "dá",
      "dão",
      "dúvida",
      "e",
      "ela",
      "elas",
      "ele",
      "eles",
      "em",
      "embora",
      "enquanto",
      "entao",
      "entre",
      "então",
      "era",
      "eram",
      "essa",
      "essas",
      "esse",
      "esses",
      "esta",
      "estado",
      "estamos",
      "estar",
      "estará",
      "estas",
      "estava",
      "estavam",
      "este",
      "esteja",
      "estejam",
      "estejamos",
      "estes",
      "esteve",
      "estive",
      "estivemos",
      "estiver",
      "estivera",
      "estiveram",
      "estiverem",
      "estivermos",
      "estivesse",
      "estivessem",
      "estiveste",
      "estivestes",
      "estivéramos",
      "estivéssemos",
      "estou",
      "está",
      "estás",
      "estávamos",
      "estão",
      "eu",
      "exemplo",
      "falta",
      "fará",
      "favor",
      "faz",
      "fazeis",
      "fazem",
      "fazemos",
      "fazer",
      "fazes",
      "fazia",
      "faço",
      "fez",
      "fim",
      "final",
      "foi",
      "fomos",
      "for",
      "fora",
      "foram",
      "forem",
      "forma",
      "formos",
      "fosse",
      "fossem",
      "foste",
      "fostes",
      "fui",
      "fôramos",
      "fôssemos",
      "geral",
      "grande",
      "grandes",
      "grupo",
      "ha",
      "haja",
      "hajam",
      "hajamos",
      "havemos",
      "havia",
      "hei",
      "hoje",
      "hora",
      "horas",
      "houve",
      "houvemos",
      "houver",
      "houvera",
      "houveram",
      "houverei",
      "houverem",
      "houveremos",
      "houveria",
      "houveriam",
      "houvermos",
      "houverá",
      "houverão",
      "houveríamos",
      "houvesse",
      "houvessem",
      "houvéramos",
      "houvéssemos",
      "há",
      "hão",
      "iniciar",
      "inicio",
      "ir",
      "irá",
      "isso",
      "ista",
      "iste",
      "isto",
      "já",
      "lado",
      "lhe",
      "lhes",
      "ligado",
      "local",
      "logo",
      "longe",
      "lugar",
      "lá",
      "maior",
      "maioria",
      "maiorias",
      "mais",
      "mal",
      "mas",
      "me",
      "mediante",
      "meio",
      "menor",
      "menos",
      "meses",
      "mesma",
      "mesmas",
      "mesmo",
      "mesmos",
      "meu",
      "meus",
      "mil",
      "minha",
      "minhas",
      "momento",
      "muito",
      "muitos",
      "máximo",
      "mês",
      "na",
      "nada",
      "nao",
      "naquela",
      "naquelas",
      "naquele",
      "naqueles",
      "nas",
      "nem",
      "nenhuma",
      "nessa",
      "nessas",
      "nesse",
      "nesses",
      "nesta",
      "nestas",
      "neste",
      "nestes",
      "no",
      "noite",
      "nome",
      "nos",
      "nossa",
      "nossas",
      "nosso",
      "nossos",
      "nova",
      "novas",
      "nove",
      "novo",
      "novos",
      "num",
      "numa",
      "numas",
      "nunca",
      "nuns",
      "não",
      "nível",
      "nós",
      "número",
      "o",
      "obra",
      "obrigada",
      "obrigado",
      "oitava",
      "oitavo",
      "oito",
      "onde",
      "ontem",
      "onze",
      "os",
      "ou",
      "outra",
      "outras",
      "outro",
      "outros",
      "para",
      "parece",
      "parte",
      "partir",
      "paucas",
      "pegar",
      "pela",
      "pelas",
      "pelo",
      "pelos",
      "perante",
      "perto",
      "pessoas",
      "pode",
      "podem",
      "poder",
      "poderá",
      "podia",
      "pois",
      "ponto",
      "pontos",
      "por",
      "porque",
      "porquê",
      "portanto",
      "posição",
      "possivelmente",
      "posso",
      "possível",
      "pouca",
      "pouco",
      "poucos",
      "povo",
      "primeira",
      "primeiras",
      "primeiro",
      "primeiros",
      "promeiro",
      "propios",
      "proprio",
      "própria",
      "próprias",
      "próprio",
      "próprios",
      "próxima",
      "próximas",
      "próximo",
      "próximos",
      "puderam",
      "pôde",
      "põe",
      "põem",
      "quais",
      "qual",
      "qualquer",
      "quando",
      "quanto",
      "quarta",
      "quarto",
      "quatro",
      "que",
      "quem",
      "quer",
      "quereis",
      "querem",
      "queremas",
      "queres",
      "quero",
      "questão",
      "quieto",
      "quinta",
      "quinto",
      "quinze",
      "quáis",
      "quê",
      "relação",
      "sabe",
      "sabem",
      "saber",
      "se",
      "segunda",
      "segundo",
      "sei",
      "seis",
      "seja",
      "sejam",
      "sejamos",
      "sem",
      "sempre",
      "sendo",
      "ser",
      "serei",
      "seremos",
      "seria",
      "seriam",
      "será",
      "serão",
      "seríamos",
      "sete",
      "seu",
      "seus",
      "sexta",
      "sexto",
      "sim",
      "sistema",
      "sob",
      "sobre",
      "sois",
      "somente",
      "somos",
      "sou",
      "sua",
      "suas",
      "são",
      "sétima",
      "sétimo",
      "só",
      "tal",
      "talvez",
      "tambem",
      "também",
      "tanta",
      "tantas",
      "tanto",
      "tarde",
      "te",
      "tem",
      "temos",
      "tempo",
      "tendes",
      "tenha",
      "tenham",
      "tenhamos",
      "tenho",
      "tens",
      "tentar",
      "tentaram",
      "tente",
      "tentei",
      "ter",
      "terceira",
      "terceiro",
      "terei",
      "teremos",
      "teria",
      "teriam",
      "terá",
      "terão",
      "teríamos",
      "teu",
      "teus",
      "teve",
      "tinha",
      "tinham",
      "tipo",
      "tive",
      "tivemos",
      "tiver",
      "tivera",
      "tiveram",
      "tiverem",
      "tivermos",
      "tivesse",
      "tivessem",
      "tiveste",
      "tivestes",
      "tivéramos",
      "tivéssemos",
      "toda",
      "todas",
      "todo",
      "todos",
      "trabalhar",
      "trabalho",
      "treze",
      "três",
      "tu",
      "tua",
      "tuas",
      "tudo",
      "tão",
      "tém",
      "têm",
      "tínhamos",
      "um",
      "uma",
      "umas",
      "uns",
      "usa",
      "usar",
      "vai",
      "vais",
      "valor",
      "veja",
      "vem",
      "vens",
      "ver",
      "verdade",
      "verdadeiro",
      "vez",
      "vezes",
      "viagem",
      "vindo",
      "vinte",
      "você",
      "vocês",
      "vos",
      "vossa",
      "vossas",
      "vosso",
      "vossos",
      "vários",
      "vão",
      "vêm",
      "vós",
      "zero",
      "à",
      "às",
      "área",
      "é",
      "éramos",
      "és",
      "último"
    };
  }
}

class Romanian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "abia",
      "acea",
      "aceasta",
      "această",
      "aceea",
      "aceeasi",
      "acei",
      "aceia",
      "acel",
      "acela",
      "acelasi",
      "acele",
      "acelea",
      "acest",
      "acesta",
      "aceste",
      "acestea",
      "acestei",
      "acestia",
      "acestui",
      "aceşti",
      "aceştia",
      "acolo",
      "acord",
      "acum",
      "adica",
      "ai",
      "aia",
      "aibă",
      "aici",
      "aiurea",
      "al",
      "ala",
      "alaturi",
      "ale",
      "alea",
      "alt",
      "alta",
      "altceva",
      "altcineva",
      "alte",
      "altfel",
      "alti",
      "altii",
      "altul",
      "am",
      "anume",
      "apoi",
      "ar",
      "are",
      "as",
      "asa",
      "asemenea",
      "asta",
      "astazi",
      "astea",
      "astfel",
      "astăzi",
      "asupra",
      "atare",
      "atat",
      "atata",
      "atatea",
      "atatia",
      "ati",
      "atit",
      "atita",
      "atitea",
      "atitia",
      "atunci",
      "au",
      "avea",
      "avem",
      "aveţi",
      "avut",
      "azi",
      "aş",
      "aşadar",
      "aţi",
      "b",
      "ba",
      "bine",
      "bucur",
      "bună",
      "c",
      "ca",
      "cam",
      "cand",
      "capat",
      "care",
      "careia",
      "carora",
      "caruia",
      "cat",
      "catre",
      "caut",
      "ce",
      "cea",
      "ceea",
      "cei",
      "ceilalti",
      "cel",
      "cele",
      "celor",
      "ceva",
      "chiar",
      "ci",
      "cinci",
      "cind",
      "cine",
      "cineva",
      "cit",
      "cita",
      "cite",
      "citeva",
      "citi",
      "citiva",
      "conform",
      "contra",
      "cu",
      "cui",
      "cum",
      "cumva",
      "curând",
      "curînd",
      "când",
      "cât",
      "câte",
      "câtva",
      "câţi",
      "cînd",
      "cît",
      "cîte",
      "cîtva",
      "cîţi",
      "că",
      "căci",
      "cărei",
      "căror",
      "cărui",
      "către",
      "d",
      "da",
      "daca",
      "dacă",
      "dar",
      "dat",
      "datorită",
      "dată",
      "dau",
      "de",
      "deasupra",
      "deci",
      "decit",
      "degraba",
      "deja",
      "deoarece",
      "departe",
      "desi",
      "despre",
      "deşi",
      "din",
      "dinaintea",
      "dintr",
      "dintr-",
      "dintre",
      "doar",
      "doi",
      "doilea",
      "două",
      "drept",
      "dupa",
      "după",
      "dă",
      "e",
      "ea",
      "ei",
      "el",
      "ele",
      "era",
      "eram",
      "este",
      "eu",
      "exact",
      "eşti",
      "f",
      "face",
      "fara",
      "fata",
      "fel",
      "fi",
      "fie",
      "fiecare",
      "fii",
      "fim",
      "fiu",
      "fiţi",
      "foarte",
      "fost",
      "frumos",
      "fără",
      "g",
      "geaba",
      "graţie",
      "h",
      "halbă",
      "i",
      "ia",
      "iar",
      "ieri",
      "ii",
      "il",
      "imi",
      "in",
      "inainte",
      "inapoi",
      "inca",
      "incit",
      "insa",
      "intr",
      "intre",
      "isi",
      "iti",
      "j",
      "k",
      "l",
      "la",
      "le",
      "li",
      "lor",
      "lui",
      "lângă",
      "lîngă",
      "m",
      "ma",
      "mai",
      "mare",
      "mea",
      "mei",
      "mele",
      "mereu",
      "meu",
      "mi",
      "mie",
      "mine",
      "mod",
      "mult",
      "multa",
      "multe",
      "multi",
      "multă",
      "mulţi",
      "mulţumesc",
      "mâine",
      "mîine",
      "mă",
      "n",
      "ne",
      "nevoie",
      "ni",
      "nici",
      "niciodata",
      "nicăieri",
      "nimeni",
      "nimeri",
      "nimic",
      "niste",
      "nişte",
      "noastre",
      "noastră",
      "noi",
      "noroc",
      "nostri",
      "nostru",
      "nou",
      "noua",
      "nouă",
      "noştri",
      "nu",
      "numai",
      "o",
      "opt",
      "or",
      "ori",
      "oricare",
      "orice",
      "oricine",
      "oricum",
      "oricând",
      "oricât",
      "oricînd",
      "oricît",
      "oriunde",
      "p",
      "pai",
      "parca",
      "patra",
      "patru",
      "patrulea",
      "pe",
      "pentru",
      "peste",
      "pic",
      "pina",
      "plus",
      "poate",
      "pot",
      "prea",
      "prima",
      "primul",
      "prin",
      "printr-",
      "putini",
      "puţin",
      "puţina",
      "puţină",
      "până",
      "pînă",
      "r",
      "rog",
      "s",
      "sa",
      "sa-mi",
      "sa-ti",
      "sai",
      "sale",
      "sau",
      "se",
      "si",
      "sint",
      "sintem",
      "spate",
      "spre",
      "sub",
      "sunt",
      "suntem",
      "sunteţi",
      "sus",
      "sută",
      "sînt",
      "sîntem",
      "sînteţi",
      "să",
      "săi",
      "său",
      "t",
      "ta",
      "tale",
      "te",
      "ti",
      "timp",
      "tine",
      "toata",
      "toate",
      "toată",
      "tocmai",
      "tot",
      "toti",
      "totul",
      "totusi",
      "totuşi",
      "toţi",
      "trei",
      "treia",
      "treilea",
      "tu",
      "tuturor",
      "tăi",
      "tău",
      "u",
      "ul",
      "ului",
      "un",
      "una",
      "unde",
      "undeva",
      "unei",
      "uneia",
      "unele",
      "uneori",
      "unii",
      "unor",
      "unora",
      "unu",
      "unui",
      "unuia",
      "unul",
      "v",
      "va",
      "vi",
      "voastre",
      "voastră",
      "voi",
      "vom",
      "vor",
      "vostru",
      "vouă",
      "voştri",
      "vreme",
      "vreo",
      "vreun",
      "vă",
      "x",
      "z",
      "zece",
      "zero",
      "zi",
      "zice",
      "îi",
      "îl",
      "îmi",
      "împotriva",
      "în",
      "înainte",
      "înaintea",
      "încotro",
      "încât",
      "încît",
      "între",
      "întrucât",
      "întrucît",
      "îţi",
      "ăla",
      "ălea",
      "ăsta",
      "ăstea",
      "ăştia",
      "şapte",
      "şase",
      "şi",
      "ştiu",
      "ţi",
      "ţie"
    };
  }
}

class Russian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "c",
      "а",
      "алло",
      "без",
      "белый",
      "близко",
      "более",
      "больше",
      "большой",
      "будем",
      "будет",
      "будете",
      "будешь",
      "будто",
      "буду",
      "будут",
      "будь",
      "бы",
      "бывает",
      "бывь",
      "был",
      "была",
      "были",
      "было",
      "быть",
      "в",
      "важная",
      "важное",
      "важные",
      "важный",
      "вам",
      "вами",
      "вас",
      "ваш",
      "ваша",
      "ваше",
      "ваши",
      "вверх",
      "вдали",
      "вдруг",
      "ведь",
      "везде",
      "вернуться",
      "весь",
      "вечер",
      "взгляд",
      "взять",
      "вид",
      "видел",
      "видеть",
      "вместе",
      "вне",
      "вниз",
      "внизу",
      "во",
      "вода",
      "война",
      "вокруг",
      "вон",
      "вообще",
      "вопрос",
      "восемнадцатый",
      "восемнадцать",
      "восемь",
      "восьмой",
      "вот",
      "впрочем",
      "времени",
      "время",
      "все",
      "все еще",
      "всегда",
      "всего",
      "всем",
      "всеми",
      "всему",
      "всех",
      "всею",
      "всю",
      "всюду",
      "вся",
      "всё",
      "второй",
      "вы",
      "выйти",
      "г",
      "где",
      "главный",
      "глаз",
      "говорил",
      "говорит",
      "говорить",
      "год",
      "года",
      "году",
      "голова",
      "голос",
      "город",
      "да",
      "давать",
      "давно",
      "даже",
      "далекий",
      "далеко",
      "дальше",
      "даром",
      "дать",
      "два",
      "двадцатый",
      "двадцать",
      "две",
      "двенадцатый",
      "двенадцать",
      "дверь",
      "двух",
      "девятнадцатый",
      "девятнадцать",
      "девятый",
      "девять",
      "действительно",
      "дел",
      "делал",
      "делать",
      "делаю",
      "дело",
      "день",
      "деньги",
      "десятый",
      "десять",
      "для",
      "до",
      "довольно",
      "долго",
      "должен",
      "должно",
      "должный",
      "дом",
      "дорога",
      "друг",
      "другая",
      "другие",
      "других",
      "друго",
      "другое",
      "другой",
      "думать",
      "душа",
      "е",
      "его",
      "ее",
      "ей",
      "ему",
      "если",
      "есть",
      "еще",
      "ещё",
      "ею",
      "её",
      "ж",
      "ждать",
      "же",
      "жена",
      "женщина",
      "жизнь",
      "жить",
      "за",
      "занят",
      "занята",
      "занято",
      "заняты",
      "затем",
      "зато",
      "зачем",
      "здесь",
      "земля",
      "знать",
      "значит",
      "значить",
      "и",
      "иди",
      "идти",
      "из",
      "или",
      "им",
      "имеет",
      "имел",
      "именно",
      "иметь",
      "ими",
      "имя",
      "иногда",
      "их",
      "к",
      "каждая",
      "каждое",
      "каждые",
      "каждый",
      "кажется",
      "казаться",
      "как",
      "какая",
      "какой",
      "кем",
      "книга",
      "когда",
      "кого",
      "ком",
      "комната",
      "кому",
      "конец",
      "конечно",
      "которая",
      "которого",
      "которой",
      "которые",
      "который",
      "которых",
      "кроме",
      "кругом",
      "кто",
      "куда",
      "лежать",
      "лет",
      "ли",
      "лицо",
      "лишь",
      "лучше",
      "любить",
      "люди",
      "м",
      "маленький",
      "мало",
      "мать",
      "машина",
      "между",
      "меля",
      "менее",
      "меньше",
      "меня",
      "место",
      "миллионов",
      "мимо",
      "минута",
      "мир",
      "мира",
      "мне",
      "много",
      "многочисленная",
      "многочисленное",
      "многочисленные",
      "многочисленный",
      "мной",
      "мною",
      "мог",
      "могу",
      "могут",
      "мож",
      "может",
      "может быть",
      "можно",
      "можхо",
      "мои",
      "мой",
      "мор",
      "москва",
      "мочь",
      "моя",
      "моё",
      "мы",
      "на",
      "наверху",
      "над",
      "надо",
      "назад",
      "наиболее",
      "найти",
      "наконец",
      "нам",
      "нами",
      "народ",
      "нас",
      "начала",
      "начать",
      "наш",
      "наша",
      "наше",
      "наши",
      "не",
      "него",
      "недавно",
      "недалеко",
      "нее",
      "ней",
      "некоторый",
      "нельзя",
      "нем",
      "немного",
      "нему",
      "непрерывно",
      "нередко",
      "несколько",
      "нет",
      "нею",
      "неё",
      "ни",
      "нибудь",
      "ниже",
      "низко",
      "никакой",
      "никогда",
      "никто",
      "никуда",
      "ним",
      "ними",
      "них",
      "ничего",
      "ничто",
      "но",
      "новый",
      "нога",
      "ночь",
      "ну",
      "нужно",
      "нужный",
      "нх",
      "о",
      "об",
      "оба",
      "обычно",
      "один",
      "одиннадцатый",
      "одиннадцать",
      "однажды",
      "однако",
      "одного",
      "одной",
      "оказаться",
      "окно",
      "около",
      "он",
      "она",
      "они",
      "оно",
      "опять",
      "особенно",
      "остаться",
      "от",
      "ответить",
      "отец",
      "откуда",
      "отовсюду",
      "отсюда",
      "очень",
      "первый",
      "перед",
      "писать",
      "плечо",
      "по",
      "под",
      "подойди",
      "подумать",
      "пожалуйста",
      "позже",
      "пойти",
      "пока",
      "пол",
      "получить",
      "помнить",
      "понимать",
      "понять",
      "пор",
      "пора",
      "после",
      "последний",
      "посмотреть",
      "посреди",
      "потом",
      "потому",
      "почему",
      "почти",
      "правда",
      "прекрасно",
      "при",
      "про",
      "просто",
      "против",
      "процентов",
      "путь",
      "пятнадцатый",
      "пятнадцать",
      "пятый",
      "пять",
      "работа",
      "работать",
      "раз",
      "разве",
      "рано",
      "раньше",
      "ребенок",
      "решить",
      "россия",
      "рука",
      "русский",
      "ряд",
      "рядом",
      "с",
      "с кем",
      "сам",
      "сама",
      "сами",
      "самим",
      "самими",
      "самих",
      "само",
      "самого",
      "самой",
      "самом",
      "самому",
      "саму",
      "самый",
      "свет",
      "свое",
      "своего",
      "своей",
      "свои",
      "своих",
      "свой",
      "свою",
      "сделать",
      "сеаой",
      "себе",
      "себя",
      "сегодня",
      "седьмой",
      "сейчас",
      "семнадцатый",
      "семнадцать",
      "семь",
      "сидеть",
      "сила",
      "сих",
      "сказал",
      "сказала",
      "сказать",
      "сколько",
      "слишком",
      "слово",
      "случай",
      "смотреть",
      "сначала",
      "снова",
      "со",
      "собой",
      "собою",
      "советский",
      "совсем",
      "спасибо",
      "спросить",
      "сразу",
      "стал",
      "старый",
      "стать",
      "стол",
      "сторона",
      "стоять",
      "страна",
      "суть",
      "считать",
      "т",
      "та",
      "так",
      "такая",
      "также",
      "таки",
      "такие",
      "такое",
      "такой",
      "там",
      "твои",
      "твой",
      "твоя",
      "твоё",
      "те",
      "тебе",
      "тебя",
      "тем",
      "теми",
      "теперь",
      "тех",
      "то",
      "тобой",
      "тобою",
      "товарищ",
      "тогда",
      "того",
      "тоже",
      "только",
      "том",
      "тому",
      "тот",
      "тою",
      "третий",
      "три",
      "тринадцатый",
      "тринадцать",
      "ту",
      "туда",
      "тут",
      "ты",
      "тысяч",
      "у",
      "увидеть",
      "уж",
      "уже",
      "улица",
      "уметь",
      "утро",
      "хороший",
      "хорошо",
      "хотел бы",
      "хотеть",
      "хоть",
      "хотя",
      "хочешь",
      "час",
      "часто",
      "часть",
      "чаще",
      "чего",
      "человек",
      "чем",
      "чему",
      "через",
      "четвертый",
      "четыре",
      "четырнадцатый",
      "четырнадцать",
      "что",
      "чтоб",
      "чтобы",
      "чуть",
      "шестнадцатый",
      "шестнадцать",
      "шестой",
      "шесть",
      "эта",
      "эти",
      "этим",
      "этими",
      "этих",
      "это",
      "этого",
      "этой",
      "этом",
      "этому",
      "этот",
      "эту",
      "я",
      "являюсь"
    };
  }
}

class Sesotho implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "ba",
      "bane",
      "bona",
      "e",
      "ea",
      "eaba",
      "empa",
      "ena",
      "ha",
      "hae",
      "hape",
      "ho",
      "hore",
      "ka",
      "ke",
      "la",
      "le",
      "li",
      "me",
      "mo",
      "moo",
      "ne",
      "o",
      "oa",
      "re",
      "sa",
      "se",
      "tloha",
      "tsa",
      "tse"
    };
  }
}

class Slovak implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "aby",
      "aj",
      "ak",
      "ako",
      "aký",
      "ale",
      "alebo",
      "and",
      "ani",
      "asi",
      "avšak",
      "až",
      "ba",
      "bez",
      "bol",
      "bola",
      "boli",
      "bolo",
      "bude",
      "budem",
      "budeme",
      "budete",
      "budeš",
      "budú",
      "buï",
      "buď",
      "by",
      "byť",
      "cez",
      "dnes",
      "do",
      "ešte",
      "for",
      "ho",
      "hoci",
      "i",
      "iba",
      "ich",
      "im",
      "iné",
      "iný",
      "ja",
      "je",
      "jeho",
      "jej",
      "jemu",
      "ju",
      "k",
      "kam",
      "každá",
      "každé",
      "každí",
      "každý",
      "kde",
      "kedže",
      "keï",
      "keď",
      "kto",
      "ktorou",
      "ktorá",
      "ktoré",
      "ktorí",
      "ktorý",
      "ku",
      "lebo",
      "len",
      "ma",
      "mať",
      "medzi",
      "menej",
      "mi",
      "mna",
      "mne",
      "mnou",
      "moja",
      "moje",
      "mu",
      "musieť",
      "my",
      "má",
      "máte",
      "mòa",
      "môcť",
      "môj",
      "môže",
      "na",
      "nad",
      "nami",
      "naši",
      "nech",
      "neho",
      "nej",
      "nemu",
      "než",
      "nich",
      "nie",
      "niektorý",
      "nielen",
      "nim",
      "nič",
      "no",
      "nová",
      "nové",
      "noví",
      "nový",
      "nám",
      "nás",
      "náš",
      "ním",
      "o",
      "od",
      "odo",
      "of",
      "on",
      "ona",
      "oni",
      "ono",
      "ony",
      "po",
      "pod",
      "podľa",
      "pokiaľ",
      "potom",
      "pre",
      "pred",
      "predo",
      "preto",
      "pretože",
      "prečo",
      "pri",
      "prvá",
      "prvé",
      "prví",
      "prvý",
      "práve",
      "pýta",
      "s",
      "sa",
      "seba",
      "sem",
      "si",
      "sme",
      "so",
      "som",
      "späť",
      "ste",
      "svoj",
      "svoje",
      "svojich",
      "svojím",
      "svojími",
      "sú",
      "ta",
      "tak",
      "taký",
      "takže",
      "tam",
      "te",
      "teba",
      "tebe",
      "tebou",
      "teda",
      "tej",
      "ten",
      "tento",
      "the",
      "ti",
      "tie",
      "tieto",
      "tiež",
      "to",
      "toho",
      "tohoto",
      "tom",
      "tomto",
      "tomu",
      "tomuto",
      "toto",
      "tou",
      "tu",
      "tvoj",
      "tvojími",
      "ty",
      "tá",
      "táto",
      "tú",
      "túto",
      "tým",
      "týmto",
      "tě",
      "už",
      "v",
      "vami",
      "vaše",
      "veï",
      "viac",
      "vo",
      "vy",
      "vám",
      "vás",
      "váš",
      "však",
      "všetok",
      "z",
      "za",
      "zo",
      "a",
      "áno",
      "èi",
      "èo",
      "èí",
      "òom",
      "òou",
      "òu",
      "či",
      "čo",
      "ďalšia",
      "ďalšie",
      "ďalší",
      "že"
    };
  }
}

class Slovenian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "ali",
      "april",
      "avgust",
      "b",
      "bi",
      "bil",
      "bila",
      "bile",
      "bili",
      "bilo",
      "biti",
      "blizu",
      "bo",
      "bodo",
      "bojo",
      "bolj",
      "bom",
      "bomo",
      "boste",
      "bova",
      "boš",
      "brez",
      "c",
      "cel",
      "cela",
      "celi",
      "celo",
      "d",
      "da",
      "daleč",
      "dan",
      "danes",
      "datum",
      "december",
      "deset",
      "deseta",
      "deseti",
      "deseto",
      "devet",
      "deveta",
      "deveti",
      "deveto",
      "do",
      "dober",
      "dobra",
      "dobri",
      "dobro",
      "dokler",
      "dol",
      "dolg",
      "dolga",
      "dolgi",
      "dovolj",
      "drug",
      "druga",
      "drugi",
      "drugo",
      "dva",
      "dve",
      "e",
      "eden",
      "en",
      "ena",
      "ene",
      "eni",
      "enkrat",
      "eno",
      "etc.",
      "f",
      "februar",
      "g",
      "g.",
      "ga",
      "ga.",
      "gor",
      "gospa",
      "gospod",
      "h",
      "halo",
      "i",
      "idr.",
      "ii",
      "iii",
      "in",
      "iv",
      "ix",
      "iz",
      "j",
      "januar",
      "jaz",
      "je",
      "ji",
      "jih",
      "jim",
      "jo",
      "julij",
      "junij",
      "jutri",
      "k",
      "kadarkoli",
      "kaj",
      "kajti",
      "kako",
      "kakor",
      "kamor",
      "kamorkoli",
      "kar",
      "karkoli",
      "katerikoli",
      "kdaj",
      "kdo",
      "kdorkoli",
      "ker",
      "ki",
      "kje",
      "kjer",
      "kjerkoli",
      "ko",
      "koder",
      "koderkoli",
      "koga",
      "komu",
      "kot",
      "kratek",
      "kratka",
      "kratke",
      "kratki",
      "l",
      "lahka",
      "lahke",
      "lahki",
      "lahko",
      "le",
      "lep",
      "lepa",
      "lepe",
      "lepi",
      "lepo",
      "leto",
      "m",
      "maj",
      "majhen",
      "majhna",
      "majhni",
      "malce",
      "malo",
      "manj",
      "marec",
      "me",
      "med",
      "medtem",
      "mene",
      "mesec",
      "mi",
      "midva",
      "midve",
      "mnogo",
      "moj",
      "moja",
      "moje",
      "mora",
      "morajo",
      "moram",
      "moramo",
      "morate",
      "moraš",
      "morem",
      "mu",
      "n",
      "na",
      "nad",
      "naj",
      "najina",
      "najino",
      "najmanj",
      "naju",
      "največ",
      "nam",
      "narobe",
      "nas",
      "nato",
      "nazaj",
      "naš",
      "naša",
      "naše",
      "ne",
      "nedavno",
      "nedelja",
      "nek",
      "neka",
      "nekaj",
      "nekatere",
      "nekateri",
      "nekatero",
      "nekdo",
      "neke",
      "nekega",
      "neki",
      "nekje",
      "neko",
      "nekoga",
      "nekoč",
      "ni",
      "nikamor",
      "nikdar",
      "nikjer",
      "nikoli",
      "nič",
      "nje",
      "njega",
      "njegov",
      "njegova",
      "njegovo",
      "njej",
      "njemu",
      "njen",
      "njena",
      "njeno",
      "nji",
      "njih",
      "njihov",
      "njihova",
      "njihovo",
      "njiju",
      "njim",
      "njo",
      "njun",
      "njuna",
      "njuno",
      "no",
      "nocoj",
      "november",
      "npr.",
      "o",
      "ob",
      "oba",
      "obe",
      "oboje",
      "od",
      "odprt",
      "odprta",
      "odprti",
      "okoli",
      "oktober",
      "on",
      "onadva",
      "one",
      "oni",
      "onidve",
      "osem",
      "osma",
      "osmi",
      "osmo",
      "oz.",
      "p",
      "pa",
      "pet",
      "peta",
      "petek",
      "peti",
      "peto",
      "po",
      "pod",
      "pogosto",
      "poleg",
      "poln",
      "polna",
      "polni",
      "polno",
      "ponavadi",
      "ponedeljek",
      "ponovno",
      "potem",
      "povsod",
      "pozdravljen",
      "pozdravljeni",
      "prav",
      "prava",
      "prave",
      "pravi",
      "pravo",
      "prazen",
      "prazna",
      "prazno",
      "prbl.",
      "precej",
      "pred",
      "prej",
      "preko",
      "pri",
      "pribl.",
      "približno",
      "primer",
      "pripravljen",
      "pripravljena",
      "pripravljeni",
      "proti",
      "prva",
      "prvi",
      "prvo",
      "r",
      "ravno",
      "redko",
      "res",
      "reč",
      "s",
      "saj",
      "sam",
      "sama",
      "same",
      "sami",
      "samo",
      "se",
      "sebe",
      "sebi",
      "sedaj",
      "sedem",
      "sedma",
      "sedmi",
      "sedmo",
      "sem",
      "september",
      "seveda",
      "si",
      "sicer",
      "skoraj",
      "skozi",
      "slab",
      "smo",
      "so",
      "sobota",
      "spet",
      "sreda",
      "srednja",
      "srednji",
      "sta",
      "ste",
      "stran",
      "stvar",
      "sva",
      "t",
      "ta",
      "tak",
      "taka",
      "take",
      "taki",
      "tako",
      "takoj",
      "tam",
      "te",
      "tebe",
      "tebi",
      "tega",
      "težak",
      "težka",
      "težki",
      "težko",
      "ti",
      "tista",
      "tiste",
      "tisti",
      "tisto",
      "tj.",
      "tja",
      "to",
      "toda",
      "torek",
      "tretja",
      "tretje",
      "tretji",
      "tri",
      "tu",
      "tudi",
      "tukaj",
      "tvoj",
      "tvoja",
      "tvoje",
      "u",
      "v",
      "vaju",
      "vam",
      "vas",
      "vaš",
      "vaša",
      "vaše",
      "ve",
      "vedno",
      "velik",
      "velika",
      "veliki",
      "veliko",
      "vendar",
      "ves",
      "več",
      "vi",
      "vidva",
      "vii",
      "viii",
      "visok",
      "visoka",
      "visoke",
      "visoki",
      "vsa",
      "vsaj",
      "vsak",
      "vsaka",
      "vsakdo",
      "vsake",
      "vsaki",
      "vsakomur",
      "vse",
      "vsega",
      "vsi",
      "vso",
      "včasih",
      "včeraj",
      "x",
      "z",
      "za",
      "zadaj",
      "zadnji",
      "zakaj",
      "zaprta",
      "zaprti",
      "zaprto",
      "zdaj",
      "zelo",
      "zunaj",
      "č",
      "če",
      "često",
      "četrta",
      "četrtek",
      "četrti",
      "četrto",
      "čez",
      "čigav",
      "š",
      "šest",
      "šesta",
      "šesti",
      "šesto",
      "štiri",
      "ž",
      "že"
    };
  }
}

class Somali implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "aad",
      "albaabkii",
      "atabo",
      "ay",
      "ayaa",
      "ayee",
      "ayuu",
      "dhan",
      "hadana",
      "in",
      "inuu",
      "isku",
      "jiray",
      "jirtay",
      "ka",
      "kale",
      "kasoo",
      "ku",
      "kuu",
      "lakin",
      "markii",
      "oo",
      "si",
      "soo",
      "uga",
      "ugu",
      "uu",
      "waa",
      "waxa",
      "waxuu"
    };
  }
}

class Spanish implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "0",
      "1",
      "2",
      "3",
      "4",
      "5",
      "6",
      "7",
      "8",
      "9",
      "_",
      "a",
      "actualmente",
      "acuerdo",
      "adelante",
      "ademas",
      "además",
      "adrede",
      "afirmó",
      "agregó",
      "ahi",
      "ahora",
      "ahí",
      "al",
      "algo",
      "alguna",
      "algunas",
      "alguno",
      "algunos",
      "algún",
      "alli",
      "allí",
      "alrededor",
      "ambos",
      "ampleamos",
      "antano",
      "antaño",
      "ante",
      "anterior",
      "antes",
      "apenas",
      "aproximadamente",
      "aquel",
      "aquella",
      "aquellas",
      "aquello",
      "aquellos",
      "aqui",
      "aquél",
      "aquélla",
      "aquéllas",
      "aquéllos",
      "aquí",
      "arriba",
      "arribaabajo",
      "aseguró",
      "asi",
      "así",
      "atras",
      "aun",
      "aunque",
      "ayer",
      "añadió",
      "aún",
      "b",
      "bajo",
      "bastante",
      "bien",
      "breve",
      "buen",
      "buena",
      "buenas",
      "bueno",
      "buenos",
      "c",
      "cada",
      "casi",
      "cerca",
      "cierta",
      "ciertas",
      "cierto",
      "ciertos",
      "cinco",
      "claro",
      "comentó",
      "como",
      "con",
      "conmigo",
      "conocer",
      "conseguimos",
      "conseguir",
      "considera",
      "consideró",
      "consigo",
      "consigue",
      "consiguen",
      "consigues",
      "contigo",
      "contra",
      "cosas",
      "creo",
      "cual",
      "cuales",
      "cualquier",
      "cuando",
      "cuanta",
      "cuantas",
      "cuanto",
      "cuantos",
      "cuatro",
      "cuenta",
      "cuál",
      "cuáles",
      "cuándo",
      "cuánta",
      "cuántas",
      "cuánto",
      "cuántos",
      "cómo",
      "d",
      "da",
      "dado",
      "dan",
      "dar",
      "de",
      "debajo",
      "debe",
      "deben",
      "debido",
      "decir",
      "dejó",
      "del",
      "delante",
      "demasiado",
      "demás",
      "dentro",
      "deprisa",
      "desde",
      "despacio",
      "despues",
      "después",
      "detras",
      "detrás",
      "dia",
      "dias",
      "dice",
      "dicen",
      "dicho",
      "dieron",
      "diferente",
      "diferentes",
      "dijeron",
      "dijo",
      "dio",
      "donde",
      "dos",
      "durante",
      "día",
      "días",
      "dónde",
      "e",
      "ejemplo",
      "el",
      "ella",
      "ellas",
      "ello",
      "ellos",
      "embargo",
      "empleais",
      "emplean",
      "emplear",
      "empleas",
      "empleo",
      "en",
      "encima",
      "encuentra",
      "enfrente",
      "enseguida",
      "entonces",
      "entre",
      "era",
      "erais",
      "eramos",
      "eran",
      "eras",
      "eres",
      "es",
      "esa",
      "esas",
      "ese",
      "eso",
      "esos",
      "esta",
      "estaba",
      "estabais",
      "estaban",
      "estabas",
      "estad",
      "estada",
      "estadas",
      "estado",
      "estados",
      "estais",
      "estamos",
      "estan",
      "estando",
      "estar",
      "estaremos",
      "estará",
      "estarán",
      "estarás",
      "estaré",
      "estaréis",
      "estaría",
      "estaríais",
      "estaríamos",
      "estarían",
      "estarías",
      "estas",
      "este",
      "estemos",
      "esto",
      "estos",
      "estoy",
      "estuve",
      "estuviera",
      "estuvierais",
      "estuvieran",
      "estuvieras",
      "estuvieron",
      "estuviese",
      "estuvieseis",
      "estuviesen",
      "estuvieses",
      "estuvimos",
      "estuviste",
      "estuvisteis",
      "estuviéramos",
      "estuviésemos",
      "estuvo",
      "está",
      "estábamos",
      "estáis",
      "están",
      "estás",
      "esté",
      "estéis",
      "estén",
      "estés",
      "ex",
      "excepto",
      "existe",
      "existen",
      "explicó",
      "expresó",
      "f",
      "fin",
      "final",
      "fue",
      "fuera",
      "fuerais",
      "fueran",
      "fueras",
      "fueron",
      "fuese",
      "fueseis",
      "fuesen",
      "fueses",
      "fui",
      "fuimos",
      "fuiste",
      "fuisteis",
      "fuéramos",
      "fuésemos",
      "g",
      "general",
      "gran",
      "grandes",
      "gueno",
      "h",
      "ha",
      "haber",
      "habia",
      "habida",
      "habidas",
      "habido",
      "habidos",
      "habiendo",
      "habla",
      "hablan",
      "habremos",
      "habrá",
      "habrán",
      "habrás",
      "habré",
      "habréis",
      "habría",
      "habríais",
      "habríamos",
      "habrían",
      "habrías",
      "habéis",
      "había",
      "habíais",
      "habíamos",
      "habían",
      "habías",
      "hace",
      "haceis",
      "hacemos",
      "hacen",
      "hacer",
      "hacerlo",
      "haces",
      "hacia",
      "haciendo",
      "hago",
      "han",
      "has",
      "hasta",
      "hay",
      "haya",
      "hayamos",
      "hayan",
      "hayas",
      "hayáis",
      "he",
      "hecho",
      "hemos",
      "hicieron",
      "hizo",
      "horas",
      "hoy",
      "hube",
      "hubiera",
      "hubierais",
      "hubieran",
      "hubieras",
      "hubieron",
      "hubiese",
      "hubieseis",
      "hubiesen",
      "hubieses",
      "hubimos",
      "hubiste",
      "hubisteis",
      "hubiéramos",
      "hubiésemos",
      "hubo",
      "i",
      "igual",
      "incluso",
      "indicó",
      "informo",
      "informó",
      "intenta",
      "intentais",
      "intentamos",
      "intentan",
      "intentar",
      "intentas",
      "intento",
      "ir",
      "j",
      "junto",
      "k",
      "l",
      "la",
      "lado",
      "largo",
      "las",
      "le",
      "lejos",
      "les",
      "llegó",
      "lleva",
      "llevar",
      "lo",
      "los",
      "luego",
      "lugar",
      "m",
      "mal",
      "manera",
      "manifestó",
      "mas",
      "mayor",
      "me",
      "mediante",
      "medio",
      "mejor",
      "mencionó",
      "menos",
      "menudo",
      "mi",
      "mia",
      "mias",
      "mientras",
      "mio",
      "mios",
      "mis",
      "misma",
      "mismas",
      "mismo",
      "mismos",
      "modo",
      "momento",
      "mucha",
      "muchas",
      "mucho",
      "muchos",
      "muy",
      "más",
      "mí",
      "mía",
      "mías",
      "mío",
      "míos",
      "n",
      "nada",
      "nadie",
      "ni",
      "ninguna",
      "ningunas",
      "ninguno",
      "ningunos",
      "ningún",
      "no",
      "nos",
      "nosotras",
      "nosotros",
      "nuestra",
      "nuestras",
      "nuestro",
      "nuestros",
      "nueva",
      "nuevas",
      "nuevo",
      "nuevos",
      "nunca",
      "o",
      "ocho",
      "os",
      "otra",
      "otras",
      "otro",
      "otros",
      "p",
      "pais",
      "para",
      "parece",
      "parte",
      "partir",
      "pasada",
      "pasado",
      "paìs",
      "peor",
      "pero",
      "pesar",
      "poca",
      "pocas",
      "poco",
      "pocos",
      "podeis",
      "podemos",
      "poder",
      "podria",
      "podriais",
      "podriamos",
      "podrian",
      "podrias",
      "podrá",
      "podrán",
      "podría",
      "podrían",
      "poner",
      "por",
      "por qué",
      "porque",
      "posible",
      "primer",
      "primera",
      "primero",
      "primeros",
      "principalmente",
      "pronto",
      "propia",
      "propias",
      "propio",
      "propios",
      "proximo",
      "próximo",
      "próximos",
      "pudo",
      "pueda",
      "puede",
      "pueden",
      "puedo",
      "pues",
      "q",
      "qeu",
      "que",
      "quedó",
      "queremos",
      "quien",
      "quienes",
      "quiere",
      "quiza",
      "quizas",
      "quizá",
      "quizás",
      "quién",
      "quiénes",
      "qué",
      "r",
      "raras",
      "realizado",
      "realizar",
      "realizó",
      "repente",
      "respecto",
      "s",
      "sabe",
      "sabeis",
      "sabemos",
      "saben",
      "saber",
      "sabes",
      "sal",
      "salvo",
      "se",
      "sea",
      "seamos",
      "sean",
      "seas",
      "segun",
      "segunda",
      "segundo",
      "según",
      "seis",
      "ser",
      "sera",
      "seremos",
      "será",
      "serán",
      "serás",
      "seré",
      "seréis",
      "sería",
      "seríais",
      "seríamos",
      "serían",
      "serías",
      "seáis",
      "señaló",
      "si",
      "sido",
      "siempre",
      "siendo",
      "siete",
      "sigue",
      "siguiente",
      "sin",
      "sino",
      "sobre",
      "sois",
      "sola",
      "solamente",
      "solas",
      "solo",
      "solos",
      "somos",
      "son",
      "soy",
      "soyos",
      "su",
      "supuesto",
      "sus",
      "suya",
      "suyas",
      "suyo",
      "suyos",
      "sé",
      "sí",
      "sólo",
      "t",
      "tal",
      "tambien",
      "también",
      "tampoco",
      "tan",
      "tanto",
      "tarde",
      "te",
      "temprano",
      "tendremos",
      "tendrá",
      "tendrán",
      "tendrás",
      "tendré",
      "tendréis",
      "tendría",
      "tendríais",
      "tendríamos",
      "tendrían",
      "tendrías",
      "tened",
      "teneis",
      "tenemos",
      "tener",
      "tenga",
      "tengamos",
      "tengan",
      "tengas",
      "tengo",
      "tengáis",
      "tenida",
      "tenidas",
      "tenido",
      "tenidos",
      "teniendo",
      "tenéis",
      "tenía",
      "teníais",
      "teníamos",
      "tenían",
      "tenías",
      "tercera",
      "ti",
      "tiempo",
      "tiene",
      "tienen",
      "tienes",
      "toda",
      "todas",
      "todavia",
      "todavía",
      "todo",
      "todos",
      "total",
      "trabaja",
      "trabajais",
      "trabajamos",
      "trabajan",
      "trabajar",
      "trabajas",
      "trabajo",
      "tras",
      "trata",
      "través",
      "tres",
      "tu",
      "tus",
      "tuve",
      "tuviera",
      "tuvierais",
      "tuvieran",
      "tuvieras",
      "tuvieron",
      "tuviese",
      "tuvieseis",
      "tuviesen",
      "tuvieses",
      "tuvimos",
      "tuviste",
      "tuvisteis",
      "tuviéramos",
      "tuviésemos",
      "tuvo",
      "tuya",
      "tuyas",
      "tuyo",
      "tuyos",
      "tú",
      "u",
      "ultimo",
      "un",
      "una",
      "unas",
      "uno",
      "unos",
      "usa",
      "usais",
      "usamos",
      "usan",
      "usar",
      "usas",
      "uso",
      "usted",
      "ustedes",
      "v",
      "va",
      "vais",
      "valor",
      "vamos",
      "van",
      "varias",
      "varios",
      "vaya",
      "veces",
      "ver",
      "verdad",
      "verdadera",
      "verdadero",
      "vez",
      "vosotras",
      "vosotros",
      "voy",
      "vuestra",
      "vuestras",
      "vuestro",
      "vuestros",
      "w",
      "x",
      "y",
      "ya",
      "yo",
      "z",
      "él",
      "éramos",
      "ésa",
      "ésas",
      "ése",
      "ésos",
      "ésta",
      "éstas",
      "éste",
      "éstos",
      "última",
      "últimas",
      "último",
      "últimos"
    };
  }
}

class Swahili implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "akasema",
      "alikuwa",
      "alisema",
      "baada",
      "basi",
      "bila",
      "cha",
      "chini",
      "hadi",
      "hapo",
      "hata",
      "hivyo",
      "hiyo",
      "huku",
      "huo",
      "ili",
      "ilikuwa",
      "juu",
      "kama",
      "karibu",
      "katika",
      "kila",
      "kima",
      "kisha",
      "kubwa",
      "kutoka",
      "kuwa",
      "kwa",
      "kwamba",
      "kwenda",
      "kwenye",
      "la",
      "lakini",
      "mara",
      "mdogo",
      "mimi",
      "mkubwa",
      "mmoja",
      "moja",
      "muda",
      "mwenye",
      "na",
      "naye",
      "ndani",
      "ng",
      "ni",
      "nini",
      "nonkungu",
      "pamoja",
      "pia",
      "sana",
      "sasa",
      "sauti",
      "tafadhali",
      "tena",
      "tu",
      "vile",
      "wa",
      "wakati",
      "wake",
      "walikuwa",
      "wao",
      "watu",
      "wengine",
      "wote",
      "ya",
      "yake",
      "yangu",
      "yao",
      "yeye",
      "yule",
      "za",
      "zaidi",
      "zake"
    };
  }
}

class Swedish implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "aderton",
      "adertonde",
      "adjö",
      "aldrig",
      "alla",
      "allas",
      "allt",
      "alltid",
      "alltså",
      "andra",
      "andras",
      "annan",
      "annat",
      "artonde",
      "artonn",
      "att",
      "av",
      "bakom",
      "bara",
      "behöva",
      "behövas",
      "behövde",
      "behövt",
      "beslut",
      "beslutat",
      "beslutit",
      "bland",
      "blev",
      "bli",
      "blir",
      "blivit",
      "bort",
      "borta",
      "bra",
      "bäst",
      "bättre",
      "båda",
      "bådas",
      "dag",
      "dagar",
      "dagarna",
      "dagen",
      "de",
      "del",
      "delen",
      "dem",
      "den",
      "denna",
      "deras",
      "dess",
      "dessa",
      "det",
      "detta",
      "dig",
      "din",
      "dina",
      "dit",
      "ditt",
      "dock",
      "dom",
      "du",
      "där",
      "därför",
      "då",
      "e",
      "efter",
      "eftersom",
      "ej",
      "elfte",
      "eller",
      "elva",
      "emot",
      "en",
      "enkel",
      "enkelt",
      "enkla",
      "enligt",
      "ens",
      "er",
      "era",
      "ers",
      "ert",
      "ett",
      "ettusen",
      "fanns",
      "fem",
      "femte",
      "femtio",
      "femtionde",
      "femton",
      "femtonde",
      "fick",
      "fin",
      "finnas",
      "finns",
      "fjorton",
      "fjortonde",
      "fjärde",
      "fler",
      "flera",
      "flesta",
      "fram",
      "framför",
      "från",
      "fyra",
      "fyrtio",
      "fyrtionde",
      "få",
      "får",
      "fått",
      "följande",
      "för",
      "före",
      "förlåt",
      "förra",
      "första",
      "genast",
      "genom",
      "gick",
      "gjorde",
      "gjort",
      "god",
      "goda",
      "godare",
      "godast",
      "gott",
      "gälla",
      "gäller",
      "gällt",
      "gärna",
      "gå",
      "går",
      "gått",
      "gör",
      "göra",
      "ha",
      "hade",
      "haft",
      "han",
      "hans",
      "har",
      "heller",
      "hellre",
      "helst",
      "helt",
      "henne",
      "hennes",
      "hit",
      "hon",
      "honom",
      "hundra",
      "hundraen",
      "hundraett",
      "hur",
      "här",
      "hög",
      "höger",
      "högre",
      "högst",
      "i",
      "ibland",
      "icke",
      "idag",
      "igen",
      "igår",
      "imorgon",
      "in",
      "inför",
      "inga",
      "ingen",
      "ingenting",
      "inget",
      "innan",
      "inne",
      "inom",
      "inte",
      "inuti",
      "ja",
      "jag",
      "jo",
      "ju",
      "just",
      "jämfört",
      "kan",
      "kanske",
      "knappast",
      "kom",
      "komma",
      "kommer",
      "kommit",
      "kr",
      "kunde",
      "kunna",
      "kunnat",
      "kvar",
      "legat",
      "ligga",
      "ligger",
      "lika",
      "likställd",
      "likställda",
      "lilla",
      "lite",
      "liten",
      "litet",
      "länge",
      "längre",
      "längst",
      "lätt",
      "lättare",
      "lättast",
      "långsam",
      "långsammare",
      "långsammast",
      "långsamt",
      "långt",
      "låt",
      "man",
      "med",
      "mej",
      "mellan",
      "men",
      "mer",
      "mera",
      "mest",
      "mig",
      "min",
      "mina",
      "mindre",
      "minst",
      "mitt",
      "mittemot",
      "mot",
      "mycket",
      "många",
      "måste",
      "möjlig",
      "möjligen",
      "möjligt",
      "möjligtvis",
      "ned",
      "nederst",
      "nedersta",
      "nedre",
      "nej",
      "ner",
      "ni",
      "nio",
      "nionde",
      "nittio",
      "nittionde",
      "nitton",
      "nittonde",
      "nog",
      "noll",
      "nr",
      "nu",
      "nummer",
      "när",
      "nästa",
      "någon",
      "någonting",
      "något",
      "några",
      "nån",
      "nånting",
      "nåt",
      "nödvändig",
      "nödvändiga",
      "nödvändigt",
      "nödvändigtvis",
      "och",
      "också",
      "ofta",
      "oftast",
      "olika",
      "olikt",
      "om",
      "oss",
      "på",
      "rakt",
      "redan",
      "rätt",
      "sa",
      "sade",
      "sagt",
      "samma",
      "sedan",
      "senare",
      "senast",
      "sent",
      "sex",
      "sextio",
      "sextionde",
      "sexton",
      "sextonde",
      "sig",
      "sin",
      "sina",
      "sist",
      "sista",
      "siste",
      "sitt",
      "sitta",
      "sju",
      "sjunde",
      "sjuttio",
      "sjuttionde",
      "sjutton",
      "sjuttonde",
      "själv",
      "sjätte",
      "ska",
      "skall",
      "skulle",
      "slutligen",
      "små",
      "smått",
      "snart",
      "som",
      "stor",
      "stora",
      "stort",
      "större",
      "störst",
      "säga",
      "säger",
      "sämre",
      "sämst",
      "så",
      "sådan",
      "sådana",
      "sådant",
      "ta",
      "tack",
      "tar",
      "tidig",
      "tidigare",
      "tidigast",
      "tidigt",
      "till",
      "tills",
      "tillsammans",
      "tio",
      "tionde",
      "tjugo",
      "tjugoen",
      "tjugoett",
      "tjugonde",
      "tjugotre",
      "tjugotvå",
      "tjungo",
      "tolfte",
      "tolv",
      "tre",
      "tredje",
      "trettio",
      "trettionde",
      "tretton",
      "trettonde",
      "två",
      "tvåhundra",
      "under",
      "upp",
      "ur",
      "ursäkt",
      "ut",
      "utan",
      "utanför",
      "ute",
      "va",
      "vad",
      "var",
      "vara",
      "varför",
      "varifrån",
      "varit",
      "varje",
      "varken",
      "vars",
      "varsågod",
      "vart",
      "vem",
      "vems",
      "verkligen",
      "vi",
      "vid",
      "vidare",
      "viktig",
      "viktigare",
      "viktigast",
      "viktigt",
      "vilka",
      "vilkas",
      "vilken",
      "vilket",
      "vill",
      "väl",
      "vänster",
      "vänstra",
      "värre",
      "vår",
      "våra",
      "vårt",
      "än",
      "ännu",
      "är",
      "även",
      "åt",
      "åtminstone",
      "åtta",
      "åttio",
      "åttionde",
      "åttonde",
      "över",
      "övermorgon",
      "överst",
      "övre"
    };
  }
}

class Tagalog implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "akin",
      "aking",
      "ako",
      "alin",
      "am",
      "amin",
      "aming",
      "ang",
      "ano",
      "anumang",
      "apat",
      "at",
      "atin",
      "ating",
      "ay",
      "bababa",
      "bago",
      "bakit",
      "bawat",
      "bilang",
      "dahil",
      "dalawa",
      "dapat",
      "din",
      "dito",
      "doon",
      "gagawin",
      "gayunman",
      "ginagawa",
      "ginawa",
      "ginawang",
      "gumawa",
      "gusto",
      "habang",
      "hanggang",
      "hindi",
      "huwag",
      "iba",
      "ibaba",
      "ibabaw",
      "ibig",
      "ikaw",
      "ilagay",
      "ilalim",
      "ilan",
      "inyong",
      "isa",
      "isang",
      "itaas",
      "ito",
      "iyo",
      "iyon",
      "iyong",
      "ka",
      "kahit",
      "kailangan",
      "kailanman",
      "kami",
      "kanila",
      "kanilang",
      "kanino",
      "kanya",
      "kanyang",
      "kapag",
      "kapwa",
      "karamihan",
      "katiyakan",
      "katulad",
      "kaya",
      "kaysa",
      "ko",
      "kong",
      "kulang",
      "kumuha",
      "kung",
      "laban",
      "lahat",
      "lamang",
      "likod",
      "lima",
      "maaari",
      "maaaring",
      "maging",
      "mahusay",
      "makita",
      "marami",
      "marapat",
      "masyado",
      "may",
      "mayroon",
      "mga",
      "minsan",
      "mismo",
      "mula",
      "muli",
      "na",
      "nabanggit",
      "naging",
      "nagkaroon",
      "nais",
      "nakita",
      "namin",
      "napaka",
      "narito",
      "nasaan",
      "ng",
      "ngayon",
      "ni",
      "nila",
      "nilang",
      "nito",
      "niya",
      "niyang",
      "noon",
      "o",
      "pa",
      "paano",
      "pababa",
      "paggawa",
      "pagitan",
      "pagkakaroon",
      "pagkatapos",
      "palabas",
      "pamamagitan",
      "panahon",
      "pangalawa",
      "para",
      "paraan",
      "pareho",
      "pataas",
      "pero",
      "pumunta",
      "pumupunta",
      "sa",
      "saan",
      "sabi",
      "sabihin",
      "sarili",
      "sila",
      "sino",
      "siya",
      "tatlo",
      "tayo",
      "tulad",
      "tungkol",
      "una",
      "walang"
    };
  }
}

class Thai implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "กล่าว",
      "กว่า",
      "กัน",
      "กับ",
      "การ",
      "ก็",
      "ก่อน",
      "ขณะ",
      "ขอ",
      "ของ",
      "ขึ้น",
      "คง",
      "ครั้ง",
      "ความ",
      "คือ",
      "จะ",
      "จัด",
      "จาก",
      "จึง",
      "ช่วง",
      "ซึ่ง",
      "ดัง",
      "ด้วย",
      "ด้าน",
      "ตั้ง",
      "ตั้งแต่",
      "ตาม",
      "ต่อ",
      "ต่าง",
      "ต่างๆ",
      "ต้อง",
      "ถึง",
      "ถูก",
      "ถ้า",
      "ทั้ง",
      "ทั้งนี้",
      "ทาง",
      "ที่",
      "ที่สุด",
      "ทุก",
      "ทํา",
      "ทําให้",
      "นอกจาก",
      "นัก",
      "นั้น",
      "นี้",
      "น่า",
      "นํา",
      "บาง",
      "ผล",
      "ผ่าน",
      "พบ",
      "พร้อม",
      "มา",
      "มาก",
      "มี",
      "ยัง",
      "รวม",
      "ระหว่าง",
      "รับ",
      "ราย",
      "ร่วม",
      "ลง",
      "วัน",
      "ว่า",
      "สุด",
      "ส่ง",
      "ส่วน",
      "สําหรับ",
      "หนึ่ง",
      "หรือ",
      "หลัง",
      "หลังจาก",
      "หลาย",
      "หาก",
      "อยาก",
      "อยู่",
      "อย่าง",
      "ออก",
      "อะไร",
      "อาจ",
      "อีก",
      "เขา",
      "เข้า",
      "เคย",
      "เฉพาะ",
      "เช่น",
      "เดียว",
      "เดียวกัน",
      "เนื่องจาก",
      "เปิด",
      "เปิดเผย",
      "เป็น",
      "เป็นการ",
      "เพราะ",
      "เพื่อ",
      "เมื่อ",
      "เรา",
      "เริ่ม",
      "เลย",
      "เห็น",
      "เอง",
      "แต่",
      "แบบ",
      "แรก",
      "และ",
      "แล้ว",
      "แห่ง",
      "โดย",
      "ใน",
      "ให้",
      "ได้",
      "ไป",
      "ไม่",
      "ไว้",
      "้ง"
    };
  }
}

class Turkish implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "acaba",
      "acep",
      "adamakıllı",
      "adeta",
      "ait",
      "altmýþ",
      "altmış",
      "altý",
      "altı",
      "ama",
      "amma",
      "anca",
      "ancak",
      "arada",
      "artýk",
      "aslında",
      "aynen",
      "ayrıca",
      "az",
      "açıkça",
      "açıkçası",
      "bana",
      "bari",
      "bazen",
      "bazý",
      "bazı",
      "başkası",
      "baţka",
      "belki",
      "ben",
      "benden",
      "beni",
      "benim",
      "beri",
      "beriki",
      "beþ",
      "beş",
      "beţ",
      "bilcümle",
      "bile",
      "bin",
      "binaen",
      "binaenaleyh",
      "bir",
      "biraz",
      "birazdan",
      "birbiri",
      "birden",
      "birdenbire",
      "biri",
      "birice",
      "birileri",
      "birisi",
      "birkaç",
      "birkaçı",
      "birkez",
      "birlikte",
      "birçok",
      "birçoğu",
      "birþey",
      "birþeyi",
      "birşey",
      "birşeyi",
      "birţey",
      "bitevi",
      "biteviye",
      "bittabi",
      "biz",
      "bizatihi",
      "bizce",
      "bizcileyin",
      "bizden",
      "bize",
      "bizi",
      "bizim",
      "bizimki",
      "bizzat",
      "boşuna",
      "bu",
      "buna",
      "bunda",
      "bundan",
      "bunlar",
      "bunları",
      "bunların",
      "bunu",
      "bunun",
      "buracıkta",
      "burada",
      "buradan",
      "burası",
      "böyle",
      "böylece",
      "böylecene",
      "böylelikle",
      "böylemesine",
      "böylesine",
      "büsbütün",
      "bütün",
      "cuk",
      "cümlesi",
      "da",
      "daha",
      "dahi",
      "dahil",
      "dahilen",
      "daima",
      "dair",
      "dayanarak",
      "de",
      "defa",
      "dek",
      "demin",
      "demincek",
      "deminden",
      "denli",
      "derakap",
      "derhal",
      "derken",
      "deđil",
      "değil",
      "değin",
      "diye",
      "diđer",
      "diğer",
      "diğeri",
      "doksan",
      "dokuz",
      "dolayı",
      "dolayısıyla",
      "doğru",
      "dört",
      "edecek",
      "eden",
      "ederek",
      "edilecek",
      "ediliyor",
      "edilmesi",
      "ediyor",
      "elbet",
      "elbette",
      "elli",
      "emme",
      "en",
      "enikonu",
      "epey",
      "epeyce",
      "epeyi",
      "esasen",
      "esnasında",
      "etmesi",
      "etraflı",
      "etraflıca",
      "etti",
      "ettiği",
      "ettiğini",
      "evleviyetle",
      "evvel",
      "evvela",
      "evvelce",
      "evvelden",
      "evvelemirde",
      "evveli",
      "eđer",
      "eğer",
      "fakat",
      "filanca",
      "gah",
      "gayet",
      "gayetle",
      "gayri",
      "gayrı",
      "gelgelelim",
      "gene",
      "gerek",
      "gerçi",
      "geçende",
      "geçenlerde",
      "gibi",
      "gibilerden",
      "gibisinden",
      "gine",
      "göre",
      "gırla",
      "hakeza",
      "halbuki",
      "halen",
      "halihazırda",
      "haliyle",
      "handiyse",
      "hangi",
      "hangisi",
      "hani",
      "hariç",
      "hasebiyle",
      "hasılı",
      "hatta",
      "hele",
      "hem",
      "henüz",
      "hep",
      "hepsi",
      "her",
      "herhangi",
      "herkes",
      "herkesin",
      "hiç",
      "hiçbir",
      "hiçbiri",
      "hoş",
      "hulasaten",
      "iken",
      "iki",
      "ila",
      "ile",
      "ilen",
      "ilgili",
      "ilk",
      "illa",
      "illaki",
      "imdi",
      "indinde",
      "inen",
      "insermi",
      "ise",
      "ister",
      "itibaren",
      "itibariyle",
      "itibarıyla",
      "iyi",
      "iyice",
      "iyicene",
      "için",
      "iş",
      "işte",
      "iţte",
      "kadar",
      "kaffesi",
      "kah",
      "kala",
      "kanýmca",
      "karşın",
      "katrilyon",
      "kaynak",
      "kaçı",
      "kelli",
      "kendi",
      "kendilerine",
      "kendini",
      "kendisi",
      "kendisine",
      "kendisini",
      "kere",
      "kez",
      "keza",
      "kezalik",
      "keşke",
      "keţke",
      "ki",
      "kim",
      "kimden",
      "kime",
      "kimi",
      "kimisi",
      "kimse",
      "kimsecik",
      "kimsecikler",
      "külliyen",
      "kýrk",
      "kýsaca",
      "kırk",
      "kısaca",
      "lakin",
      "leh",
      "lütfen",
      "maada",
      "madem",
      "mademki",
      "mamafih",
      "mebni",
      "međer",
      "meğer",
      "meğerki",
      "meğerse",
      "milyar",
      "milyon",
      "mu",
      "mü",
      "mý",
      "mı",
      "nasýl",
      "nasıl",
      "nasılsa",
      "nazaran",
      "naşi",
      "ne",
      "neden",
      "nedeniyle",
      "nedenle",
      "nedense",
      "nerde",
      "nerden",
      "nerdeyse",
      "nere",
      "nerede",
      "nereden",
      "neredeyse",
      "neresi",
      "nereye",
      "netekim",
      "neye",
      "neyi",
      "neyse",
      "nice",
      "nihayet",
      "nihayetinde",
      "nitekim",
      "niye",
      "niçin",
      "o",
      "olan",
      "olarak",
      "oldu",
      "olduklarını",
      "oldukça",
      "olduğu",
      "olduğunu",
      "olmadı",
      "olmadığı",
      "olmak",
      "olması",
      "olmayan",
      "olmaz",
      "olsa",
      "olsun",
      "olup",
      "olur",
      "olursa",
      "oluyor",
      "on",
      "ona",
      "onca",
      "onculayın",
      "onda",
      "ondan",
      "onlar",
      "onlardan",
      "onlari",
      "onlarýn",
      "onları",
      "onların",
      "onu",
      "onun",
      "oracık",
      "oracıkta",
      "orada",
      "oradan",
      "oranca",
      "oranla",
      "oraya",
      "otuz",
      "oysa",
      "oysaki",
      "pek",
      "pekala",
      "peki",
      "pekçe",
      "peyderpey",
      "rağmen",
      "sadece",
      "sahi",
      "sahiden",
      "sana",
      "sanki",
      "sekiz",
      "seksen",
      "sen",
      "senden",
      "seni",
      "senin",
      "siz",
      "sizden",
      "sizi",
      "sizin",
      "sonra",
      "sonradan",
      "sonraları",
      "sonunda",
      "tabii",
      "tam",
      "tamam",
      "tamamen",
      "tamamıyla",
      "tarafından",
      "tek",
      "trilyon",
      "tüm",
      "var",
      "vardı",
      "vasıtasıyla",
      "ve",
      "velev",
      "velhasıl",
      "velhasılıkelam",
      "veya",
      "veyahut",
      "ya",
      "yahut",
      "yakinen",
      "yakında",
      "yakından",
      "yakınlarda",
      "yalnız",
      "yalnızca",
      "yani",
      "yapacak",
      "yapmak",
      "yaptı",
      "yaptıkları",
      "yaptığı",
      "yaptığını",
      "yapılan",
      "yapılması",
      "yapıyor",
      "yedi",
      "yeniden",
      "yenilerde",
      "yerine",
      "yetmiþ",
      "yetmiş",
      "yetmiţ",
      "yine",
      "yirmi",
      "yok",
      "yoksa",
      "yoluyla",
      "yüz",
      "yüzünden",
      "zarfında",
      "zaten",
      "zati",
      "zira",
      "çabuk",
      "çabukça",
      "çeşitli",
      "çok",
      "çokları",
      "çoklarınca",
      "çokluk",
      "çoklukla",
      "çokça",
      "çoğu",
      "çoğun",
      "çoğunca",
      "çoğunlukla",
      "çünkü",
      "öbür",
      "öbürkü",
      "öbürü",
      "önce",
      "önceden",
      "önceleri",
      "öncelikle",
      "öteki",
      "ötekisi",
      "öyle",
      "öylece",
      "öylelikle",
      "öylemesine",
      "öz",
      "üzere",
      "üç",
      "þey",
      "þeyden",
      "þeyi",
      "þeyler",
      "þu",
      "þuna",
      "þunda",
      "þundan",
      "þunu",
      "şayet",
      "şey",
      "şeyden",
      "şeyi",
      "şeyler",
      "şu",
      "şuna",
      "şuncacık",
      "şunda",
      "şundan",
      "şunlar",
      "şunları",
      "şunu",
      "şunun",
      "şura",
      "şuracık",
      "şuracıkta",
      "şurası",
      "şöyle",
      "ţayet",
      "ţimdi",
      "ţu",
      "ţöyle"
    };
  }
}

class Ukrainian implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "але",
      "ви",
      "вона",
      "вони",
      "воно",
      "він",
      "в╡д",
      "з",
      "й",
      "коли",
      "ми",
      "нам",
      "про",
      "та",
      "ти",
      "хоча",
      "це",
      "цей",
      "чи",
      "чого",
      "що",
      "як",
      "яко╞",
      "із",
      "інших",
      "╙",
      "╞х",
      "╡"
    };
  }
}

class Urdu implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "آئی",
      "آئے",
      "آج",
      "آخر",
      "آخرکبر",
      "آدهی",
      "آًب",
      "آٹھ",
      "آیب",
      "اة",
      "اخبزت",
      "اختتبم",
      "ادھر",
      "ارد",
      "اردگرد",
      "ارکبى",
      "اش",
      "اضتعوبل",
      "اضتعوبلات",
      "اضطرذ",
      "اضکب",
      "اضکی",
      "اضکے",
      "اطراف",
      "اغیب",
      "افراد",
      "الگ",
      "اور",
      "اوًچب",
      "اوًچبئی",
      "اوًچی",
      "اوًچے",
      "اى",
      "اً",
      "اًذر",
      "اًہیں",
      "اٹھبًب",
      "اپٌب",
      "اپٌے",
      "اچھب",
      "اچھی",
      "اچھے",
      "اکثر",
      "اکٹھب",
      "اکٹھی",
      "اکٹھے",
      "اکیلا",
      "اکیلی",
      "اکیلے",
      "اگرچہ",
      "اہن",
      "ایطے",
      "ایک",
      "ب",
      "ت",
      "تبزٍ",
      "تت",
      "تر",
      "ترتیت",
      "تریي",
      "تعذاد",
      "تن",
      "تو",
      "توبم",
      "توہی",
      "توہیں",
      "تٌہب",
      "تک",
      "تھب",
      "تھوڑا",
      "تھوڑی",
      "تھوڑے",
      "تھی",
      "تھے",
      "تیي",
      "ثب",
      "ثبئیں",
      "ثبترتیت",
      "ثبری",
      "ثبرے",
      "ثبعث",
      "ثبلا",
      "ثبلترتیت",
      "ثبہر",
      "ثدبئے",
      "ثرآں",
      "ثراں",
      "ثرش",
      "ثعذ",
      "ثغیر",
      "ثلٌذ",
      "ثلٌذوثبلا",
      "ثلکہ",
      "ثي",
      "ثٌب",
      "ثٌبرہب",
      "ثٌبرہی",
      "ثٌبرہے",
      "ثٌبًب",
      "ثٌذ",
      "ثٌذکرو",
      "ثٌذکرًب",
      "ثٌذی",
      "ثڑا",
      "ثڑوں",
      "ثڑی",
      "ثڑے",
      "ثھر",
      "ثھرا",
      "ثھراہوا",
      "ثھرپور",
      "ثھی",
      "ثہت",
      "ثہتر",
      "ثہتری",
      "ثہتریي",
      "ثیچ",
      "ج",
      "خب",
      "خبرہب",
      "خبرہی",
      "خبرہے",
      "خبهوظ",
      "خبًب",
      "خبًتب",
      "خبًتی",
      "خبًتے",
      "خبًٌب",
      "خت",
      "ختن",
      "خجکہ",
      "خص",
      "خططرذ",
      "خلذی",
      "خو",
      "خواى",
      "خوًہی",
      "خوکہ",
      "خٌبة",
      "خگہ",
      "خگہوں",
      "خگہیں",
      "خیطب",
      "خیطبکہ",
      "در",
      "درخبت",
      "درخہ",
      "درخے",
      "درزقیقت",
      "درضت",
      "دش",
      "دفعہ",
      "دلچطپ",
      "دلچطپی",
      "دلچطپیبں",
      "دو",
      "دور",
      "دوراى",
      "دوضرا",
      "دوضروں",
      "دوضری",
      "دوضرے",
      "دوًوں",
      "دکھبئیں",
      "دکھبتب",
      "دکھبتی",
      "دکھبتے",
      "دکھبو",
      "دکھبًب",
      "دکھبیب",
      "دی",
      "دیب",
      "دیتب",
      "دیتی",
      "دیتے",
      "دیر",
      "دیٌب",
      "دیکھو",
      "دیکھٌب",
      "دیکھی",
      "دیکھیں",
      "دے",
      "ر",
      "راضتوں",
      "راضتہ",
      "راضتے",
      "رریعہ",
      "رریعے",
      "رکي",
      "رکھ",
      "رکھب",
      "رکھتب",
      "رکھتبہوں",
      "رکھتی",
      "رکھتے",
      "رکھی",
      "رکھے",
      "رہب",
      "رہی",
      "رہے",
      "ز",
      "زبصل",
      "زبضر",
      "زبل",
      "زبلات",
      "زبلیہ",
      "زصوں",
      "زصہ",
      "زصے",
      "زقبئق",
      "زقیتیں",
      "زقیقت",
      "زکن",
      "زکویہ",
      "زیبدٍ",
      "صبف",
      "صسیر",
      "صفر",
      "صورت",
      "صورتسبل",
      "صورتوں",
      "صورتیں",
      "ض",
      "ضبت",
      "ضبتھ",
      "ضبدٍ",
      "ضبرا",
      "ضبرے",
      "ضبل",
      "ضبلوں",
      "ضت",
      "ضرور",
      "ضرورت",
      "ضروری",
      "ضلطلہ",
      "ضوچ",
      "ضوچب",
      "ضوچتب",
      "ضوچتی",
      "ضوچتے",
      "ضوچو",
      "ضوچٌب",
      "ضوچی",
      "ضوچیں",
      "ضکب",
      "ضکتب",
      "ضکتی",
      "ضکتے",
      "ضکٌب",
      "ضکی",
      "ضکے",
      "ضیذھب",
      "ضیذھی",
      "ضیذھے",
      "ضیکٌڈ",
      "ضے",
      "طرف",
      "طریق",
      "طریقوں",
      "طریقہ",
      "طریقے",
      "طور",
      "طورپر",
      "ظبہر",
      "ع",
      "عذد",
      "عظین",
      "علاقوں",
      "علاقہ",
      "علاقے",
      "علاوٍ",
      "عووهی",
      "غبیذ",
      "غخص",
      "غذ",
      "غروع",
      "غروعبت",
      "غے",
      "فرد",
      "فی",
      "ق",
      "قجل",
      "قجیلہ",
      "قطن",
      "لئے",
      "لا",
      "لازهی",
      "لو",
      "لوجب",
      "لوجی",
      "لوجے",
      "لوسبت",
      "لوسہ",
      "لوگ",
      "لوگوں",
      "لڑکپي",
      "لگتب",
      "لگتی",
      "لگتے",
      "لگٌب",
      "لگی",
      "لگیں",
      "لگے",
      "لی",
      "لیب",
      "لیٌب",
      "لیں",
      "لے",
      "ه",
      "هتعلق",
      "هختلف",
      "هسترم",
      "هسترهہ",
      "هسطوش",
      "هسیذ",
      "هطئلہ",
      "هطئلے",
      "هطبئل",
      "هطتعول",
      "هطلق",
      "هعلوم",
      "هػتول",
      "هلا",
      "هوکي",
      "هوکٌبت",
      "هوکٌہ",
      "هٌبضت",
      "هڑا",
      "هڑًب",
      "هڑے",
      "هکول",
      "هگر",
      "هہرثبى",
      "هیرا",
      "هیری",
      "هیرے",
      "هیں",
      "و",
      "وار",
      "والے",
      "وٍ",
      "ًئی",
      "ًئے",
      "ًب",
      "ًبپطٌذ",
      "ًبگسیر",
      "ًطجت",
      "ًقطہ",
      "ًو",
      "ًوخواى",
      "ًکبلٌب",
      "ًکتہ",
      "ًہ",
      "ًہیں",
      "ًیب",
      "ًے",
      "ٓ آش",
      "ٹھیک",
      "پبئے",
      "پبش",
      "پبًب",
      "پبًچ",
      "پر",
      "پراًب",
      "پطٌذ",
      "پل",
      "پورا",
      "پوچھب",
      "پوچھتب",
      "پوچھتی",
      "پوچھتے",
      "پوچھو",
      "پوچھوں",
      "پوچھٌب",
      "پوچھیں",
      "پچھلا",
      "پھر",
      "پہلا",
      "پہلی",
      "پہلےضی",
      "پہلےضے",
      "پہلےضےہی",
      "پیع",
      "چبر",
      "چبہب",
      "چبہٌب",
      "چبہے",
      "چلا",
      "چلو",
      "چلیں",
      "چلے",
      "چکب",
      "چکی",
      "چکیں",
      "چکے",
      "چھوٹب",
      "چھوٹوں",
      "چھوٹی",
      "چھوٹے",
      "چھہ",
      "چیسیں",
      "ڈھوًڈا",
      "ڈھوًڈلیب",
      "ڈھوًڈو",
      "ڈھوًڈًب",
      "ڈھوًڈی",
      "ڈھوًڈیں",
      "ک",
      "کئی",
      "کئے",
      "کب",
      "کبفی",
      "کبم",
      "کت",
      "کجھی",
      "کرا",
      "کرتب",
      "کرتبہوں",
      "کرتی",
      "کرتے",
      "کرتےہو",
      "کررہب",
      "کررہی",
      "کررہے",
      "کرو",
      "کرًب",
      "کریں",
      "کرے",
      "کطی",
      "کل",
      "کن",
      "کوئی",
      "کوتر",
      "کورا",
      "کوروں",
      "کورٍ",
      "کورے",
      "کوطي",
      "کوى",
      "کوًطب",
      "کوًطی",
      "کوًطے",
      "کھولا",
      "کھولو",
      "کھولٌب",
      "کھولی",
      "کھولیں",
      "کھولے",
      "کہ",
      "کہب",
      "کہتب",
      "کہتی",
      "کہتے",
      "کہو",
      "کہوں",
      "کہٌب",
      "کہی",
      "کہیں",
      "کہے",
      "کی",
      "کیب",
      "کیطب",
      "کیطرف",
      "کیطے",
      "کیلئے",
      "کیوًکہ",
      "کیوں",
      "کیے",
      "کے",
      "کےثعذ",
      "کےرریعے",
      "گئی",
      "گئے",
      "گب",
      "گرد",
      "گروٍ",
      "گروپ",
      "گروہوں",
      "گٌتی",
      "گی",
      "گیب",
      "گے",
      "ہر",
      "ہن",
      "ہو",
      "ہوئی",
      "ہوئے",
      "ہوا",
      "ہوبرا",
      "ہوبری",
      "ہوبرے",
      "ہوتب",
      "ہوتی",
      "ہوتے",
      "ہورہب",
      "ہورہی",
      "ہورہے",
      "ہوضکتب",
      "ہوضکتی",
      "ہوضکتے",
      "ہوًب",
      "ہوًی",
      "ہوًے",
      "ہوچکب",
      "ہوچکی",
      "ہوچکے",
      "ہوگئی",
      "ہوگئے",
      "ہوگیب",
      "ہوں",
      "ہی",
      "ہیں",
      "ہے",
      "ی",
      "یقیٌی",
      "یہ",
      "یہبں"
    };
  }
}

class Vietnamese implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a ha",
      "a-lô",
      "ai",
      "ai ai",
      "ai nấy",
      "alô",
      "amen",
      "anh",
      "bao giờ",
      "bao lâu",
      "bao nhiêu",
      "bao nả",
      "bay biến",
      "biết",
      "biết bao",
      "biết bao nhiêu",
      "biết chừng nào",
      "biết mấy",
      "biết đâu",
      "biết đâu chừng",
      "biết đâu đấy",
      "bà",
      "bài",
      "bác",
      "bây bẩy",
      "bây chừ",
      "bây giờ",
      "bây nhiêu",
      "bèn",
      "béng",
      "bông",
      "bạn",
      "bản",
      "bất chợt",
      "bất cứ",
      "bất giác",
      "bất kì",
      "bất kể",
      "bất kỳ",
      "bất luận",
      "bất nhược",
      "bất quá",
      "bất thình lình",
      "bất tử",
      "bất đồ",
      "bấy",
      "bấy chầy",
      "bấy chừ",
      "bấy giờ",
      "bấy lâu",
      "bấy lâu nay",
      "bấy nay",
      "bấy nhiêu",
      "bập bà bập bõm",
      "bập bõm",
      "bắt đầu từ",
      "bằng",
      "bằng không",
      "bằng nấy",
      "bằng ấy",
      "bển",
      "bệt",
      "bị",
      "bỏ mẹ",
      "bỗng",
      "bỗng chốc",
      "bỗng dưng",
      "bỗng không",
      "bỗng nhiên",
      "bỗng đâu",
      "bộ",
      "bội phần",
      "bớ",
      "bởi",
      "bởi chưng",
      "bởi nhưng",
      "bởi thế",
      "bởi vì",
      "bởi vậy",
      "bức",
      "cao",
      "cha",
      "cha chả",
      "chao ôi",
      "chiếc",
      "cho",
      "cho nên",
      "cho tới",
      "cho tới khi",
      "cho đến",
      "cho đến khi",
      "choa",
      "chu cha",
      "chui cha",
      "chung cục",
      "chung qui",
      "chung quy",
      "chung quy lại",
      "chuyện",
      "chành chạnh",
      "chí chết",
      "chính",
      "chính là",
      "chính thị",
      "chùn chùn",
      "chùn chũn",
      "chú",
      "chú mày",
      "chú mình",
      "chúng mình",
      "chúng ta",
      "chúng tôi",
      "chăn chắn",
      "chăng",
      "chưa",
      "chầm chập",
      "chậc",
      "chắc",
      "chắc hẳn",
      "chẳng lẽ",
      "chẳng những",
      "chẳng nữa",
      "chẳng phải",
      "chết nỗi",
      "chết thật",
      "chết tiệt",
      "chỉ",
      "chỉn",
      "chốc chốc",
      "chớ",
      "chớ chi",
      "chợt",
      "chủn",
      "chứ",
      "chứ lị",
      "coi bộ",
      "coi mòi",
      "con",
      "cu cậu",
      "cuốn",
      "cuộc",
      "càng",
      "các",
      "cái",
      "cây",
      "còn",
      "có",
      "có chăng là",
      "có dễ",
      "có thể",
      "có vẻ",
      "cóc khô",
      "cô",
      "cô mình",
      "công nhiên",
      "cùng",
      "cùng cực",
      "cùng nhau",
      "cùng với",
      "căn",
      "căn cắt",
      "cũng",
      "cũng như",
      "cũng vậy",
      "cũng vậy thôi",
      "cơ",
      "cơ chừng",
      "cơ hồ",
      "cơ mà",
      "cơn",
      "cả",
      "cả thảy",
      "cả thể",
      "cảm ơn",
      "cần",
      "cật lực",
      "cật sức",
      "cậu",
      "cổ lai",
      "của",
      "cứ",
      "cứ việc",
      "cực lực",
      "do",
      "do vì",
      "do vậy",
      "do đó",
      "duy",
      "dào",
      "dì",
      "dù cho",
      "dù rằng",
      "dưới",
      "dạ",
      "dần dà",
      "dần dần",
      "dầu sao",
      "dẫu",
      "dẫu sao",
      "dễ sợ",
      "dễ thường",
      "dở chừng",
      "dữ",
      "em",
      "giữa",
      "gì",
      "hay",
      "hoàn toàn",
      "hoặc",
      "hơn",
      "hầu hết",
      "họ",
      "hỏi",
      "khi",
      "khác",
      "không",
      "luôn",
      "là",
      "làm",
      "lên",
      "lúc",
      "lại",
      "lần",
      "lớn",
      "muốn",
      "mà",
      "mình",
      "mỗi",
      "một",
      "một cách",
      "mới",
      "mợ",
      "ngay",
      "ngay cả",
      "ngay khi",
      "ngay lúc",
      "ngay lập tức",
      "ngay tức khắc",
      "ngay từ",
      "nghe chừng",
      "nghe đâu",
      "nghen",
      "nghiễm nhiên",
      "nghỉm",
      "ngoài",
      "ngoài ra",
      "ngoải",
      "ngày",
      "ngày càng",
      "ngày ngày",
      "ngày xưa",
      "ngày xửa",
      "ngôi",
      "ngõ hầu",
      "ngăn ngắt",
      "ngươi",
      "người",
      "ngọn",
      "ngọt",
      "ngộ nhỡ",
      "nh",
      "nhau",
      "nhiên hậu",
      "nhiều",
      "nhiệt liệt",
      "nhung nhăng",
      "nhà",
      "nhân dịp",
      "nhân tiện",
      "nhé",
      "nhón nhén",
      "như",
      "như chơi",
      "như không",
      "như quả",
      "như thể",
      "như tuồng",
      "như vậy",
      "nhưng",
      "nhưng mà",
      "nhược bằng",
      "nhất",
      "nhất loạt",
      "nhất luật",
      "nhất mực",
      "nhất nhất",
      "nhất quyết",
      "nhất sinh",
      "nhất thiết",
      "nhất tâm",
      "nhất tề",
      "nhất đán",
      "nhất định",
      "nhận",
      "nhỉ",
      "nhỡ ra",
      "những",
      "những ai",
      "những như",
      "nào",
      "này",
      "nên",
      "nên chi",
      "nó",
      "nóc",
      "nói",
      "năm",
      "nơi",
      "nấy",
      "nếu",
      "nếu như",
      "nền",
      "nọ",
      "nớ",
      "nức nở",
      "nữa",
      "oai oái",
      "oái",
      "pho",
      "phè",
      "phóc",
      "phót",
      "phăn phắt",
      "phương chi",
      "phải",
      "phải chi",
      "phải chăng",
      "phắt",
      "phỉ phui",
      "phỏng",
      "phỏng như",
      "phốc",
      "phụt",
      "phứt",
      "qua",
      "qua quít",
      "qua quýt",
      "quyết",
      "quyết nhiên",
      "quyển",
      "quá",
      "quá chừng",
      "quá lắm",
      "quá sá",
      "quá thể",
      "quá trời",
      "quá xá",
      "quá đỗi",
      "quá độ",
      "quá ư",
      "quý hồ",
      "quả",
      "quả là",
      "quả tang",
      "quả thật",
      "quả tình",
      "quả vậy",
      "quả đúng",
      "ra",
      "ra phết",
      "ra sao",
      "ra trò",
      "ren rén",
      "riu ríu",
      "riêng",
      "riệt",
      "rày",
      "ráo",
      "ráo trọi",
      "rén",
      "rích",
      "rón rén",
      "rút cục",
      "răng",
      "rất",
      "rằng",
      "rằng là",
      "rốt cuộc",
      "rốt cục",
      "rồi",
      "rứa",
      "sa sả",
      "sao",
      "sau",
      "sau chót",
      "sau cuối",
      "sau cùng",
      "sau đó",
      "so",
      "song le",
      "suýt",
      "sì",
      "sạch",
      "sất",
      "sắp",
      "sẽ",
      "số",
      "số là",
      "sốt sột",
      "sở dĩ",
      "sự",
      "tanh",
      "tha hồ",
      "than ôi",
      "thanh",
      "theo",
      "thi thoảng",
      "thoạt",
      "thoạt nhiên",
      "thoắt",
      "thuần",
      "thà",
      "thà là",
      "thà rằng",
      "thành ra",
      "thành thử",
      "thái quá",
      "tháng",
      "thì",
      "thì thôi",
      "thình lình",
      "thím",
      "thôi",
      "thúng thắng",
      "thương ôi",
      "thường",
      "thảo hèn",
      "thảo nào",
      "thấy",
      "thẩy",
      "thậm",
      "thậm chí",
      "thật lực",
      "thật ra",
      "thật vậy",
      "thế",
      "thế là",
      "thế mà",
      "thế nào",
      "thế nên",
      "thế ra",
      "thế thì",
      "thế à",
      "thếch",
      "thỉnh thoảng",
      "thỏm",
      "thốc",
      "thốc tháo",
      "thốt",
      "thốt nhiên",
      "thộc",
      "thời gian",
      "thục mạng",
      "thửa",
      "thực ra",
      "thực sự",
      "thực vậy",
      "tiếp theo",
      "tiếp đó",
      "tiện thể",
      "toà",
      "toé khói",
      "toẹt",
      "trong",
      "trên",
      "trước",
      "trước kia",
      "trước nay",
      "trước tiên",
      "trước đây",
      "trước đó",
      "trếu tráo",
      "trển",
      "trệt",
      "trệu trạo",
      "trỏng",
      "trời đất ơi",
      "trừ phi",
      "tuy",
      "tuy nhiên",
      "tuy rằng",
      "tuy thế",
      "tuy vậy",
      "tuyệt nhiên",
      "tuần tự",
      "tuốt luốt",
      "tuốt tuồn tuột",
      "tuốt tuột",
      "tà tà",
      "tênh",
      "tít mù",
      "tò te",
      "tôi",
      "tông tốc",
      "tù tì",
      "tăm tắp",
      "tại",
      "tại vì",
      "tấm",
      "tấn",
      "tất cả",
      "tất thảy",
      "tất tần tật",
      "tất tật",
      "tắp",
      "tắp lự",
      "tọt",
      "tỏ ra",
      "tỏ vẻ",
      "tốc tả",
      "tối ư",
      "tột",
      "tớ",
      "tới",
      "tức thì",
      "tức tốc",
      "từ",
      "từng",
      "tự vì",
      "tựu trung",
      "veo",
      "veo veo",
      "việc",
      "vung thiên địa",
      "vung tàn tán",
      "vung tán tàn",
      "và",
      "vào",
      "vâng",
      "vèo",
      "vì",
      "vì chưng",
      "vì thế",
      "vì vậy",
      "ví bằng",
      "ví dù",
      "ví phỏng",
      "ví thử",
      "vô hình trung",
      "vô kể",
      "vô luận",
      "vô vàn",
      "văng tê",
      "vạn nhất",
      "vả chăng",
      "vả lại",
      "vẫn",
      "vậy",
      "vậy là",
      "vậy thì",
      "về",
      "vị tất",
      "vốn dĩ",
      "với",
      "với lại",
      "vở",
      "vụt",
      "vừa",
      "vừa mới",
      "xa xả",
      "xiết bao",
      "xon xón",
      "xoành xoạch",
      "xoét",
      "xoẳn",
      "xoẹt",
      "xuất kì bất ý",
      "xuất kỳ bất ý",
      "xuể",
      "xuống",
      "xăm xúi",
      "xăm xăm",
      "xăm xắm",
      "xềnh xệch",
      "xệp",
      "à",
      "à ơi",
      "ào",
      "á",
      "á à",
      "ái",
      "ái chà",
      "ái dà",
      "áng",
      "âu là",
      "ô hay",
      "ô hô",
      "ô kê",
      "ô kìa",
      "ôi chao",
      "ôi thôi",
      "ông",
      "úi",
      "úi chà",
      "úi dào",
      "ý",
      "ý chừng",
      "ý da",
      "đang",
      "đi",
      "điều",
      "đành đạch",
      "đáng lí",
      "đáng lý",
      "đáng lẽ",
      "đánh đùng",
      "đáo để",
      "đây",
      "đã",
      "đó",
      "được",
      "đại loại",
      "đại nhân",
      "đại phàm",
      "đại để",
      "đến",
      "đến nỗi",
      "đều",
      "để",
      "ơ",
      "ơ hay",
      "ơ kìa",
      "ơi",
      "ư",
      "ạ",
      "ạ ơi",
      "ấy",
      "ầu ơ",
      "ắt",
      "ắt hẳn",
      "ắt là",
      "ối dào",
      "ối giời",
      "ối giời ơi",
      "ồ",
      "ổng",
      "ớ",
      "ờ",
      "ở",
      "ở trên",
      "ủa",
      "ứ hự",
      "ứ ừ",
      "ừ",
      "ử"
    };
  }
}

class Yoruba implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "a",
      "an",
      "bá",
      "bí",
      "bẹ̀rẹ̀",
      "fún",
      "fẹ́",
      "gbogbo",
      "inú",
      "jù",
      "jẹ",
      "jẹ́",
      "kan",
      "kì",
      "kí",
      "kò",
      "láti",
      "lè",
      "lọ",
      "mi",
      "mo",
      "máa",
      "mọ̀",
      "ni",
      "náà",
      "ní",
      "nígbà",
      "nítorí",
      "nǹkan",
      "o",
      "padà",
      "pé",
      "púpọ̀",
      "pẹ̀lú",
      "rẹ̀",
      "sì",
      "sí",
      "sínú",
      "ṣ",
      "ti",
      "tí",
      "wà",
      "wá",
      "wọn",
      "wọ́n",
      "yìí",
      "àti",
      "àwọn",
      "é",
      "í",
      "òun",
      "ó",
      "ń",
      "ńlá",
      "ṣe",
      "ṣé",
      "ṣùgbọ́n",
      "ẹmọ́",
      "ọjọ́",
      "ọ̀pọ̀lọpọ̀"
    };
  }
}

class Zulu implements Language {
  @override
  Set<String> stopWords() {
    return <String>{
      "futhi",
      "kahle",
      "kakhulu",
      "kanye",
      "khona",
      "kodwa",
      "kungani",
      "kusho",
      "la",
      "lakhe",
      "lapho",
      "mina",
      "ngesikhathi",
      "nje",
      "phansi",
      "phezulu",
      "u",
      "ukuba",
      "ukuthi",
      "ukuze",
      "uma",
      "wahamba",
      "wakhe",
      "wami",
      "wase",
      "wathi",
      "yakhe",
      "zakhe",
      "zonke"
    };
  }
}
